2023-07-18  Bruno Haible  <bruno@clisp.org>

	Fix a typo in an error message string.
	Reported by Christian Wiatr <w9204-fs@yahoo.com>.
	* defstruct.lisp (defstruct): Fix error message string.

2023-07-15  Bruno Haible  <bruno@clisp.org>

	Fix a typo in an error message string.
	Reported by Christian Wiatr <w9204-fs@yahoo.com>.
	* io.d (structure_reader): Fix error message string.

2023-06-29  Bruno Haible  <bruno@clisp.org>

	Update the installation instructions for Windows.
	* INSTALL.windows: Add a note about MSYS2.

2023-01-12  Bruno Haible  <bruno@clisp.org>

	Allow non-simple strings in FORMAT and FORMATTER.
	Reported by Vibhu Mohindra in
	<https://gitlab.com/gnu-clisp/clisp/-/issues/37>.
	* format.lisp (format-parse-cs): Use CHAR instead of SCHAR.

2023-01-12  Bruno Haible  <bruno@clisp.org>

	syscalls: Fix buffer overflow.
	Reported by Jerry James <loganjerry@gmail.com>
	in <https://gitlab.com/gnu-clisp/clisp/-/merge_requests/4>.
	* modules/syscalls/calls.c (ENSURE_6X): Allocate one more byte.

2022-12-28  Bruno Haible  <bruno@clisp.org>

	Fix error when passing arguments with spaces to configure on Solaris 11.
	* configure: Use "$@" instead of $*, to avoid splitting arguments that
	contain spaces, e.g. "CPPFLAGS=-I/some/dir -Wall".

2022-10-21  Bruno Haible  <bruno@clisp.org>

	Fix a buffer overflow.
	Reported by marxin at <https://gitlab.com/gnu-clisp/clisp/-/issues/33>.
	* spvw_memfile.d (memfile_do_operation): Allocate one more byte for
	filename_mem.

2022-09-26  Bruno Haible  <bruno@clisp.org>

	Recommend libsigsegv 2.14.
	* configure (libsigsegv_url): Update to 2.14.
	* INSTALL.windows: 64-bit Cygwin is now fully supported.

2022-09-25  Bruno Haible  <bruno@clisp.org>

	Fix a build error on Cygwin.
	Reported by Vibhu Mohindra <vibs29@hotmail.com>.
	* unix.d (CR): Push macro definition aside while including <windows.h>.

2021-06-28  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on macOS/arm64.
	* Makefile.devel (multibuild-macosx-arm64): Enable all build variants.
	* makemake.in (XCFLAGS): For macOS/arm64, enable all optimizations.
	* lispbibl.d: Add definitions for UNIX_MACOSX && ARM64.

2020-06-22  Bruno Haible  <bruno@clisp.org>

	Fix a build error on Cygwin in C++ mode.
	* unix.d (waitpid): Don't redeclare on Cygwin.

2020-06-22  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Cygwin/x86_64.
	* Makefile.devel (multibuild-cygwin-64): Enable all build variants that
	work.
	* makemake.in (XCFLAGS): For Cygwin/x86_64, enable all optimizations
	except ASM.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* modules/clx/new-clx/configure.in: Don't invoke AC_HEADER_TIME.
	* modules/clx/new-clx/configure, modules/clx/new-clx/config.h.in:
	Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* m4/ln.m4 (CL_PROG_HLN): Use AS_MESSAGE_LOG_FD instead of AC_FD_CC.
	* aclocal.m4: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* src/configure.in: Invoke AC_FUNC_FORK instead of AC_FUNC_VFORK.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* m4/param.m4 (CL_MACHINE): Use ac_cv_c_compiler_gnu instead of
	ac_cv_prog_gcc.
	* aclocal.m4: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* src/configure.in: Use LT_INIT instead of libtool 1.x macro names.
	* src/configure: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* m4/intparam.m4 (CL_INTPARAM_CROSS, CL_INTPARAM_SIZEOF): Use
	AC_COMPUTE_INT instead of _AC_COMPUTE_INT.
	* aclocal.m4: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* m4/general.m4 (CL_MODULE_COMMON_CHECKS): Don't require AC_GNU_SOURCE,
	since it is redundant with AC_USE_SYSTEM_EXTENSIONS.
	* aclocal.m4, src/configure: Regenerated.
	* modules/*/configure: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Avoid warnings from autoconf-2.71.
	* m4/ioctl.m4, m4/mmap.m4, m4/mprotect.m4, m4/poll.m4, m4/proto.m4,
	m4/select.m4, m4/signal.m4: Use AC_*_IFELSE macros instead of AC_TRY_*
	macros.
	* modules/syscalls/configure.in: Likewise.
	* aclocal.m4, src/configure: Regenerated.
	* modules/*/configure: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Switch to autoconf-2.71.
	* m4/clisp.m4 (CL_DECOLONIZE, CL_CLISP): Expand into the initialization
	portion of the configure script. This is needed after this change in
	Autoconf:
	https://git.savannah.gnu.org/gitweb/?p=autoconf.git;a=commitdiff;h=4c59bf27d7083088290219450c81d999431b43f1
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Use newest libffcall.
	* m4/ffcall.m4 (CL_LIBFFCALL_DOWNLOAD_URL): Point to the libffcall-2.4
	release.
	* aclocal.m4, src/configure: Regenerated.

2021-06-27  Bruno Haible  <bruno@clisp.org>

	Update after Sam removed clhs.el.
	* makemake.in (EMACS_FILES): Remove clhs.el.

2020-12-01  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* build-aux/*: Update from gnulib and upstream.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.

2020-12-01  Bruno Haible  <bruno@clisp.org>

	Bump minimum Autoconf version, for compatibility with gnulib.
	* configure.in: AC_PREREQ version 2.64.
	* modules/*/configure.in: Likewise.

2020-06-21  Bruno Haible  <bruno@clisp.org>

	Fix a build error on mingw.
	* _clisp.c: Include w32shell.c in such a way that it gets found.

2020-06-21  Bruno Haible  <bruno@clisp.org>

	Fix configuration on mingw.
	* m4/address.m4 (CL_ADDRESS_RANGE): Write conftest.h with Unix newlines.
	* m4/filecharset.m4 (CL_FILECHARSET): Write conftest.out with Unix
	newlines.
	* m4/tcpconn.m4 (CL_TCPCONN): Don't check for the setsockopt() prototype
	on native Windows. The parameter macros are defined in win32.d instead.

2020-06-21  Bruno Haible  <bruno@clisp.org>

	Make the DISASSEMBLE command for machine code work again.
	* disassem.lisp (disassemble-machine-code): Allow spaces at the
	beginning of disassembly lines. Hide the output of the attach command.
	Prefer the 'less' program to the 'more' program when it exists.

2020-06-21  Bruno Haible  <bruno@clisp.org>

	Fix a "make install" failure on Solaris.
	* makemake.in (installdirs, install-bin): Put symlinks in
	$(prefix)/share/locale, not $(prefix)/locale. Make sure this directory
	exists.

2020-06-21  Bruno Haible  <bruno@clisp.org>

	Fix test failures on FreeBSD 12.
	* spvw_language.d (init_language): Try locale names with suffix
	".UTF-8", not ".utf8".

2020-06-21  Bruno Haible  <bruno@clisp.org>

	Fix portability problems in SOCKET-CONNECT with :TIMEOUT 0.
	Reported at <https://gitlab.com/gnu-clisp/clisp/-/issues/25>.
	* socket.d (connect_via_ip): Don't wait if no timeout was given. Don't
	special-case timeout == 0.
	* stream.d (SOCKET-CONNECT): Map a zero timeout to 1 ms.

2020-06-21  Bruno Haible  <bruno@clisp.org>

	New functions EXT:OPERATING-SYSTEM-TYPE, EXT:OPERATING-SYSTEM-VERSION.
	* constobj.d (O(operating_system_type_string),
	O(operating_system_version_string)): New.
	* misc.d (EXT:OPERATING-SYSTEM-TYPE, EXT:OPERATING-SYSTEM-VERSION): New.
	* init.lisp (operating-system-type, operating-system-version): Export
	from package EXT.

2020-06-20  Bruno Haible  <bruno@clisp.org>

	Put client socket into blocking mode always.
	* socket.d (connect_via_ip): When a timeout was specified and connect()
	succeeded, put the file descriptor back into blocking mode.

2020-06-12  Bruno Haible  <bruno@clisp.org>

	Use realpath from libc when possible.
	This fixes a mistake from 2017-10-24.
	* pathname.d (realpath, realpath_is_my_realpath): Fix condition.

2020-06-12  Bruno Haible  <bruno@clisp.org>

	Fix (sys::program-name) result on Cygwin.
	* pathname.d (my_realpath) [UNIX_CYGWIN]: Don't return NULL in most
	cases.

2019-11-03  Bruno Haible  <bruno@clisp.org>

	Avoid 'makemake' error on macOS.
	Reported by Roland Illig <roland.illig@gmx.de>
	in <https://sourceforge.net/p/clisp/bugs/740/>.
	* makemake.in: Add spaces to avoid misinterpretation of ((arch...
	commands.

2019-06-29  Bruno Haible  <bruno@clisp.org>

	Make it possible to use DEFSETF expanders with computed keywords.
	Reported by Kaz Kylheku <kaz@kylheku.com>
	in <https://sourceforge.net/p/clisp/mailman/message/36601264/>.
	* functions.lisp (function-info): New function, extracted from
	function-signature.
	* compiler.lisp (function-signature): Invoke function-info.
	* places.lisp (define-setf-expander): Store on the property list also a
	function that returns the keyword initforms.
	(get-setf-expansion): Handle the case of a DEFSETF long form with
	keyword arguments, including the case when the keywords are not known at
	macroexpansion time.

2019-06-28  Bruno Haible  <bruno@clisp.org>

	Fix typos in message strings.
	* spvw_language.d: Fix typo in message.
	* control.d: Likewise.
	* hashtabl.d: Likewise.

2019-06-28  Bruno Haible  <bruno@clisp.org>

	INSTALL.windows: Modernize URLs.
	* INSTALL.windows: Prefer https over http URLs.

2018-11-11  Bruno Haible  <bruno@clisp.org>

	Add comments.
	* macros2.lisp (WITH-OPEN-FILE, WITH-OPEN-STREAM): Add comments.

2018-11-11  Bruno Haible  <bruno@clisp.org>

	Fix a compiler bug that could lead to a "Compiler bug!!" error.
	Reported by Paul F. Dietz
	at <https://gitlab.com/gnu-clisp/clisp/issues/14>.
	* compiler.lisp: Fix comments about CALL1 and CALL2.
	(for-value-table): Change classification of CALL1 and CALL2.

2018-09-22  Bruno Haible  <bruno@clisp.org>

	Fix problem with non-ASCII characters in file names on Windows.
	Reported by Ulrike Fischer
	at <https://gitlab.com/gnu-clisp/clisp/issues/10>.
	* m4/filecharset.m4 (CL_FILECHARSET): Test only the ASCII character
	range.
	* pathname.d (legal_namebyte): Return true for all non-ASCII bytes.
	Hardcode known expressions for Unix and Windows.
	* src/aclocal.m4, src/configure: Regenerated.

2018-07-18  Bruno Haible  <bruno@clisp.org>

	Fix the macroexpander of MULTIPLE-VALUE-SETQ.
	Reported by Charles Zhang
	at <https://gitlab.com/gnu-clisp/clisp/issues/6>.
	* macros1.lisp (multiple-value-setq): Treat case of no variables
	specially.

2018-06-24  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (check_gdbm_errno): Update to gdbm 1.15.

2018-04-23  Sam Steingold  <sds@gnu.org>

	* makemake.in (MYIMPROOT): Set to gnu.org to work around the lack
	of HTTPS support in CLISP.

2018-04-23  Bruno Haible  <bruno@clisp.org>

	Update URLs.
	* makemake.in (cygwin.README): Update URL to libsigsegv home page.

2018-04-22  Bruno Haible  <bruno@clisp.org>

	Add support for Linux/riscv64.
	* m4/mmap.m4 (CL_MMAP): Avoid crash on Linux/riscv64.
	* aclocal.m4, src/configure: Regenerated.
	* lispbibl.d (RISCV64): New macro.
	(C_CODE_ALIGNMENT, intDsize, MAPPABLE_ADDRESS_RANGE_*, SP_register,
	ASM_get_SP_register, SP_DOWN): Define for Linux/riscv64.
	* Makefile.devel (multibuild-linux-riscv64): New target.
	* makemake.in (XCFLAGS): For Linux/riscv64, enable all optimizations
	except ASM.
	Reduce optimization when compiling hashtabl.c.

2018-04-22  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.

2018-04-22  Bruno Haible  <bruno@clisp.org>

	Switch to automake 1.16.1.
	* Makefile.devel (AUTOMAKE_VERSION): Set to 1.16.1.
	* build-aux/*: Updated.
	* m4/gtk-*.m4: Updated.

2018-04-22  Bruno Haible  <bruno@clisp.org>

	More hg to git changes.
	* Makefile.devel (EXCLUDE): Exclude .git, not .hg.
	* src/configure.in: Remove AC_REVISION invocation.
	* src/makemake.in (check-doc): Test for .git, not .hg.
	* utils/modprep.lisp: Update comment.

2018-04-22  Bruno Haible  <bruno@clisp.org>

	Assume a git checkout instead of a hg checkout.
	* Makefile.devel (GIT): New variable.
	(HG): Remove variable.
	(gnulib-imported, tag-release): Use GIT instead of HG.

2018-04-08  Bruno Haible  <bruno@clisp.org>

	Fix possible build failure on some Linux/powerpc machines.
	Reported by Johannes Hielscher <jhielscher@posteo.de>.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_END) [UNIX_LINUX && POWERPC]:
	Shrink.

2018-02-24  Bruno Haible  <bruno@clisp.org>

	Fix memory map related warnings on Alpine Linux 3.7/i386.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_*) [UNIX_LINUX && I80386]: Shrink,
	to avoid the address ranges used on Alpine Linux.

2018-02-24  Bruno Haible  <bruno@clisp.org>

	Fix memory map related warnings on Alpine Linux 3.7/x86_64.
	Reported by Nelson Beebe.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_*) [UNIX_LINUX && AMD64]: Shrink,
	to avoid the address ranges used on Alpine Linux.

2018-02-24  Bruno Haible  <bruno@clisp.org>

	Fix compilation error in C++ mode with musl libc.
	* spvw_mmap.d (mincore_pageinfo_t): Change to 'unsigned char' on all
	Linux platforms.

2018-02-19  Sam Steingold  <sds@gnu.org>

	* constobj.d (lisp_implementation_version_built_string): No need
	for "#ifdef __DATE__", it is widely supported.

2018-02-18  Bruno Haible  <bruno@clisp.org>

	Bump version number.
	* version.sh: Bump version number to 2.49.93+.
	* version.h, src/configure: Regenerated.

2018-02-18  Bruno Haible  <bruno@clisp.org>

	Avoid "warning: command substitution: ignored null byte in input".
	Reported by Nelson Beebe.
	* m4/bold.m4 (RSE_BOLD): For vt100, remove trailing NUL bytes. Only
	physical terminals need these NULs; physical terminals are not in use
	any more nowadays.
	* aclocal.m4, src/configure, modules/*/configure: Regenerated.

2018-02-18  Bruno Haible  <bruno@clisp.org>

	Improve installation documentation.
	Reported by Nelson Beebe.
	* DEPENDENCIES: State which libsigsegv version to use on IRIX.

2018-02-18  Bruno Haible  <bruno@clisp.org>

	Make KERNELVOID32_HEAPCODES work on Linux/arm, Linux/hppa, Linux/m68k.
	Reported by Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (KERNELVOID32A_HEAPCODES/KERNELVOID32B_HEAPCODES):
	If STACK_ADDRESS_RANGE >= 0xE0000000, use KERNELVOID32A_HEAPCODES, not
	KERNELVOID32B_HEAPCODES.
	(KERNELVOID32_HEAPCODES_WORKS): Set to 1 for Linux/hppa, Linux/m68k.
	(ONE_FREE_BIT_HEAPCODES/KERNELVOID32_HEAPCODES): Remove special handling
	of Linux/hppa and Linux/m68k.
	* Makefile.devel (multibuild-linux-hppa, multibuild-linux-m68k): Depend
	on build-porting32-gcc-kernelvoid32_heapcodes.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix a build failure on some Linux/arm machines.
	Namely, a "PSEUDOCODE_ALIGNMENT is not fulfilled" error.
	* lispbibl.d (C_CODE_ALIGNMENT) [ARM]: Define depending on __thumb__.
	(TYPECODES/HEAPCODES): Likewise.
	* makemake.in (XCFLAGS): On ARM, use GCC option '-marm', not
	'-falign-functions=4', in order to enforce C_CODE_ALIGNMENT == 4.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Comments.
	* lispbibl.d: Improve comments about memory map on Hurd/i386.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix possible build failure on some Linux/sparc64 machines.
	* lispbibl.d (CODE_ADDRESS_RANGE): Ensure the same value across all
	Linux/sparc64 systems.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix possible build failure on some Linux/s390x machines.
	* lispbibl.d (CODE_ADDRESS_RANGE): Ensure the same value across all
	Linux/s390x systems.
	(MAPPABLE_ADDRESS_RANGE_*) [UNIX_LINUX && S390_64]: Change.
	(SINGLEMAP_TYPE_MASK, SINGLEMAP_oint_type_shift): Adjust accordingly.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix possible build failure on some Linux/powerpc64 machines.
	* lispbibl.d (CODE_ADDRESS_RANGE): Ensure the same value across all
	Linux/powerpc64 systems.
	Enhance comments about memory map on Linux/PowerPC64.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/mips64 machines.
	Reported by Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (CODE_ADDRESS_RANGE): Ensure the same value across all
	Linux/mips64 systems.
	(MAPPABLE_ADDRESS_RANGE_END) [UNIX_LINUX && MIPS64]: Change.
	(SINGLEMAP_WORKS) [UNIX_LINUX && MIPS64]: Set to 0.
	* Makefile.devel (multibuild-linux-mips-64): Remove
	build-porting64-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/arm64 machines.
	Reported by Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (CODE_ADDRESS_RANGE): Ensure the same value across all
	Linux/arm64 systems.
	(SINGLEMAP_WORKS) [UNIX_LINUX && ARM64]: Set to 0.
	* Makefile.devel (multibuild-linux-arm64): Remove
	build-porting64-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/x86_64 machines (Ubuntu 17.10, Debian).
	Reported by Sam Steingold and Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (CODE_ADDRESS_RANGE): Ensure the same value across all
	Linux/x86_64 systems.
	(MAPPABLE_ADDRESS_RANGE_*, SINGLEMAP_WORKS) [UNIX_LINUX && AMD64]:
	Change.
	* Makefile.devel (multibuild-linux-x86_64): Remove
	build-porting64-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/powerpc machines.
	Reported by Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (CODE_ADDRESS_RANGE, MAPPABLE_ADDRESS_RANGE_START)
	[UNIX_LINUX && POWERPC]: Change.
	(SINGLEMAP_WORKS) [UNIX_LINUX && POWERPC]: Set to 0.
	* Makefile.devel (multibuild-linux-powerpc): Remove
	build-porting32-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/mips machines.
	Reported by Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (CODE_ADDRESS_RANGE, MAPPABLE_ADDRESS_RANGE_END)
	[UNIX_LINUX && MIPS && !n32]: Change.
	(SINGLEMAP_WORKS) [UNIX_LINUX && MIPS && !n32]: Set to 0.
	* Makefile.devel (multibuild-linux-mips-32): Remove
	build-porting32-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/i386 machines.
	Reported by Sébastien Villemot <sebastien@debian.org>.
	* lispbibl.d (CODE_ADDRESS_RANGE, MAPPABLE_ADDRESS_RANGE_START)
	[UNIX_LINUX && I80386]: Change.
	(SINGLEMAP_WORKS) [UNIX_LINUX && I80386]: Set to 0.
	* Makefile.devel (multibuild-linux-i386): Remove
	build-porting32-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on some Linux/arm machines.
	Reported by Dr. Werner Fink <werner@suse.de>.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_*) [UNIX_LINUX && ARM]: Change.
	(SINGLEMAP_WORKS) [UNIX_LINUX && ARM]: Set to 0.
	* Makefile.devel (multibuild-linux-arm): Remove
	build-porting32-gcc-spvw_pure_blocks.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Use newest libffcall.
	* m4/ffcall.m4 (CL_LIBFFCALL_DOWNLOAD_URL): Point to the libffcall-2.1
	release.
	* NEWS: Likewise.
	* aclocal.m4, src/configure: Regenerated.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure when building in the srcdir.
	Reported by Nelson Beebe.
	* makemake.in: When preprocessing the ari_asm_*.c and sp_asm_*.c files
	in the srcdir, omit the '-I' option.

2018-02-17  Bruno Haible  <bruno@clisp.org>

	Fix compilation error in C++ mode (regression from 2018-02-11).
	* spvw.d (output_mfih): Fix array initializer.

2018-02-11  Bruno Haible  <bruno@clisp.org>

	Bump version number.
	* version.sh: Bump version number to 2.49.91+.
	* version.h, src/configure: Regenerated.

2018-02-11  Bruno Haible  <bruno@clisp.org>

	Implement options -memfile-hash, -memfile-hash-of, -memfile-compatible.
	* Makefile.devel (GNULIB_CORE): Add sha1.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* spvw_memfile.d (MFIH_LEN): New macro.
	(memflags): Use bit 22.
	(memdump_header_t): Add '_mfihash' field.
	(get_mem_file_interface_hash): New function.
	(fill_memdump_header): Invoke it.
	(memfile_operation): New enum type.
	(memfile_handle_do_operation): Renamed from loadmem_from_handle, Add op
	and arg arguments. Handle op_extract_mfih and op_test_compatibility as
	well.
	(memfile_do_operation): New function, extracted from loadmem.
	(loadmem): Invoke it.
	(extract_mem_file_interface_hash, is_mem_file_compatible):
	New functions.
	(loadmem_from_executable): Update.
	* spvw.d: Include sha1.h. Move include of spvw_memfile.c up.
	(main_action_t): New enum type.
	(struct argv_actions): Add 'argv_main_action' field.
	(parse_options): Initialize it. Parse the -memfile-hash,
	-memfile-hash-of, -memfile-compatible options.
	(output_mfih): New function.
	(main): Handle action_mfihash, action_mfihash_of, action_mfcompat.

2018-02-11  Bruno Haible  <bruno@clisp.org>

	Simplify code.
	* spvw_memfile.d: Reorder functions, to avoid forward declarations.

2018-02-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on GNU/kFreeBSD/i386.
	* Makefile.devel (multibuild-freebsd-gnu-i386): New target, depending on
	all build variants that work.
	* makemake.in (XCFLAGS): For GNU/kFreeBSD/i386, enable all optimizations
	except ASM.

2018-02-11  Bruno Haible  <bruno@clisp.org>

	Add support for GNU/kFreeBSD on i386.
	* lispbibl.d: Treat GNU/kFreeBSD/i386 like FreeBSD/i386.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on IRIX mips o32.
	* Makefile.devel (multibuild-irix-mips-32): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For IRIX with o32 ABI, enable all optimizations
	except ASM.
	* lispbibl.d (HEAPCODES1BIT_WITH_TRIVIALMAP_WORKS,
	HEAPCODES1BIT_WITH_MALLOC_WORKS): Update value for IRIX with o32 ABI.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Fix error "Expecting o32 objects: ari_asm_mips.o is n32" on IRIX.
	* makemake.in: Compile ari_asm_mips.s with the compiler, not with the
	assembler.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on IRIX mips n32.
	* Makefile.devel (multibuild-irix-mips-n32-cc,
	multibuild-irix-mips-n32-gcc): Enable all build variants that work.
	* makemake.in (XCFLAGS): For IRIX with n32 ABI, enable all optimizations
	except ASM.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Tweak address range allocation with SINGLEMAP_MEMORY on IRIX.
	* spvw.d (init_memory): Avoid a specific address range on IRIX.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	rawsock: Fix compilation failure on IRIX with cc.
	* modules/rawsock/rawsock.c (optional_sockaddr_argument, error_eai):
	Add braces to avoid declaration-after-statement.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Fix configure output on IRIX.
	* configure: Use `...` instead of $(...).

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Minix/i386.
	* Makefile.devel (multibuild-minix-i386): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Minix/i386, enable all optimizations
	except ASM.

2018-02-04  Bruno Haible  <bruno@clisp.org>

	Add support for Minix.
	* lispbibl.d: On Minix, define 'unix' and UNIX_MINIX. Define the
	object representation parameters.
	* stream.d (handle_pathname): On Minix, return NIL.
	* makemake.in (XCFLAGS): Handle Minix.
	On Minix, skip the test of /dev/fd/1.
	* Makefile.devel (multibuild-minix-i386): New target.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Enable one more build variant on HP-UX/HPPA in 64-bit mode.
	* Makefile.devel (multibuild-hpux-hppa-64): Enable also the
	build-porting64-cc-limited_memory build.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Record result for HP-UX/HPPA in 32-bit mode.
	* lispbibl.d (HEAPCODES1BIT_WITH_MALLOC_WORKS): Update value for
	HP-UX/HPPA in 32-bit mode.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Fix a build failure on HP-UX/ia64 in 64-bit mode.
	Namely, "PSEUDOCODE_ALIGNMENT is not fulfilled" error during clisp-link.
	* lispbibl.d (C_CODE_ALIGNMENT): Define to only 8 on 64-bit IA64.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Enable some more build variants on Linux/hppa.
	* lispbibl.d: On Linux/hppa, choose HEAPCODES by default, not
	TYPECODES. But don't choose KERNELVOID32_HEAPCODES by default.
	(HEAPCODES1BIT_WITH_TRIVIALMAP_WORKS, HEAPCODES1BIT_WITH_MALLOC_WORKS):
	Update value for Linux/hppa.
	(multibuild-linux-hppa): Enable the HEAPCODES builds that work.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Make KERNELVOID32_HEAPCODES work also on SPARC platforms with GCC,
	and on Linux/mipsn32 (even with GENERATIONAL_GC).
	* lispbibl.d: On Linux/sparc, NetBSD/sparc, and Linux/mipsn32, prefer
	KERNELVOID32_HEAPCODES over ONE_FREE_BIT_HEAPCODES.
	(KERNELVOID32_HEAPCODES_WORKS): Update values.
	(_attribute_in_misaligned_varobjects_): New macro.
	(dfloatjanus, dfloat_): Use it.
	* stream.d (strm_buffered_extrafields_t,
	strm_i_buffered_extrafields_t): Likewise.
	* dfloat.d (DF_to_double): No need to define as an inline function when
	GCC is in use.
	* Makefile.devel (multibuild-linux-sparc, multibuild-netbsd-sparc,
	multibuild-solaris-sparc-gcc): Depend on
	build-porting32-gcc-kernelvoid32_heapcodes.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Fix crashes due to sp_jmp_buf objects going out of scope too early.
	* stream.d (MAYBE_IGNORE_ERRORS): Extend scope of 'returner'. (Bug
	introduced on 2010-06-15.)
	(lisp_completion): Extend scope of 'returner'. (Bug introduced on
	2001-03-02.)
	* record.d (update_instance): Extend scope of 'returner'. (Bug
	introduced on 2004-04-22.)
	* foreign.d (EXEC-ON-STACK): Extend scope of 'returner'. (Bug
	introduced on 2003-05-03.)

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Fix floatparam.h generation failure with gcc 7 on i386.
	GCC bug report: <https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84190>.
	* floatparam.c (mainfn): Use 'volatile' in a few more places.

2018-02-03  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure: Regenerated.
	* modules/*/configure: Regenerated.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Tweak the usable address range on IRIX.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_END) [UNIX_IRIX]: Change.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix failure of the builds with -DWIDE on IRIX/mips (n32 ABI).
	* makemake.in: When compiling with GCC for IRIX/mipsn32 and -DWIDE,
	reduce optimizations.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	rawsock: Fix compilation error on IRIX.
	The <netinet/in.h> on IRIX 6.5 has only partial support for IPv6.
	* modules/rawsock/rawsock.c (RAWSOCK:CONVERT-ADDRESS): Test HAVE_IPV6,
	not AF_INET6.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	syscalls: Fix a build failure on IRIX 6.5.
	IRIX 6.5 does not have the round() function.
	* modules/syscalls/calls.c (POSIX:LOADAVG): Don't use the round()
	function.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix build failure on IRIX.
	* clisp-link.in: Use placeholder @SHELL@.
	* makemake.in (clisp-link): Substitute a good shell for @SHELL@.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on HP-UX/ia64 in 64-bit mode.
	* Makefile.devel (multibuild-hpux-ia64-64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For HP-UX/ia64 in 64-bit mode, enable all
	optimizations except ASM.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Choose working configuration on HP-UX/ia64 in 64-bit mode.
	* lispbibl.d: On 64-bit HP-UX/ia64, choose HEAPCODES by default, not
	TYPECODES.
	Adjust parameters for HEAPCODES1BIT_WITH_MALLOC on HP-UX/ia64.
	(GENERIC64C_HEAPCODES_WORKS): Update value for HP-UX/ia64.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on HP-UX/ia64 in 32-bit mode.
	* Makefile.devel (multibuild-hpux-ia64-32): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For HP-UX/ia64 in 32-bit mode, enable all
	optimizations except ASM.
	* lispbibl.d (HEAPCODES1BIT_WITH_MALLOC_WORKS): Update value for
	HP-UX/ia64 in 32-bit mode.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on HP-UX/HPPA in 64-bit mode.
	* lispbibl.d: On HP-UX/HPPA in 64-bit mode, choose HEAPCODES by default,
	not TYPECODES.
	(garcol_bit_o): Find appropriate value for HP-UX/HPPA in 64-bit mode.
	(GENERIC64C_HEAPCODES_WORKS): Update value for HP-UX/HPPA in 64-bit
	mode.
	* Makefile.devel (multibuild-hpux-hppa-64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For 64-bit HP-UX/HPPA, enable all
	optimizations except ASM.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on HP-UX/HPPA in 32-bit mode.
	* Makefile.devel (multibuild-hpux-hppa-32): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For 32-bit HP-UX/HPPA, enable all
	optimizations except ASM.
	* lispbibl.d (KERNELVOID32_HEAPCODES_WORKS): Update value for HP-UX HPPA
	in 32-bit mode.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix failure of the builds with TYPECODES on HP-UX with 64-bit HPPA.
	* lispbibl.d (INIT_SYMBOL_TAB): Disable on 64-bit HPPA with HP C and
	TYPECODES.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Avoid crash of KERNELVOID32_HEAPCODES build on HP-UX with 32-bit HPPA.
	* dfloat.d (DF_to_double): Use an inline function to avoid misaligned
	'double' access.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Add support for 32-bit mode on IA64.
	* lispbibl.d (C_CODE_ALIGNMENT): Define to only 8 on 32-bit IA64.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Add support for 64-bit mode on HPPA.
	* lispbibl.d (C_CODE_ALIGNMENT, C_FUNCTION_POINTER_BIAS,
	PSEUDOCODE_ALIGNMENT, make_machine_code_unchecked, TheMachineCode):
	Distinguish 32-bit and 64-bit HPPA cases.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix PSEUDOCODE_ALIGNMENT verification on HP-UX with 32-bit HPPA.
	* lispbibl.d (C_FUNCTION_POINTER_BIAS): New macro.
	(make_machine_code, TheMachineCode): Use it.
	* spvw.d (verify_pseudocode_alignment): Likewise.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Don't let DISASSEMBLE on HP-UX kill the current process.
	* disassem.lisp (disassemble-machine-code): Don't invoke gdb on HP-UX.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Don't write into read-only allocated C strings. Fixes a crash on HP-UX.
	* encoding.d (canonicalize_encoding): Invoke strdup.
	(encoding_from_name): Remove dangerous cast.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix install failure on AIX (bug#726).
	* makemake.in (with_dynamic_modules): Set to 'no' by default on AIX.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Disable some more builds that don't work on Solaris/x86_64 with cc.
	* Makefile.devel (multibuild-solaris-x86_64-cc): Don't depend on any
	build-porting64-cc-typecodes-* target.
	* lispbibl.d: On Solaris/x86_64 with cc, choose HEAPCODES by default,
	not TYPECODES.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix "reserving address range" warning on Solaris/i386.
	* spvw.d (init_memory): Exclude the address range of immediate objects
	from the address range that we reserve for heap-allocated objects.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Enable another build variant on Solaris/i386.
	* Makefile.devel (multibuild-solaris-i386-cc): Depend on
	build-porting32-cc-debug_ari_asm.
	(multibuild-solaris-i386-gcc): Depend on
	build-porting32-gcc-debug_ari_asm.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix LOGTEST bug when using Sun C on i386.
	A cast from 'int' to 'bool' works like x -> x!=0 with the standard C99
	'bool' type, but not with the 'signed char' substitute we import from
	gnulib. Cf. also the commit from 2004-03-12.
	* intlog.d (I_I_logtest): Explicitly test for !=0.
	* ari_asm_*.d (and_test_loop_up, test_loop_up): Clarify return type.
	* ari_asm_*-macro.c: Regenerated.

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Avoid hanging builds on Solaris, caused by "make check" in rawsock.
	* configure: Disable "make full-mod-check".

2018-01-28  Bruno Haible  <bruno@clisp.org>

	Fix mistake in an exception type (bug introduced on 2004-04-22).
	* constobj.d (O(type_socket_option)): Fix typo.

2018-01-27  Bruno Haible  <bruno@clisp.org>

	Add support for Linux in Microsoft WSL.
	* lispbibl.d (init_stream_osdeps): New declaration.
	* stream.d (is_wsl): New variable.
	(init_stream_osdeps): New function.
	(IS_EINVAL_EXTRA): On Microsoft WSL, treat EIO like EINVAL.
	* spvw.d (main): Invoke init_stream_osdeps.

2018-01-27  Bruno Haible  <bruno@clisp.org>

	Distribute the DEPENDENCIES and INSTALL.windows files.
	* Makefile.devel (SOURCES1): Add DEPENDENCIES, INSTALL.windows.

2018-01-27  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.

2018-01-27  Bruno Haible  <bruno@clisp.org>

	Update Spanish translation.
	* po/es.po: Update from Francisco Javier Serrador.
	* po/es.gmo, po/clisplow_es.*: Regenerated.

2018-01-26  Sam Steingold  <sds@gnu.org>

	* modules/dbus/configure.in: Add missing tests for
	dbus_message_set_serial, dbus_message_lock,
	dbus_message_demarshal_bytes_needed,
	dbus_connection_get_adt_audit_session_data.
	Reported by Jerry James <loganjerry@gmail.com>.

2018-01-24  Bruno Haible  <bruno@clisp.org>

	Remove workarounds for GCC versions < 2.95.
	* lispbibl.d: Bail out early when using a GCC version < 2.95.
	Remove workarounds for these GCC versions.
	* eval.d: Likewise.
	* intsqrt.d: Likewise.
	* lfloat.d: Likewise.

2018-01-23  Bruno Haible  <bruno@clisp.org>

	Fix initialization of modules in SINGLEMAP_MEMORY model, part 2.
	Reported by Jerry James <loganjerry@gmail.com>.
	* utils/modprep.c: Declare the init_function_1 and init_function_2
	early. Emit a static variable 'this_module_stab'. Change expansion of
	F() to refer to it, instead of to the generated subr_tab. Initialize
	it in init_function_1 and init_function_2.
	* modules/berkeley-db/bdb.c: Update init_function_2.
	* modules/clx/new-clx/clx.f: Likewise.
	* modules/pcre/cpcre.c: Likewise.
	* modules/rawsock/rawsock.c: Likewise.
	* modules/syscalls/calls.c: Likewise.

2018-01-22  Sam Steingold  <sds@gnu.org>

	* configure: When do_cbc==2, run "make base-mod-check" as cbcstep5
	and "make full-mod-check" as cbcstep6.

2018-01-22  Bruno Haible  <bruno@clisp.org>

	Fix GC-safety bug introduced on 2017-12-31.
	* lispbibl.d (SET_BIT, CLR_BIT): Remove trailing semicolon.
	* eval.d (symbol_env_search): Remove optimization that assumes that
	sym is constant.

2018-01-22  Sam Steingold  <sds@gnu.org>

	* pathname.d (my_realpath): Cosmetic change to avoid gcc
	"warning: suggest a space before ';' or explicit braces around
	empty body in 'while' statement".

2018-01-22  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (open-http): Admit that HTTPS is not supported instead
	of raising 'PARSE-INTEGER: substring "" does not have integer
	syntax at position 0'.

2018-01-22  Sam Steingold  <sds@gnu.org>

	* lispbibl.d: g++ bugs are not relevant to clang.

2018-01-22  Sam Steingold  <sds@gnu.org>

	* glm4/no-c++.m4: Update from gnulib to enable g++ compilation.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on AIX/POWER in 64-bit mode.
	* Makefile.devel (multibuild-aix-powerpc-64-xlc,
	multibuild-aix-powerpc-64-gcc): Enable all build variants that work.
	* makemake.in (XCFLAGS): For 64-bit AIX/POWER, enable all optimizations
	except ASM.
	* lispbibl.d (GENERIC64C_HEAPCODES_WORKS): Update value for AIX/POWER.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on AIX/POWER in 32-bit mode.
	* Makefile.devel (multibuild-aix-powerpc-32-xlc,
	multibuild-aix-powerpc-32-gcc): Enable all build variants that work.
	* makemake.in (XCFLAGS): For AIX/POWER, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix test failure regarding BOOLE on AIX with xlc.
	* makemake.in: When compiling lisparit.c with xlc for AIX and -DWIDE,
	reduce optimizations.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Comment.
	* stream.d (handle_pathname): Add comment about AIX.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix a crash due to (CLEAR-INPUT *TERMINAL-IO*) on AIX.
	* stream.d (clear_tty_input) [AIX]: Temporarily set the SIGHUP signal
	handler.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix error while creating clisp.c on AIX with xlc.
	* makemake.in: Choose the name of the gen-* temporary executables in a
	way that avoids particular suffixes.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix compilation error in C++ mode on AIX in 32-bit mode.
	* lispbibl.d (INIT_SYMBOL_TAB): Don't define when using g++ on 32-bit
	AIX/PowerPC.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	syscalls: Fix compilation error in C++ mode on AIX.
	* modules/syscalls/calls.c: Don't bind to sethostid() on AIX.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix compilation error in C++ mode on AIX.
	* spvw_mmap.d (MINCORE_ADDR_T): New type.
	(mincore_init, is_small_range_unmapped): Use it in the mincore()
	invocations.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Recommend libsigsegv 2.12.
	* configure (libsigsegv_url): Update to 2.12.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Solaris/x86_64.
	* Makefile.devel (multibuild-solaris-x86_64-cc,
	multibuild-solaris-x86_64-gcc): Enable all build variants that work or
	should work.
	* makemake.in (XCFLAGS): For Solaris/x86_64, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Solaris/i386.
	* Makefile.devel (multibuild-solaris-i386-cc,
	multibuild-solaris-i386-gcc): Enable all build variants that work or
	should work.
	* makemake.in (XCFLAGS): For Solaris/i386, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Solaris/SPARC64.
	* Makefile.devel (multibuild-solaris-sparc64-cc,
	multibuild-solaris-sparc64-gcc): Enable all build variants that work or
	should work.
	* makemake.in (XCFLAGS): For Solaris/SPARC64, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Solaris/SPARC.
	* Makefile.devel (multibuild-solaris-sparc-cc,
	multibuild-solaris-sparc-gcc): Enable all build variants that work or
	should work.
	* makemake.in (XCFLAGS): For Solaris/SPARC, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Make gettext calls work with non-GNU gettext in Solaris 11 libc.
	* makemake.in: After installing .mo files, on Solaris, create symbolic
	links ll_CC.UTF-8 -> ll for all supported locales.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix build failure with Sun cc.
	Sun cc and HP-UX cc do not look in the current directory by default
	when attempting to fulfil a '#include "..."' statement after a #line
	preprocessor directive. Cf. commit from 2017-03-16.
	* makemake.in: When compiling output of TXT2C, add option '-I.'.
	* modules/*/Makefile.in: When compiling a .m.c file, add option '-I.'.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix error during initialization of *TERMINAL-IO* on Mac OS X.
	* stream.d (handle_type): Ignore EBADF error on Mac OS X.
	(regular_or_pipe_handle_p): Renamed from pipe_file_handle_p.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix use of libtool's archive_cmds on Mac OS X.
	* makemake.in (DSYMUTIL): New variable.
	(archive_cmds): Don't lose references to $allow_undefined_flag.
	(XCC_CREATESHARED): Remove second command if present.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Avoid problem with shared libraries on Mac OS X.
	* makemake.in (SHREXT): Define to '.dylib' on Mac OS X and to '.sl' on
	HP-UX.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on NetBSD/sparc.
	* Makefile.devel (multibuild-netbsd-sparc): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For NetBSD/sparc, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on DragonFly/i386.
	None of the builds actually works for me: the kernel panics too often.
	* Makefile.devel (multibuild-dragonfly-i386): Enable all build variants
	that should work.
	* makemake.in (XCFLAGS): For DragonFly/i386, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on FreeBSD/arm64.
	* Makefile.devel (multibuild-freebsd-arm64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For FreeBSD/arm64, enable all optimizations
	except ASM.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix build failure on FreeBSD/arm64 and Solaris/SPARC64 with non-GCC
	compiler and NO_ADDRESS_SPACE_ASSUMPTIONS.
	* lispbibl.d: On FreeBSD/arm64 with clang and on Solaris/SPARC64 with
	cc, prefer GENERIC64B_HEAPCODES over GENERIC64C_HEAPCODES.
	(GENERIC64B_HEAPCODES_WORKS): Define accordingly.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Update set of working builds for Linux/s390x.
	* Makefile.devel (multibuild-linux-s390x): Don't depend on
	build-porting64-gcc-debug_gcsafety.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix crash of build-porting64-gcc-debug_gcsafety build on Linux/s390x.
	* makemake.in: When we already have -O0 in the $XCFLAGS, don't add -O1
	to a particular compilation command.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Update comments.
	* stream.d (clear_tty_input, finish_tty_output, clear_tty_output):
	Update comments after 2017-10-05 change.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	When testing, enable a couple of optimizations that are not risky.
	This avoids test failures with non-GCC compilers.
	* Makefile.devel (build-porting*-one_free_bit_heapcodes-trivialmap,
	build-porting*-kernelvoid32_heapcodes,
	build-porting*-generic64_heapcodes,
	build-porting*-typecodes-spvw_mixed_blocks-trivialmap,
	build-porting*-spvw_pure_blocks): Remove flags -DNO_FAST_FLOAT
	-DNO_FAST_DOUBLE -DNO_ALLOCA.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix crash with all non-GCC/clang compilers (regression from 2006-09-03).
	* lispbibl.d (Cclosure_last_const): Don't use sizeof of a struct that
	contains a variable-length array.
	* unix/PLATFORMS: Remove section about Sun cc.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	Fix compilation error in C++ mode (regression from 2017-12-04).
	* modules/regexp/regexi.c (REGEXP-EXEC): Add necessary casts.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	syscalls: Make this module work with DYNAMIC_MODULES.
	Fixes bug#725.
	* modules/syscalls/calls.c (bogomips): New function, moved here from
	bogomips.c. Use 'volatile' to defeat compiler optimizations.
	* modules/syscalls/bogomips.c: Remove file.
	* modules/syscalls/Makefile.in (bogomips.o): Remove rule.
	(GENERATED): Remove bogomips.o.
	* modules/syscalls/link.sh.in (NEW_FILES): Likewise.

2018-01-20  Bruno Haible  <bruno@clisp.org>

	clisp-link: Fix "ld: SONAME must not be empty string" warning.
	* clisp-link (add): Set 'dll' before invoking @createsharedlib@.

2018-01-18  Sam Steingold  <sds@gnu.org>

	Follow suggestions in https://stackoverflow.com/q/48283885/850781
	* modules/pari/configure.in: Accept --with-pari-datadir and search
	for pari.desc there and in other inferred locations.
	* modules/pari/Makefile.in: Substitute PARI_DATADIR and pass it to
	pari.lisp compilation.
	* modules/pari/pari.lisp: Assume the 1st compilation arg point to
	the directory with pari.desc.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Mac OS X/x86_64.
	* Makefile.devel (multibuild-macosx-x86_64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Mac OS X/x86_64, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Mac OS X/PowerPC.
	* Makefile.devel (multibuild-macosx-powerpc): Enable all build variants
	that work or should work.
	* makemake.in (XCFLAGS): For Mac OS X/PowerPC, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Mac OS X/i386.
	* Makefile.devel (multibuild-macosx-i386): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Mac OS X/i386, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on OpenBSD/x86_64.
	* Makefile.devel (multibuild-openbsd-x86_64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For OpenBSD/x86_64, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on OpenBSD/i386.
	* Makefile.devel (multibuild-openbsd-i386): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For OpenBSD/i386, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on NetBSD/x86_64.
	* Makefile.devel (multibuild-netbsd-x86_64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For NetBSD/x86_64, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on NetBSD/i386.
	* Makefile.devel (multibuild-netbsd-i386): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For NetBSD/i386, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on FreeBSD/x86_64.
	* Makefile.devel (multibuild-freebsd-x86_64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For FreeBSD/x86_64, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on FreeBSD/i386.
	* Makefile.devel (multibuild-freebsd-i386): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For FreeBSD/i386, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/mips64.
	* Makefile.devel (multibuild-linux-mips-64): Renamed from
	multibuild-linux-mipseb-64 and multibuild-linux-mipsel-64. Enable all
	build variants that work.
	* makemake.in (XCFLAGS): For Linux/mips64 with 64-bit ABI, enable all
	optimizations except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/mipsn32.
	* Makefile.devel (multibuild-linux-mips-n32): Renamed from
	multibuild-linux-mipseb-n32 and multibuild-linux-mipsel-n32. Enable all
	build variants that work.
	* makemake.in (XCFLAGS): For Linux/mips64 with n32 ABI, enable all
	optimizations except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/mips.
	* Makefile.devel (multibuild-linux-mips-32): Renamed from
	multibuild-linux-mipseb-32 and multibuild-linux-mipsel-32. Enable all
	build variants that work.
	* makemake.in (XCFLAGS): For Linux/mips with o32 ABI, enable all
	optimizations except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Fix failure of the spvw_pure_blocks build on Linux/mipsn32.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_START): Treat Linux/mipsn32 like
	Linux/mips32.
	(SINGLEMAP_*) [Linux/mipsn32]: Update accordingly.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Fix compilation error on Linux/mipsn32.
	* makemake.in: On mipsn32 platforms, use ari_asm_mips.d and
	sp_asm_mips.d.
	* arilev1.d: On mipsn32 platforms, include ari_asm_mips.c, not
	ari_asm_mips64.c.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Fix failure of the builds with -DWIDE on Linux/mips (o32 ABI).
	* makemake.in: When compiling with GCC for Linux/mips and -DWIDE,
	reduce optimizations.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/alpha.
	* Makefile.devel (multibuild-linux-alpha): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/alpha, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Fix a bug in the optimizations for SPARC64.
	* arilev0.d (mulu16): Cast the operands from uint16 to uint32, to force
	a zero-extend before the asm-coded instructions.

2018-01-13  Bruno Haible  <bruno@clisp.org>

	Make SYS::IMPLEMENTATION-DEPENDENT work in all memory models.
	* control.d (make_variable_frame): Fix pushSTACK_symbolwithflags
	invocation.

2018-01-13  Bruno Haible  <bruno@clisp.org>

	Print frame pointers as #<FRAME-POINTER nn> also in HEAPCODES model.
	* io.d (prin_object_dispatch_low) [HEAPCODES]: For a frame pointer,
	invoke pr_framepointer, not pr_machine.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Hurd/i386.
	* Makefile.devel (multibuild-hurd-i386): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Hurd/i386, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Fix failure of the builds with -DWIDE on Hurd/i386 and FreeBSD/i386.
	* makemake.in: When compiling with GCC for i386 and -DWIDE, reduce
	optimizations.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/s390x.
	* Makefile.devel (multibuild-linux-s390x): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/s390x, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/s390.
	* Makefile.devel (multibuild-linux-s390): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/s390, enable all optimizations
	except ASM.

2018-01-14  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/ia64.
	* Makefile.devel (multibuild-linux-ia64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/ia64, enable all optimizations
	except ASM.

2018-01-13  Bruno Haible  <bruno@clisp.org>

	Improve framepointerp in GENERIC64C_HEAPCODES model.
	* lispbibl.d (framepointerp) [GENERIC64C_HEAPCODES]: Correct bit mask.

2018-01-13  Bruno Haible  <bruno@clisp.org>

	Improve the quality of SXHASH on instances of STANDARD-STABLEHASH and
	STRUCTURE-STABLEHASH.
	Suggested by Sam Steingold.
	* hashtabl.d (sxhash_clause2): Renamed from sxhash.
	(sxhash): New function.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on GNU/kFreeBSD/x86_64.
	* Makefile.devel (multibuild-freebsd-gnu-x86_64): Enable all build
	variants.
	* makemake.in (XCFLAGS): For GNU/kFreeBSD/x86_64, enable all
	optimizations except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/sparc64.
	* Makefile.devel (multibuild-linux-sparc64): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/sparc64, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/sparc.
	* Makefile.devel (multibuild-linux-sparc): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/sparc, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/powerpc64le.
	* Makefile.devel (multibuild-linux-powerpc64le): Enable all build
	variants.
	* makemake.in (XCFLAGS): For Linux/powerpc64le, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/powerpc64.
	* Makefile.devel (multibuild-linux-powerpc64): Enable all build
	variants.
	* makemake.in (XCFLAGS): For Linux/powerpc64, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/powerpc.
	* Makefile.devel (multibuild-linux-powerpc): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/powerpc, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/arm64.
	* Makefile.devel (multibuild-linux-arm64): Enable all build variants.
	* makemake.in (XCFLAGS): For Linux/arm64, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/arm.
	* Makefile.devel (multibuild-linux-arm): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/arm, enable all optimizations
	except ASM.

2018-01-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/m68k.
	* Makefile.devel (multibuild-linux-m68k): Enable all build variants
	that are intended to work.
	* makemake.in (XCFLAGS): For Linux/m68k, enable all optimizations
	except ASM.

2018-01-11  Sam Steingold  <sds@gnu.org>

	DIRECTORY matches like PATHNAME-MATCH-P (bug#724).
	* pathname.d (split_nametype_match): Extract from ...
	(directory_search_scandir): Call it instead of wildcard_match on
	direntry.
	(directory_search): Use the pathname object instead of
	file_namestring for name&type.

2018-01-10  Bruno Haible  <bruno@clisp.org>

	Enable more optimizations on Linux/hppa.
	* makemake.in (XCFLAGS): For Linux/hppa, enable all optimizations
	except ASM.
	* Makefile.devel (multibuild-linux-hppa): Don't depend on
	build-porting32-gcc-ari_asm, since build-porting32-gcc-safety0 tests
	this optimization now.

2018-01-10  Bruno Haible  <bruno@clisp.org>

	Enable more optimizations on Linux/x86_64-x32.
	* makemake.in (XCFLAGS): For Linux/x86_64-x32, enable all optimizations
	except ASM.

2018-01-10  Bruno Haible  <bruno@clisp.org>

	Enable more optimizations on Linux/i386.
	* makemake.in (XCFLAGS): For Linux/i386, enable all optimizations
	except ASM.
	* Makefile.devel (multibuild-linux-i386): Don't depend on
	build-porting32-gcc-ari_asm and build-porting32-gcc-arilev0-asm, since
	build-porting32-gcc-safety0 tests both of these optimizations now.

2018-01-10  Bruno Haible  <bruno@clisp.org>

	Enable more optimizations on Linux/x86_64.
	* makemake.in (XCFLAGS): For Linux/x86_64, enable all optimizations
	except ASM.

2018-01-09  Bruno Haible  <bruno@clisp.org>

	ari_asm for ARM: Avoid use of privileged instructions.
	Reported at <https://bugzilla.redhat.com/show_bug.cgi?id=812928#c7>.
	* ari_asm_arm.d: Use LDMFD and LDMccFD instructions without ^.
	* ari_asm_arm-macro.c: Regenerated.

2018-01-09  Bruno Haible  <bruno@clisp.org>

	ari_asm for ARM: Update instructions for ARMv5 and newer or ARMv4T.
	* ari_asm_arm.d: Use "BXcc lr" instead of "MOVcc[S] pc,lr" instruction.
	* ari_asm_arm-macro.c: Regenerated.

2018-01-09  Bruno Haible  <bruno@clisp.org>

	ari_asm for ARM: Avoid warning about deprecated instruction.
	* ari_asm_arm.d: Use CMP instead of CMPS instruction.
	* ari_asm_arm-macro.c: Regenerated.

2018-01-09  Bruno Haible  <bruno@clisp.org>

	Modernize syntax transformation of assembly-language files.
	* src/ari_asm_arm.d: Convert to Linux/arm syntax, with %% preprocessor
	directives. Remove GNU-stack note.
	* src/ari_asm_hppa.d: Convert to Linux/hppa syntax. Remove GNU-stack
	note.
	* src/ari_asm_i386.d, src/sp_asm_i386.d: Convert to Linux/i386 syntax.
	Remove GNU-stack note.
	* src/sp_asm_m68k.d: Convert to Linux/m68k syntax. Remove GNU-stack
	note.
	* src/ari_asm_mips.d, src/sp_asm_mips.d: Convert to Linux/mips syntax,
	with %% preprocessor directives.
	* src/ari_asm_mips64.d: Convert to Linux/mips64 syntax, with %%
	preprocessor directives.
	* src/ari_asm_sparc.d, src/sp_asm_sparc.d: Convert to Linux/sparc
	syntax, with %% preprocessor directives. Remove GNU-stack note.
	* src/ari_asm_sparc64.d, src/sp_asm_sparc64.d: Convert to Linux/sparc64
	syntax, with %% preprocessor directives. Remove GNU-stack note.
	* utils/comment5.sed: New file.
	* src/asm-arm.sh, src/asm-arm.h: New files, from GNU libffcall.
	* src/asm-hppa.sh, src/asm-hppa.h: New files, from GNU libffcall.
	* src/asm-i386.sh, src/asm-i386.h: New files, from GNU libffcall.
	* src/asmi386.sh, src/asmi386.hh, src/asmi386.h: Remove files.
	* src/asm-m68k.sh, src/asm-m68k.h: New files, from GNU libffcall.
	* src/asm-mips.sh, src/asm-mips.h: New files, from GNU libffcall.
	* src/asm-sparc.sh, src/asm-sparc.h: New files, from GNU libffcall.
	* src/noexecstack.h: New file, from GNU libffcall.
	* src/noexecstack-arm.h: Likewise.
	* Makefile.devel (src/ari_asm_*-macro.c, src/sp_asm_*-macro.c): New
	rules.
	(src/asmi386.h, src/ari_asm_i386.msvc.c, src/sp_asm_i386.msvc.c):
	Remove rules.
	(build-prerequisites): Update.
	* makemake.in (SED): Emit new variable.
	(ASMFLAGS): Don't use K&R mode of SunPRO C.
	Generate .s file of assembly-language file by processing *-macro.c, in
	a way similar to GNU libffcall.
	With MSVC, generate .obj file of assembly-language file by compiling
	*-macro.c.
	* src/ari_asm_*-macro.c, src/sp_asm_*-macro.c: New generated files.
	* src/ari_asm_i386.msvc.c, src/sp_asm_i386.msvc.c: Remove generated
	files.

2018-01-09  Bruno Haible  <bruno@clisp.org>

	build: Revisit 'cpu' variable.
	* makemake.in (cpu): Simplify fallback code that should never run.
	(XCFLAGS): Treat $cpu = armhf like $cpu = arm.

2018-01-07  Sam Steingold  <sds@gnu.org>

	Modernize GDBM interface.
	* modules/gdbm/gdbm.c (check_gdbm_errno): Add more error codes.
	(gdbm_open_flags): DEFCHECKER(bitmasks=both).
	(GDBM-OPEN): Restore :OPTIONS.
	(GDBM-DEFAULT-KEY-TYPE, GDBM-DEFAULT-VALUE-TYPE): Remove,
	use GDBM-OPT instead.
	(GDBM-OPT, %SET-GDBM-OPT): Replace GDBM-SETOPT.
	* modules/gdbm/gdbm.lisp (GDBM-OPT): Add defsetf.

2018-01-06  Sam Steingold  <sds@gnu.org>

	Restore the code to avoid -Wmissing-declarations.
	* utils/modprep.lisp (print-tables-2): Revert part of 2017-12-05.
	* foreign1.lisp (finalize-coutput-file): Revert part of 2017-11-29.

2018-01-04  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (gdbm_open_flags): DEFFLAGSET, not DEFCHECKER.
	(GDBM-OPEN): Support all the current open flags.

2018-01-04  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (open-url): Remove an unused variable.

2018-01-04  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (error_gdbm): Fix declaration for gdbm 1.14.
	(open_gdbm): No need to cast error_gdbm.
	(GDBM:GDBM-COUNT): New function.
	* modules/gdbm/gdbm.lisp: Export it.

2018-01-01  Bruno Haible  <bruno@clisp.org>

	Bump copyright year.
	* COPYRIGHT: Bump year.
	* spvw.d (print_banner): Likewise.

2018-01-01  Bruno Haible  <bruno@clisp.org>

	Tweak mappable address range for Linux/x86_64.
	Reported by Sam Steingold in bug#718.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_*, SINGLEMAP_*) [UNIX_LINUX &&
	AMD64]: Define differently.

2018-01-01  Bruno Haible  <bruno@clisp.org>

	Modernization: Use improvements from gnulib and libffcall.
	* m4/as-underscore.m4: Replace with version from GNU libffcall.
	* aclocal.m4, src/configure, src/config.h.in, gllib/*: Regenerated.

2017-12-31  Bruno Haible  <bruno@clisp.org>

	Update Spanish translation.
	* po/es.po: Update from Francisco Javier Serrador.
	* po/es.gmo, po/clisplow_es.*: Regenerated.

2017-12-31  Bruno Haible  <bruno@clisp.org>

	Emit a warning when LOOP is used with unportable syntax.
	* loop.lisp (loop-initialization): Add member 'impdependent-declspec'.
	(expand-loop): Wrap selected initialization forms in LOCALLY with a
	SYS::IMPLEMENTATION-DEPENDENT declaration for variables that are not
	guaranteed to be visible.

2017-12-31  Bruno Haible  <bruno@clisp.org>

	Support new declaration SYS::IMPLEMENTATION-DEPENDENT.
	* lispbibl.d (impdependent): New macro.
	(sym_macrop): Mark as maygc.
	(check_symbol_in_declaration): Renamed from check_symbol_special.
	Add decl_identifier argument.
	* constsym.d: Add SYS::IMPLEMENTATION-DEPENDENT.
	* constobj.d (O(printstring_implementation_dependent)): Add.
	(O(declaration_types)): Add SYS::IMPLEMENTATION-DEPENDENT to the
	known declarations.
	* io.d (pr_system): Handle impdependent.
	* spvw_debug.d (nobject_out1): Likewise.
	* error.d (check_symbol_in_declaration): Renamed from
	check_symbol_special. Add decl_identifier argument.
	* control.d (specdecled_): Ignore the bindings with "value"
	impdependent.
	(make_variable_frame): Handle SYS::IMPLEMENTATION-DEPENDENT
	declarations.
	* eval.d (warn_impdependent): New function.
	(symbol_env_search): Invoke warn_impdependent when encountering
	impdependent.
	(sym_value, sym_macrop): Mark as maygc.
	(setq, macroexp0, get_closure): Update.
	* compiler.lisp (impdependent): New variable.
	(venv-search): Emit warning about implementation-dependent variable
	references.
	(process-declarations): Return additional value: the impdependent
	symbols.
	(*impdependents*): New variable.
	(push-specials-impdependents): Renamed from push-specials.
	Update *VENV* also for the impdependent symbols.
	(c-LAMBDABODY, c-LET/LET*, c-LOCALLY, c-MULTIPLE-VALUE-BIND, c-FLET)
	(c-LABELS, c-MACROLET, c-SYMBOL-MACROLET, c-FUNCALL-INLINE): Update.

2017-12-29  Bruno Haible  <bruno@clisp.org>

	Don't create a circular tree when recovering from continuable error
	(bug from 2003-05-20).
	* control.d (make_variable_frame): Store the corrected symbol in the
	source program.

2017-12-29  Bruno Haible  <bruno@clisp.org>

	Remove unused code.
	* loop.lisp (wrap-unwind-protect): Remove function.
	(expand-loop): Don't use it.

2017-12-29  Bruno Haible  <bruno@clisp.org>

	* loop.lisp: Translate and improve comments.

2017-12-20  Sam Steingold  <sds@gnu.org>

	* modules/pari/pari.lisp (make-arg-spec): Downcase keyword args to
	avoid having to write (pari:random_ :|n| 10).

2017-12-20  Sam Steingold  <sds@gnu.org>

	Finish rfe#21: add :GUARD argument to DEF-C-VAR.
	* foreign1.lisp (with-guard): New macro.
	(finalize-coutput-file): Use it for constants, types, variables,
	and functions.
	(def-c-var): Accept :GUARD, defaulting to *FOREIGN-GUARD*, pass to
	(note-c-var): Save guard to *VARIABLE-LIST*.

2017-12-17  Sam Steingold  <sds@gnu.org>

	* modules/pari/pari.lisp (make-documentation): Set doc instead of
	expanding into a form that does it.
	(polsturm): Redefine with better keyword args, preserving the doc
	using make-documentation.

2017-12-15  Sam Steingold  <sds@gnu.org>

	* modules/pari/pari.lisp: Convert to and from INFINITY (+oo and -oo)

2017-12-15  Sam Steingold  <sds@gnu.org>

	Most of the PARI interface functions are generated automatically.
	* modules/pari/desc2lisp.lisp: New file, read
	$datadir/pari/pari.desc and emi pari-call-out forms.
	* modules/pari/pari.lisp: Remove most of pari-call-out forms and
	use desc2lisp to interface to most of the GP functions.

2017-12-15  Bruno Haible  <bruno@clisp.org>

	Fix configure failure with some shells (regression from 2017-12-04).
	Reported by Blake McBride <blake@mcbride.name>.
	* configure: Don't use unportable 'pipefail' shell feature. Use
	explicit failure test for the ${MAKE} commands instead.

2017-12-11  Sam Steingold  <sds@gnu.org>

	* modules/regexp/regexp.lisp (regexp-split): Respect the :END argument.

2017-12-10  Sam Steingold  <sds@gnu.org>

	* loop.lisp (expand-loop): Revert the 2017-11-22 fix for bug#375.

2017-12-08  Sam Steingold  <sds@gnu.org>

	Ensure that all positional args are in *ARGS* when compiling.
	* spvw.d (push_to_args): Extract from ...
	(main_actions): Call push_to_args() on argv_execute_args when
	compiling in addition to when scripting
	* makemake.in (check-script): Test that.

2017-12-07  Jerry James  <loganjerry@gmail.com>
	    Sam Steingold  <sds@gnu.org>

	Avoid -Wunsequenced / -Wsequence-point warnings (subsumes patch#54).
	* modules/clx/new-clx/clx.f (STANDARD_XID_OBJECT_LOOK)
	(STANDARD_PTR_OBJECT_LOOK): Avoid multiple popSTACK()s in a single
	expression by creating a separate statement for each.
	* modules/rawsock/rawsock.c (RAWSOCK:GETADDRINFO): Likewise.
	* modules/syscalls/calls.c (POSIX:MKNOD): Likewise.

2017-12-06  Sam Steingold  <sds@gnu.org>

	* emacs/d-mode.el (d-extra-keywords): Add "unused".
	* array.d, encoding.d, foreign.d, funarg.d, io.d, pathname.d,
	* sequence.d, socket.d, spvw.d, spvw_garcol.d, spvw_garcol_old.d,
	* spvw_mmap.d, spvw_sigint.d, spvw_sigpipe.d, spvw_sigsegv.d,
	* spvw_sigwinch.d, stream.d, time.d, gctrigger.c: Code cleanup:
	use "unused(V)" instead of "(void)V".

2017-12-06  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (handle_fault_range) [!(GENERATIONAL_GC & SPVW_MIXED)]:
	Expand non-trivially to avoid -Wunused-parameter.

2017-12-06  Sam Steingold  <sds@gnu.org>

	* makemake.in (LIBS): Add LIBUNISTRING like LIBSIGSEGV. Fix bug#719.

2017-12-06  Sam Steingold  <sds@gnu.org>

	Make sure the Darwin foo.dSYM directories are removed by clean et al.
	* makemake.in (exefiles, EXERM): New variables.
	Used throughout to ensure removal of .dSYM. Cf. patch#50.

2017-12-05  Jörg Höhle  <hoehle@users.sourceforge.net>

	* loop.lisp (destructure-type): In LOOP destructuring, type NIL
	originally meant: "Skip type declaration for this variable" (patch#53).

2017-12-05  Sam Steingold  <sds@gnu.org>

	* utils/modprep.lisp (print-tables-2): Do not output unnecessary
	prototypes, but output code to avoid the -Wunused-parameter warning.
	Similar to the 2017-11-29 foreign1.lisp patch.

2017-12-05  Ken Brown  <kbrown@cornell.edu>

	* encoding.d (encoding_from_name) [UNIX_CYGWIN]: Use Unix line
	endings (patch#47).

2017-12-04  Jörg Höhle  <hoehle@users.sourceforge.net>

	* modules/regexp/regexi.c (REGEXP-COMPILE, REGEXP-EXEC) [UNICODE]:
	Use UTF-8 to communicate with gnulib/regexp, but keep
	O(misc_encoding) for locale-dependent error messages.

2017-12-04  Jörg Höhle  <hoehle@users.sourceforge.net>

	* modules/regexp/regexi.c (REGEXP-EXEC): Compute character string
	index based on the current O(misc_encoding).

2017-12-04  Sam Steingold  <sds@gnu.org>

	* configure.in: Move gl_EARLY before AC_LIB_PROG_LD to avoid aclocal
	warning: AC_COMPILE_IFELSE was called before AC_USE_SYSTEM_EXTENSIONS

2017-12-04  Sam Steingold  <sds@gnu.org>

	* configure: Ensure exit on a pipe sub-command failure (regression
	since 2017-02-26) by using bash/ksh/zsh-specific "set -o pipefail".

2017-12-04  Sam Steingold  <sds@gnu.org>

	* modules/pari/pari.lisp: General cleanup.
	"465 exported symbols, 46 undocumented, 7 without pari function"

2017-12-03  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-doc): Respect command line options like
	make check-doc IMPNOTES=../doc/html/ CLHSROOT=http://clhs.lisp.se/
	(note the trailing slash!)

2017-12-01  Sam Steingold  <sds@gnu.org>

	Fix bug#659: update the pari module to PARI/GP 2.9.3
	* modules/pari/cpari.c (clisp_out, clisp_err): PariOUT no longer
	has the 4th field "die", instead set cb_pari_err_recover to...
	(clisp_err_recover): New function.
	* modules/pari/pari.lisp: Drop removed/Update renamed objects.
	(convert-to-pari@vector): Use #(...) for Vecsmall (immediate long[]).
	(convert-from-pari-vector): Handle Vecsmall.

2017-11-30  Jörg Höhle  <hoehle@users.sourceforge.net>

	* modules/i18n/gettext.c: CLISP_UNICODE is always defined in
	modules, so use #if, not #ifdef.

2017-11-29  Sam Steingold  <sds@gnu.org>

	* foreign1.lisp (finalize-coutput-file): Do not output unnecessary
	prototypes, but output code to avoid the -Wunused-parameter warning.

2017-11-29  Sam Steingold  <sds@gnu.org>

	Remove old deprecated features.
	(5+ years after the first release in which it became deprecated)
	* modules/syscalls/posix.lisp (socket-service-port): Remove.
	* deprecated.lisp (type-expand-1, foreign-address-null)
	(delete-dir, make-dir, rename-dir): Remove.

2017-11-29  Sam Steingold  <sds@gnu.org>

	* amigasock.lisp: Remove the last vestige of Amiga support.

2017-11-29  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-doc): Also test sys::ensure-clhs-map.

2017-11-29  Sam Steingold  <sds@gnu.org>

	An attempt to fix bug#719: get libunistring-optional from gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* Makefile.devel (GNULIB_CORE): Add libunistring-optional.
	* configure.in: call gl_LIBUNISTRING_OPTIONAL.
	* gllib/*, glm4/*: Update from gnulib.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-11-28  Sam Steingold  <sds@gnu.org>

	DEF-CALL-OUT now accepts the :GUARD argument.
	* foreign1.lisp (finalize-coutput-file): 4th element in function
	record in *function-list* is its guard.
	(def-call-out): Accept :guard, defaulting to *foreign-guard*, pass
	it to ...
	(note-c-fun): Save guard to *function-list*.
	* modules/bindings/glibc/linux.lisp (canonicalize_file_name)
	(euidaccess, get_current_dir_name, group_member, fcloseall):
	Uncomment and guard with "defined(__USE_GNU)".

2017-11-27  Bruno Haible  <bruno@clisp.org>

	ari_asm for mips: Don't use a global variable as return value.
	* ari_asm_mips.d (asm_mulu32_): Accept a pointer argument for where to
	store the high part of the result.
	* ari_asm_mips64.d (asm_mulu32_): Likewise.
	* arilev0.d (mulu32_) [MIPS]: Pass a pointer to asm_mulu32_.

2017-11-27  Bruno Haible  <bruno@clisp.org>

	ari_asm for i386: Don't use a global variable as return value.
	* ari_asm_i386.d (asm_mulu32_64): Renamed from asm_mulu32_. Don't
	access mulu32_high.
	(asm_divu_6432_3232_): Don't access divu_32_rest.
	* arilev0.d (mulu32, mulu32_, divu_6432_3232_) [I80386]: Get a 64-bit
	result from the registers.
	* ari_asm_i386.msvc.c: Regenerated.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	ari_asm for HPPA: Don't use a global variable as return value.
	* ari_asm_hppa.d (asm_mulu32_64): Renamed from asm_mulu32_. Don't
	access mulu32_high.
	* arilev0.d (mulu32, mulu32_) [HPPA]: Get a 64-bit result from the
	registers.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	ari_asm for HPPA: Fix build failure with the GNU assembler.
	* ari_asm_hppa.d: Use pseudo-ops that GNU as understands.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	ari_asm for ARM: Don't use a global variable as return value.
	* ari_asm_arm.d (asm_mulu32_64): Renamed from asm_mulu32_. Don't
	access mulu32_high.
	(asm_divu_3216_1616_): Don't access divu_16_rest.
	(asm_divu_6432_3232_): Don't access divu_32_rest.
	* arilev0.d (retval64_r0, retval64_r1): New macros.
	(mulu32, mulu32_, divu_3216_1616, divu_6432_3232, divu_6432_3232_)
	[ARM]: Get a 2x32-bit result from the registers r0,r1.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Simplify ari_asm for ARM.
	* ari_asm_arm.d: Remove support for RISC OS syntax.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Add comments.
	* ari_asm_*.d: Add comments about the ABIs. Info taken from libffcall.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Avoid an infinite recursion when clisp is started under a broken gdb.
	* stream.d (low_read_unbuffered_handle): Don't signal an EIO error
	from the TERMINAL-STREAM.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Disable generational GC on Linux/mips*.
	Generational GC on Linux/mips* works in QEMU-based virtual machines,
	but not on EdgeRouter Pro (Cavium Octeon II) hardware.
	* lispbibl.d (GENERATIONAL_GC): Don't enable on Linux/mips*.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Fix a bug in the optimizations for SPARC64.
	* arilev0.d (divu_3216_1616, divu_3216_3216): Use a temporary variable
	of type uint32, not uint16, to force a zero-extend before the asm-coded
	instructions.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Fix bugs in ari_asm for sparc64.
	* ari_asm_sparc64.d (asm_or_loop_up, asm_xor_loop_up, asm_and_loop_up,
	asm_eqv_loop_up, asm_nand_loop_up, asm_nor_loop_up, asm_andc2_loop_up,
	asm_orc2_loop_up) [COUNTER_LOOPS]: Write into xptr[], not into yptr[].
	(asm_add_loop_down): Write result into the right location.
	(asm_addto_loop_down) [COUNTER_LOOPS]: Optimize.
	(asm_sub_loop_down) [COUNTER_LOOPS]: Write result into the right
	location.
	(asm_subx_loop_down): Write result into the right location.
	(asm_subfrom_loop_down): Produce dest-source, not source-dest.
	(asm_shiftleftcopy_loop_down): Use correct register.
	(asm_neg_loop_down) [COUNTER_LOOPS]: Optimize.

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Fix bugs in the COUNTER_LOOPS implementation of ari_asm for SPARC.
	* ari_asm_sparc.d (asm_or_loop_up, asm_xor_loop_up, asm_and_loop_up,
	asm_eqv_loop_up, asm_nand_loop_up, asm_nor_loop_up, asm_andc2_loop_up,
	asm_orc2_loop_up): Write into xptr[], not into yptr[].

2017-11-26  Bruno Haible  <bruno@clisp.org>

	Fix bug in ari_asm for mips64.
	* ari_asm_mips64.d (asm_subx_loop_down): Expect the 5th argument in $8,
	not on the stack.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Add a facility for checking and debugging the ari_asm_* code.
	* arilev1.d: When DEBUG_ARI_ASM is defined, select LOOP_DEBUG_ASM and
	include arilev1dbg.c.
	* arilev1c.d: Apply C() macro to the name of each function.
	* arilev1dbg.d: New file.
	* makemake.in (LISPARIT_INCLUDES): Add it.
	* Makefile.devel (build-porting*-debug_ari_asm): New targets.
	(multibuild-linux-hppa, multibuild-linux-i386): Depend on
	build-porting32-gcc-debug_ari_asm.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Don't install signal handlers for SIGABRT and SIGILL.
	* spvw_sigterm.d (set_sigterm_handler): Don't install a handler for
	SIGABRT or SIGILL.
	* spvw.d (fill_terminating_signals_mask): Update accordingly.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Fix comment (regression from 2008-01-15).
	* spvw.d (quit): Note the meaning of a negative final_exitcode.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Provide a starting point for ari_asm_* development.
	* arilev1c.d: Use 'maybe_local' instead of 'local'.
	* arilev1.d (LOOP_STATIC_C): Renamed from LOOP_EXTERN_C.
	(LOOP_EXTERN_C): New macro. Define maybe_local.
	* arilev1_asm_proto.d: New file.
	* makemake.in (EXTRA_CPARTS): Add arilev1_asm_proto.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Modernize: Convert source code from K&R C to ANSI C.
	* arilev1c.d: Convert to ANSI C.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	More systematic Makefile.devel target naming.
	* Makefile.devel (build-porting*-ari_asm): Renamed from
	build-porting*-ari-asm.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	More systematic naming of ari* assembly-language files.
	* ari_asm_i386.d: Renamed from ari80386.d.
	* ari_asm_arm.d: Renamed from ariarm.d.
	* ari_asm_hppa.d: Renamed from arihppa.d.
	* ari_asm_mips.d: Renamed from arimips.d.
	* ari_asm_mips64.d: Renamed from arimips64.d.
	* ari_asm_sparc.d: Renamed from arisparc.d.
	* ari_asm_sparc64.d: Renamed from arisparc64.d.
	* arilev1.d: Update accordingly.
	* makemake.in (ARI_ASMD, ARI_ASMS): Likewise.
	* Makefile.devel (src/ari_asm_i386.msvc.c): Renamed from
	src/ari80i386.msvc.c.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	More systematic naming of sp* assembly-language files.
	* sp_asm_m68k.d: Renamed from sp68000.d.
	* sp_asm_sparc.d: Renamed from spsparc.d.
	* sp_asm_sparc64.d: Renamed from spsparc64.d.
	* sp_asm_mips.d: Renamed from spmips.d.
	* sp_asm_i386.d: Renamed from sp80386.d.
	* makemake.in (SP_ASMD, SP_ASMS): Update accordingly.
	* Makefile.devel (src/sp_asm_i386.msvc.c): Renamed from
	src/sp80i386.msvc.c.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Fix build failure of build-porting32-gcc-arilev0-asm on Linux/sparc.
	* makemake.in: When compiling eval.c with GCC for sparc, reduce
	optimizations.

2017-11-25  Bruno Haible  <bruno@clisp.org>

	Make it possible to use '-nextgc-factor 0.001' with GENERATIONAL_GC.
	* spvw.d (main): Move install_segv_handler invocation from here...
	(init_memory): ... to here.

2017-11-22  Sam Steingold  <sds@gnu.org>

	Fix bug#375: (loop ... for x on x ...)
	* loop.lisp (expand-loop): Bind all start forms at the outermost
	level to gensyms and then use the gensyms in the preamble.

2017-11-21  Sam Steingold  <sds@gnu.org>

	Avoid gcc/clang warnings -Wformat
	* spvw_global.d (check_gc_consistency, check_gc_consistency_2):
	Cast format arguments to (unsigned long).
	* spvw_sigsegv.d (print_mem_stats): Likewise.

2017-11-21  Sam Steingold  <sds@gnu.org>

	Avoid gcc/clang warnings -Wunused-parameter
	* encoding.d (base64_mbstowcs, base64_wcslen, base64_wcstombs)
	(base64_range, all_range, bmp_range, uni16be_mbstowcs)
	(uni16le_mbstowcs, uni16be_wcstombs, uni16le_wcstombs)
	(uni32be_mbstowcs, uni32le_mbstowcs, uni32_wcslen)
	(uni32be_wcstombs, utf8_mblen, utf8_mbstowcs, utf8_wcslen)
	(java_wcstombs, java_mblen, java_mbstowcs, java_wcslen, nls_mblen)
	(nls_asciiext_mblen, nls_wcslen, nls_asciiext_wcslen):
	Use (void) to mark unused parameters.

2017-11-21  Sam Steingold  <sds@gnu.org>

	Avoid gcc/clang warnings -Wdangling-else (missed by #pragma).
	* foreign.d (PARSE-FOREIGN-INTTYPE): Add braces.
	* flo_rest.d, intelem.d (IF_LENGTH): Likewise.

2017-11-20  Bruno Haible  <bruno@clisp.org>

	Revert introduction of installed program 'clisp!' (no longer needed).
	* _clisp.c: Do not test SHEBANG_SUPPORT.
	* _distmakefile: Do not install 'clisp!'.
	* makemake.in: Likewise.
	* NEWS: Bug#699 is fixed without breaking backward compatibility.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Make it easier to test the optimizations in arilev0.d and ari*.d.
	* Makefile.devel (build-porting*-ari-asm, build-porting*-arilev0-asm):
	New targets.
	(multibuild-linux-hppa, multibuild-linux-i386): Depend on them.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Improve SYS::ADDRESS-OF in SINGLEMAP_MEMORY model.
	* misc.d (SYS::ADDRESS-OF): In SINGLEMAP_MEMORY model, do not mask
	out the type bits.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/s390x with HEAPCODES.
	* lispbibl.d: On Linux/s390x, prefer GENERIC64_HEAPCODES over
	ONE_FREE_BIT_HEAPCODES always.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Do not use a global register variable as return value for SPARC64.
	* arisparc64.d (asm_mulu32_64): Renamed from asm_mulu32_.
	Return 64 bits in %o0.
	(asm_divu_6432_3232_): Return 64 bits in %o0.
	(asm__get_g1): Remove function.
	* arilev0.d (mulu32, mulu32_, mulu32_64, divu_6432_3232,
	divu_6432_3232_) [SPARC64]: Update accordingly.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Fix bug#542: Do not use a global register variable as return value for SPARC.
	* arisparc.d (asm_mulu32_64): Renamed from asm_mulu32_. Return 64 bits
	in %o1,%o0, not %o0,%g1.
	(asm_divu_6432_3232_): Return 64 bits in %o1,%o0, not %o0,%g1.
	(asm_divu_loop_up, asm_divucopy_loop_up): Update accordingly.
	(asm__get_g1): Remove function.
	* arilev0.d (mulu32, mulu32_, mulu32_64, divu_6432_3232,
	divu_6432_3232_) [SPARC && !SPARC64]: Update accordingly.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Optimize arisparc.d also with Sun C and also for SPARCv9.
	* arisparc.d (sparcv8): Set also with Sun "cc -xarch=v8". Set also when
	compiling for SPARC v9, not v8.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Allow adding -DNO_ARI_ASM to the Makefile, without reconfiguring.
	This fixes a link error (conflict between ari*.o and lisparit.o).
	It is simpler to prefix all functions defined in assembly-language with
	'asm_' than to #define selected function names with '_generic' suffix
	if they are defined in C.
	* ari80386.d, ariarm.d, arihppa.d, arimips*.d, arisparc*.d: Prefix the
	names of all exported functions with 'asm_'.
	* arilev0.d: Remove all *_ -> _generic redirects.
	(mulu16): Use asm_mulu16_ instead of mulu16_.
	(mulu32, mulu32_64): Use asm_mulu32_ instead of mulu32_, asm__get_g1
	instead of _get_g1.
	(mulu32_unchecked): Use asm_mulu32_unchecked instead of
	mulu32_unchecked.
	(divu_3216_1616): Use asm_divu_3216_1616_ instead of divu_3216_1616_.
	(divu_6432_3232): Use asm_divu_6432_3232_ instead of divu_6432_3232_.
	* arilev1e.d: Redirect *_loop_* -> asm_*_loop_* at the preprocessor
	level.
	* intlog.d (integerlength32): Use asm_length32 instead of length32.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Remove unused assembly-language code.
	* arihppa.d: Remove unused code.
	* arilev0.d: Remove HPPA_DIV_WORKS conditionals.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Allow adding -DNO_SP_ASM to the Makefile, without reconfiguring.
	This fixes a link error (conflict between sp*.o and spvw.o).
	* sp68000.d, sp80386.d, spmips.d, spsparc.d, spsparc64.d: Prefix all
	external symbols with 'asm_'.
	* lispbibl.d (getSP, setSP): Reference the external functions prefixed
	with 'asm_'.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Fix a crash if KERNELVOID32_HEAPCODES && SPVW_PAGES && DEBUG_SPVW.
	* spvw_global.d (check_gc_consistency): Take varobjects_misaligned
	into account.
	* spvw_global_old.d: Likewise.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Remove support for M88000 processors.
	* lispbibl.d (M88000): Remove definition. Do not test for M88000.
	* intlog.d (integerlength32): Remove special optimization for M88000.
	* makemake.in (XCFLAGS): Remove special handling of m88k, convex CPUs.

2017-11-19  Bruno Haible  <bruno@clisp.org>

	Remove support for VAX processors.
	It was never actually used or tested.
	* lispbibl.d (VAX): Remove definition. Do not test for VAX.
	* arilev0.d: Do not test for VAX.
	* arilev1.d: Likewise.
	* arivaxunix.d: Remove file.

2017-11-18  Bruno Haible  <bruno@clisp.org>

	Fix initialization of modules in SINGLEMAP_MEMORY model.
	Reported by Jean Louis <bugs@gnu.support> in bug#713.
	* utils/modprep.lisp (print-tables-2): Emit statements that store the
	keyword vectors of the SUBRs in their heap-allocated location, not in
	their preliminary location.
	* spvw.d (init_subr_tab_1): Set module->stab also if the module has no
	SUBRs. (Just a no-op.)

2017-11-18  Bruno Haible  <bruno@clisp.org>

	Allow clisp! scripts to have file names with spaces.
	* _clisp.c: Do not split argv[1] if it looks like a file name.

2017-11-18  Bruno Haible  <bruno@clisp.org>

	Allow UTF-8 encoded hard space in first argument of clisp! invocation.
	* _clisp.c: Treat UTF-8 encoded hard space like ISO-8859-1 encoded hard
	space.

2017-11-18  Bruno Haible  <bruno@clisp.org>

	Allow file names with spaces to be passed as first argument to 'clisp'.
	Reported by Jean Louis <bugs@gnu.support> in bug#699.
	* _clisp.c: Disable the argv[1] splitting hack unless SHEBANG_SUPPORT
	is defined.
	* _distmakefile: Install a program 'clisp!' next to 'clisp'.
	* makemake.in (install-bin): Likewise.
	(uninstall-bin): Unstill 'clisp!'.

2017-11-17  Bruno Haible  <bruno@clisp.org>

	Revamp the installation documentation.
	* INSTALL.windows: New file, mostly borrowed from GNU gettext.
	* win32msvc/INSTALL: Mark as obsolete.
	* INSTALL: Mention INSTALL.windows.
	* DEPENDENCIES: New file.
	* HACKING: New file.

2017-11-17  Sam Steingold  <sds@gnu.org>

	Use UTF-8 for all PCRE strings.
	* modules/pcre/cpcre.c (PCRE:PCRE-COMPILE): Use UTF-8 even for
	error messages.
	(fullinfo_nametable): Use UTF-8 for pcre_fullinfo().
	(PCRE:PCRE-NAME-TO-INDEX): Use UTF-8 for pcre_get_stringnumber().

2017-11-17  Sam Steingold  <sds@gnu.org>

	* loop.lisp: Use revadd pervasively.
	Remove a spurious CASE clause.

2017-11-16  Sam Steingold  <sds@gnu.org>

	* clhs.lisp (starts-with-p): Extract and export.

2017-11-15  Sam Steingold  <sds@gnu.org>

	Improve loop error reporting.
	* loop.lisp (loop-syntax-error): Accept an optional location
	argument (nil means end of form).
	(expand-loop): Pass location to `loop-syntax-error'.

2017-11-15  Sam Steingold  <sds@gnu.org>

	Fix bug#711: DO in loop allows more expressions than the standard.
	* loop.lisp (expand-loop parse-progn): Check that all forms in
	implicit PROGNs are compound as implied by CLHS.

2017-11-14  Sam Steingold  <sds@gnu.org>

	Make it easier for users to customize completion.
	* complete.lisp (ext:longest-common-prefix): Extract from completion.
	(completion): Use it.
	(*completion*): Set to #'completion.
	(ext:make-completion): New function for users.
	* init.lisp (*completion*): Export from CUSTOM.
	(make-completion, longest-common-prefix): Export from EXT.
	* constsym.d: Replace COMPLETION with *COMPLETION*.
	* spvw.d (init_symbol_values): Define *COMPLETION*.
	* stream.d (lisp_completion): Use *COMPLETION* instead of COMPLETION.

2017-11-12  Bruno Haible  <bruno@clisp.org>

	Fix "Warning: reserving address range" on some Linux/x86_64 systems.
	Reported by Sam Steingold in bug#703.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_*): Tweak values for Linux/x86_64.
	(SINGLEMAP_TYPE_MASK): Likewise.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/hppa.
	* Makefile.devel (multibuild-linux-hppa): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/hppa, enable all optimizations
	except ASM, ARI_ASM, SP_ASM.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/x86_64-x32.
	* Makefile.devel (multibuild-linux-x86_64-32): Enable all build variants
	that work.
	* makemake.in (XCFLAGS): For Linux/x86_64-x32, enable all optimizations
	except ASM, ARI_ASM, SP_ASM.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/i386.
	* Makefile.devel (multibuild-linux-i386): Enable all build variants
	that work.
	(multibuild-linux-x86): Remove target.
	* makemake.in (XCFLAGS): For Linux/i386, enable all optimizations
	except ASM, ARI_ASM, SP_ASM.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Enable most optimizations on Linux/x86_64.
	* Makefile.devel (multibuild-linux-x86_64): Enable all build variants.
	* makemake.in (XCFLAGS): For Linux/x86_64, enable all optimizations
	except ASM, ARI_ASM, SP_ASM.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	New option --cbcx that includes "make extracheck".
	* configure: Accept option --cbcx.
	* Makefile.devel (build-porting*): Use option --cbcx instead of --cbc.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Prepare for enabling optimizations on a per-platform basis.
	* makemake.in (enable_portability): Allow three values: no, ifuseful,
	yes.
	(XCFLAGS): Add flags that disable optimizations that have not yet been
	verified to work, for each platform.
	* Makefile.devel (build-porting*): Configure with option
	--disable-portability.
	(multibuild-*): New targets, one per platform.
	* unix/PLATFORMS: Explain the per-platform porting process.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	New heuristics for deciding which object representation to use.
	* lispbibl.d (TYPECODES, HEAPCODES): New logic which one to choose by
	default.
	(ONE_FREE_BIT_HEAPCODES, KERNELVOID32_HEAPCODES, GENERIC64_HEAPCODES):
	Likewise.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Avoid known unsupported features on specific platforms.
	* lispbibl.d (TRIVIALMAP_MEMORY): Do not enable by default on Cygwin
	and in a specific case on Linux/m68k.
	(GENERATIONAL_GC): Do not enable by default on NetBSD, Linux/hppa,
	Linux/m68k.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Tweak support for Haiku.
	* lispbibl.d (TRIVIALMAP_MEMORY): Do not enable by default on Haiku.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Record whether GENERIC64C_HEAPCODES works.
	* lispbibl.d (GENERIC64C_HEAPCODES_WORKS): Define for each 64-bit
	platform.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Record whether KERNELVOID32_HEAPCODES works.
	* lispbibl.d (KERNELVOID32_HEAPCODES_WORKS): Define for each 32-bit
	platform.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Find good parameters for using ONE_FREE_BIT_HEAPCODES, per platform.
	* lispbibl.d (garcol_bit_o, imm_type_shift, oint_type_*, oint_addr_*):
	Find appropriate values for ONE_FREE_BIT_HEAPCODES, depending on
	TRIVIALMAP_MEMORY.
	(HEAPCODES1BIT_WITH_TRIVIALMAP_WORKS, HEAPCODES1BIT_WITH_MALLOC_WORKS):
	Define for each platform.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Check the mymalloc return value also when ONE_FREE_BIT_HEAPCODES.
	* spvw_allocate.d (pointable_usable_test): For ONE_FREE_BIT_HEAPCODES,
	check against the garcol_bit.
	(fprint_mymalloc_diagnostic): New function.
	(mymalloc): Use it.
	* spvw_allocate_old.d: Likewise.
	* spvw.d (init_memory): Use fprint_mymalloc_diagnostic.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Find good parameters for using TYPECODES model, for each platform.
	* lispbibl.d (TRIVIALMAP_MEMORY): Move definition up, before the
	decision between TYPECODES and HEAPCODES.
	(oint_type_*, oint_addr_*, garcol_bit_o): Find appropriate values for
	TYPECODES, for selected platforms.
	(TYPECODES_WITH_TRIVIALMAP_WORKS, TYPECODES_WITH_MALLOC_WORKS): Define
	for each platform.
	* Makefile.devel (build-porting*-typecodes-spvw_mixed_blocks): Split
	into build-porting*-typecodes-spvw_mixed_blocks-malloc
	and build-porting*-typecodes-spvw_mixed_blocks-trivialmap.
	(build-porting*-one_free_bit_heapcodes): Split into
	build-porting*-one_free_bit_heapcodes-malloc and
	build-porting*-one_free_bit_heapcodes-trivialmap, accordingly.
	(build-porting*-try1_typecodes, build-porting*-try2_typecodes): Remove
	targets.
	(build-porting32-*-kernelvoid32_heapcodes)
	(build-porting64-*-generic64_heapcodes): Do not prevent the use of
	GENERATIONAL_GC.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Update support for Linux/hppa and Linux/m68k.
	I learned how to use these platforms with dynamic linking, see
	<https://bugs.launchpad.net/qemu/+bug/1701798/>.
	* lispbibl.d (SINGLEMAP_WORKS): Update value for Linux/hppa, Linux/m68k.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Tweak support for Linux/sparc.
	* lispbibl.d (CODE_ADDRESS_RANGE) [Linux/sparc]: Force the same value
	across machines.
	(SINGLEMAP_*) [Linux/sparc]: Change parameters. But it does not work.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/m68k.
	* lispbibl.d (sintW): Emit into clisp.h. It is used by the expansion of
	macro 'dotimespC'.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Fix unnecessary error when oint_addr_mask != 2^oint_addr_len-1.
	* spvw.d (bits_used_by_range): Move up.
	* spvw_allocate.d (pointable_usable_test): Do not assume that
	oint_addr_mask == 2^oint_addr_len-1.
	(mymalloc): Use pointable_usable_test to test the entire returned
	address range.
	* spvw_allocate_old.d: Likewise.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Fix crash on SPARC when oint_addr_mask != 2^oint_addr_len-1.
	* lispbibl.d (untype) [SPARC]: Make it work also when oint_addr_mask is
	not 2^oint_addr_len-1. Optimize also for 64-bit SPARC.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Avoid build error "Bogus header_flags -- redefine header_flags!".
	* lisbibl.d (hfint): Choose hfint depending on oint_type_shift, instead
	of depending on CPU.

2017-11-11  Bruno Haible  <bruno@clisp.org>

	Fix compilation warnings introduced on 2017-11-03.
	* lispbibl.d (NO_ASM, NO_ARI_ASM, NO_FAST_DISPATCH): Do not redefine if
	already defined.

2017-11-05  Bruno Haible  <bruno@clisp.org>

	Tweak mappable address ranges.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_END): Shrink a bit for Linux/mips
	(o32 and n32 ABIs), for Mac OS X/PowerPC, for Linux/alpha (based on
	findings with older Linux versions).
	Update SINGLEMAP_* parameters for Linux/alpha accordingly.
	Add MAPPABLE_ADDRESS_RANGE_* for FreeBSD/alpha, NetBSD/alpha,
	OSF/1/alpha (based on older findings).

2017-11-03  Bruno Haible  <bruno@clisp.org>

	Avoid assembler or linker errors due to assembly during current testing.
	This can be removed once ARI_ASM and SP_ASM generally works.
	* Makefile.devel (build-porting*): In builds with -DSAFETY=3, use also
	-DNO_ARI_ASM -DNO_SP_ASM.

2017-11-02  Bruno Haible  <bruno@clisp.org>

	Fix a "make check" hang on IRIX.
	* makemake.in (check-script): Work around the AIX peculiarity also on
	IRIX.

2017-11-02  Bruno Haible  <bruno@clisp.org>

	Support building with 'gmake' instead of 'make'.
	* configure (MAKE): New variable. Use it instead of hardcoding 'make'.
	* Makefile.devel (MAKE): Remove variable. All common 'make' programs
	set MAKE to a reasonable value (the value of the environment variable
	'MAKE' or the name of the current program) by default.

2017-11-02  Bruno Haible  <bruno@clisp.org>

	Avoid error on IRIX when stdout is a pipe (regression from 2016-11-11).
	* stream.d (IS_EINVAL_EXTRA): Handle IRIX.
	(finish_tty_output): Use IS_EINVAL instead of testing only for EINVAL.

2017-11-02  Bruno Haible  <bruno@clisp.org>

	Skip a test that would request more space than available.
	* tests/lists153.tst: Disable huge allocation tests on 32-bit platforms
	with TYPECODES.

2017-11-02  Bruno Haible  <bruno@clisp.org>

	Fix a build failure with SINGLEMAP_MEMORY (regression from 2017-11-01).
	Reported by Don Cohen.
	* lispbibl.d (oint_addr_mask): Fix big mistake in expression.

2017-11-01  Bruno Haible  <bruno@clisp.org>

	Work around HP-UX cc crash.
	* makemake.in (XCFLAGS): Remove '-g' if we are using HP-UX cc.

2017-11-01  Bruno Haible  <bruno@clisp.org>

	Fix build failure when oint_type_shift has an unusual value.
	* lispbibl.d (mtypecode): Define a fallback when no optimized definition
	is possible.

2017-11-01  Bruno Haible  <bruno@clisp.org>

	Fix small problem in 2017-10-28 change.
	* lispbibl.d (oint_addr_mask): Make sure evaluation in preprocessor
	directives produces the right value.

2017-10-31  Bruno Haible  <bruno@clisp.org>

	Apply TRIVIALMAP's memory allocation also to the STACK area.
	* lispbibl.d (TRIVIALMAP_MEMORY_STACK): New macro. When it is defined,
	do not check oint_addr_mask against MALLOC_ADDRESS_RANGE.
	* spvw.d (init_memory) [TRIVIALMAP_MEMORY_STACK]: Allocate the stack
	range in [MAPPABLE_ADDRESS_RANGE_START, MAPPABLE_ADDRESS_RANGE_END],
	rather than through mymalloc.

2017-10-30  Bruno Haible  <bruno@clisp.org>

	Add early detection of a problem that would lead to crashes later.
	Seen on Linux/sparc64.
	* spvw.d (bits_used_by_range): New function.
	(init_memory): Verify that the range used for STACK is adequate.

2017-10-30  Bruno Haible  <bruno@clisp.org>

	Fix socket operations on native Windows (regression from 2011-07-19).
	Since we use the gnulib wrappers for socket operations, we must test
	errno, not WSAGetLastError().
	* win32aux.d (lowlevel_fd_read, fd_read, fd_write): Fix documentation.
	(do_sock_read): Use errno, not WSAGetLastError().
	(sock_read): Set errno, not WSAGetLastError().
	(do_sock_write): Use errno, not WSAGetLastError().
	(sock_write): Set errno, not WSAGetLastError().
	* stream.d (fd_error_eof_p): Renamed from error_eof_p. Do not test
	against WSAESHUTDOWN.
	(low_read_array_unbuffered_handle, low_fill_buffered_handle): Update.
	(CHECK_INTERRUPT): Test errno, not WSAGetLastError().
	(sock_error_eof_p): New function.
	(low_read_unbuffered_socket, low_listen_unbuffered_socket,
	low_read_array_unbuffered_socket, low_fill_buffered_socket): Invoke
	sock_error_eof_p instead of error_eof_p.

2017-10-30  Bruno Haible  <bruno@clisp.org>

	Add support for Haiku.
	* lispbibl.d (unix): Define on Haiku.
	(UNIX_HAIKU): New macro.
	(UTF8_CHS): Define on Haiku.
	(STACK_register): Treat Haiku like BeOS.
	(local): Move definition down.
	(MAPPABLE_ADDRESS_RANGE_*): Define for Haiku.
	(SINGLEMAP_*): Define for Haiku.
	* unix.d (ualarm): On Haiku, use past POSIX prototype.
	* spvw.d (init_object_tab): Add :HAIKU to *features*.
	* errunix.d (OS_error_internal): Change argument type to 'int', because
	errno values are negative on Haiku.
	(OS_error, OS_error_arg): Change type of 'errcode' to 'int'.
	* stream.d (IS_EINVAL_EXTRA): On Haiku, include EPERM.
	(handle_pathname): On BeOS and Haiku, return NIL.
	* makemake.in (check-script): Do not run unportable test on BeOS and
	Haiku.
	* m4/tcpconn.m4 (CL_TCPCONN): Require gl_SOCKETLIB. Consider LIBSOCKET
	when testing for setsockopt and getsockopt.
	* aclocal.m4, src/configure: Regenerated.
	* modules/rawsock/configure, modules/rawsock/config.h.in: Likewise.

2017-10-30  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure: Regenerated.

2017-10-30  Bruno Haible  <bruno@clisp.org>

	Provide more understandable GCC diagnostics.
	* makemake.in (XCFLAGS): For gcc >= 4.8, add '-no-integrated-cpp'.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Make (truename "/dev/fd/1") work on Cygwin.
	* pathname.d (my_realpath): Add special treatment of /dev/fd on Cygwin.
	(get_path_info): Optimize number of readlink() calls.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Fix endless loop in TRUENAME on Cygwin (regression from 2017-03-14).
	* pathname.d (get_path_info): When retrying readlink(), choose a buffer
	size that is greater than the previous one.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Do not use symbolic links when building for native Windows.
	* makemake.in (LN_S): For native Windows, ignore the autoconfigured
	value.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Do not assume that (truename (make-stream :output)) works on Windows.
	* makemake.in (check-script): Do not run unportable test on native
	Windows.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Fix 32-bit mingw build failure on 64-bit Cygwin.
	* configure.in: Determine WINDRES variable.
	* makemake.in (clispres.o): Use it.
	* src/configure, gllib/Makefile.in: Regenerated.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Use SINGLEMAP_MEMORY by default on most 64-bit platforms.
	* lispbibl.d: Revise decision whether to use SINGLEMAP_MEMORY: Ignore
	MMAP_FIXED_ADDRESS_HIGHEST_BIT (since the SINGLEMAP_* parameters handle
	this more precisely). Do not disable it on Linux/s390x (where it actually
	works). Do not disable it in MULTITHREAD mode.

2017-10-28  Bruno Haible  <bruno@clisp.org>

	Make SINGLEMAP_MEMORY work reliably on many platforms.
	* Makefile.devel (build-porting*-spvw_pure_blocks): Do not disable
	GENERATIONAL_GC when testing this configuration.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_*): Define separately for mips o32
	and mips n32.
	(SINGLEMAP_ADDRESS_BASE, SINGLEMAP_TYPE_MASK, SINGLEMAP_oint_type_shift,
	SINGLEMAP_garcol_bit_o, SINGLEMAP_oint_type_len,
	SINGLEMAP_oint_type_mask, SINGLEMAP_WORKS): Define appropriately for
	each known platform.
	(oint_type_*, oint_addr_*, oint_data_*) [SINGLEMAP_MEMORY]: Define based
	on these parameters.
	(TB7, ..., TB0) [SINGLEMAP_MEMORY]: Define based on garcol_bit_o and
	oint_type_mask.
	(garcol_bit_o): Do not redefine if already defined for SINGLEMAP_MEMORY.
	(SINGLEMAP_MEMORY_STACK): Define always when SINGLEMAP_MEMORY is
	defined.
	(pointable_address_unchecked) [SINGLEMAP_MEMORY]: Ignore
	addressbus_mask.
	(subr_tab_addr, symbol_tab_addr) [SINGLEMAP_MEMORY]: Consider
	SINGLEMAP_ADDRESS_BASE.
	* spvw.d (init_memory): When we do not need malloc()ed memory at all,
	do not call mymalloc.
	If SINGLEMAP_MEMORY && !IGNORE_MAPPABLE_ADDRESS_RANGE, verify that all
	heaps lie in the mappable address range.
	Consider SINGLEMAP_ADDRESS_BASE.

2017-10-27  Bruno Haible  <bruno@clisp.org>

	Fix fixnum converter macros on SPARC64.
	* lispbibl.d (posfixnum_to_V): Optimize on SPARC always.
	(fixnum_to_V) [SPARC]: Fix expression.

2017-10-27  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure, modules/*/configure: Regenerated.

2017-10-25  Bruno Haible  <bruno@clisp.org>

	Fix build failure on 64-bit platforms with oint_addr_len==32.
	* lispbibl.d (SPint): Define as uintP.

2017-10-25  Bruno Haible  <bruno@clisp.org>

	Small code cleanup.
	* package.d (rehash_symtab): Remove leftover code from 2009-10-07.

2017-10-24  Bruno Haible  <bruno@clisp.org>

	Improve code structure.
	* foreign.d: Reorder functions, to avoid forward declarations.
	* subr.d: Update.
	* constsym.d: Update.

2017-10-24  Bruno Haible  <bruno@clisp.org>

	Code style.
	* foreign.d: Use 'var' for local variable declarations.

2017-10-24  Bruno Haible  <bruno@clisp.org>

	Fix compilation errors on HP-UX (regression from 2008-03-12).
	* unix.d: On HP-UX, undefine also HAVE_DLADDR etc.
	* foreign.d (foreign_library_variable, foreign_library_function):
	Fix declaration to match the one on the other platforms.

2017-10-24  Bruno Haible  <bruno@clisp.org>

	Do not assume that /dev/fd[012] exists on AIX and HP-UX.
	* stream.d (handle_pathname): On AIX and HP-UX, return NIL.
	* makemake.in (check-script): Do not run unportable test on AIX and
	HP-UX.

2017-10-24  Bruno Haible  <bruno@clisp.org>

	Fix the error message of TRUENAME on a nonexistent file.
	* pathname.d (my_realpath): Define always.
	(realpath_is_my_realpath): New macro.
	(realpath_obj): Invoke realpath, then my_realpath in case of error
	ENOENT.

2017-10-23  Bruno Haible  <bruno@clisp.org>

	Fix an endless recursion during "make check" on AIX.
	* stream.d (IS_EINVAL_EXTRA): On AIX, include the ENODEV errors.

2017-10-23  Bruno Haible  <bruno@clisp.org>

	Fix a "make check" hang on AIX.
	* makemake.in (check-script): Work around an AIX peculiarity.

2017-10-23  Bruno Haible  <bruno@clisp.org>

	Make intparam.c compile with g++ >= 6.
	Reported by Sam Steingold in bug#709.
	* intparam.c (main9, get_stack_direction): Do not use the C keyword
	'auto'.

2017-10-22  Bruno Haible  <bruno@clisp.org>

	Avoid link errors when passing -DNO_ARI_ASM or -DNO_SP_ASM in CPPFLAGS.
	* makemake.in (ARI_ASMD, ARI_ASMS): Test whether XCFLAGS or XCPPFLAGS
	contains -DNO_ARI_ASM. Do not test for --enable-portability directly.
	(SP_ASMS, SP_ASMD): Test whether XCFLAGS or XCPPFLAGS contains
	-DNO_SP_ASM. Do not test for --enable-portability directly.

2017-10-22  Bruno Haible  <bruno@clisp.org>

	Improve decision whether to use symbolflags or not.
	* lispbibl.d (oint_symbolflags_shift, NO_symbolflags): Define depending
	on sizeof_symbol_is_multiple_of_varobject_alignment and alignment_long.

2017-10-22  Bruno Haible  <bruno@clisp.org>

	Improve decision whether to require varobject_alignment for symbols.
	* lispbibl.d (MAP_MEMORY_TABLES): Move up.
	(varobject_alignment): Add comment.
	(sizeof_symbol_is_multiple_of_varobject_alignment): New macro.
	(symbol_): Add filler word if necessary to ensure appropriate size.
	Define 'symbol_has_symfiller' if so.
	* constsym.d (LISPSYM_B): Test 'symbol_has_symfiller'. Define through
	auxiliary macros SYM_VAROBJECT_HEADER_INIT1, SYM_VAROBJECT_HEADER_INIT2,
	SYM_SYMFILLER_INIT, SYM_TLS_INDEX_INIT.

2017-10-22  Bruno Haible  <bruno@clisp.org>

	Clarify which compilers can align global variables.
	* lispbibl.d (HAVE_GLOBAL_VAR_ALIGN): New macro.
	* spvwtabf.d (subr_tab_data): Mention it in comment.
	* spvwtabs.d (symbol_tab_data): Likewise.

2017-10-22  Bruno Haible  <bruno@clisp.org>

	Avoid redefinition warnings.
	* lispbibl.d (TYPECODES, KERNELVOID32_HEAPCODES, GENERIC64_HEAPCODES,
	HEAPCODES, SINGLEMAP_MEMORY, GENERATIONAL_GC): Do not define if already
	defined.

2017-10-19  Bruno Haible  <bruno@clisp.org>

	Fix GC crash when cleaning weak hash table (regression from 2004-05-09).
	* hashtabl.d (prepare_resize): Pre-fill the new index-vector with "nix".

2017-10-19  Bruno Haible  <bruno@clisp.org>

	Readd currently redundant check, in comments.
	* hashtabl.d (prepare_resize): Readd test removed on 2012-03-10, but
	keep it disabled.

2017-10-19  Bruno Haible  <bruno@clisp.org>

	Fix build failure with DEBUG_GCSAFETY (regression from 2017-10-14).
	* makemake.in (gen.lispbibl.c): Replace 'print' statements with fprint
	statements.

2017-10-18  Bruno Haible  <bruno@clisp.org>

	Fix compilation failure with DEBUG_SPVW & SPVW_PURE & GENERATIONAL_GC.
	* spvw_global.d (mem): Remove heapnr_from_type field.
	(HAVE_HEAPNR_FROM_TYPE): Remove macro.
	(init_mem_heapnr_from_type): Remove function.
	(typecode_to_heapnr): New macro.
	* spvw_global_old.d: Likewise.
	* spvw_garcol.d (update): Use typecode_to_heapnr instead of
	mem.heapnr_from_type array.
	* spvw_garcol_old.d: Likewise.
	* spvw_genera1.d (rebuild_old_generation_cache, gc_check_at): Likewise.
	* spvw_genera1_old.d: Likewise.
	* spvw.d (init_memory): Update.

2017-10-18  Bruno Haible  <bruno@clisp.org>

	Fix build failure with cc on IRIX.
	* foreign.d (do_av_start): Access the 'flags' field only on Windows.

2017-10-18  Bruno Haible  <bruno@clisp.org>

	Fix build failure with pre-C99 compilers (regression from 2008-10-29).
	* spvw_allocate.d (allocate): Use braces at variable declarations after
	statements.

2017-10-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/arm64 with CC="arm-linux-gnueabihf-gcc-4.8".
	* lispbibl.d (C_CODE_ALIGNMENT) [ARM]: Set to 1.

2017-10-16  Bruno Haible  <bruno@clisp.org>

	Avoid a crash of the highest bit number test on Linux/arm.
	* m4/mmap.m4 (CL_MMAP): On arm systems, test address 0x41000000 instead
	of address 0x40000000.
	* aclocal.m4, src/configure: Regenerated.

2017-10-16  Bruno Haible  <bruno@clisp.org>

	Avoid another risky optimization when --enable-portability is enabled.
	* lispbibl.d: When NO_SYMBOLFLAGS is defined, do not use symbolflags.
	* makemake.in (XCFLAGS): Add -DNO_SYMBOLFLAGS if --enable-portability
	is specified.

2017-10-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/s390x.
	* makemake.in: When compiling lisparit.c with GCC for s390x, reduce
	optimizations.

2017-10-15  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/sparc64.
	* makemake.in: When compiling eval.c with GCC for sparc64, disable
	optimizations.

2017-10-15  Bruno Haible  <bruno@clisp.org>

	Avoid another dangerous code when --enable-portability is enabled.
	* eval.d (closure_register, byteptr_register): Do not define if
	NO_ASM is defined.

2017-10-15  Bruno Haible  <bruno@clisp.org>

	Improve code structure.
	* lispbibl.d: Reorder a #if cascade.

2017-10-14  Bruno Haible  <bruno@clisp.org>

	Use only mappable addresses in TRIVIALMAP_MEMORY.
	* lispbibl.d (TRIVIALMAP_MEMORY): Do not enable if
	MAPPABLE_ADDRESS_RANGE_START or MAPPABLE_ADDRESS_RANGE_END are not
	defined.
	* spvw.d (init_memory) [TRIVIALMAP_MEMORY]: Obey
	MAPPABLE_ADDRESS_RANGE_START and MAPPABLE_ADDRESS_RANGE_END. Remove the
	previous unreliable heuristics.

2017-10-14  Bruno Haible  <bruno@clisp.org>

	Simplify makemake.in.
	* makemake.in (echotabpipe): Remove function. Use 'echotab' instead.

2017-10-14  Bruno Haible  <bruno@clisp.org>

	Make genclisph check for errors on its output files.
	* genclisph.d: Take the header output file as first argument. The
	test output file is no longer optional. Check fclose result on all
	output streams. Emit logging output to stdout, not stderr.
	* makemake.in (gen.lispbibl.c): Replace 'puts' and 'printf' statements
	with fprintf statements.
	(clisp.h): Use clisp.h.tmp as temporary header output file.

2017-10-14  Bruno Haible  <bruno@clisp.org>

	Make genclisph code clearer.
	* genclisph.d (check_typecodes): Check test_f value not here...
	(main): ... but here.

2017-10-14  Bruno Haible  <bruno@clisp.org>

	Fix build failure with TYPECODES (regression from 2010-10-08).
	* genclisph.d (check_typecode_entry): Check array_simplep only for
	typecodes of array types.

2017-10-13  Bruno Haible  <bruno@clisp.org>

	Fix warning in clisp-test.c (regression from 2017-08-24).
	* genclisph.d (check_typecodes): Fix %-escape mistake.

2017-10-13  Bruno Haible  <bruno@clisp.org>

	Tweak mappable address range for Linux/x86_64.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE_END): Shrink a bit.

2017-10-12  Bruno Haible  <bruno@clisp.org>

	Verified mappable address range for Solaris 11.
	* lispbibl.d: Add comments about Solaris 11.

2017-10-12  Bruno Haible  <bruno@clisp.org>

	Guarantee a page boundary between the growing and shrinking heap_limits
	in case of GENERATIONAL_GC && SPVW_MIXED_BLOCKS.
	* spvw_allocate.d (make_space_gc_true, make_space_gc_false): Round to
	physpagesize, not map_pagesize, if GENERATIONAL_GC is enabled.
	* spvw_fault.d (handle_fault): Drop the requirement that
	SIGSEGV_FAULT_ADDRESS_ALIGNMENT be 1.
	* spvw_fault_old.d (handle_fault): Likewise.
	* lispbibl.d (GENERATIONAL_GC): Define without considering the value of
	SIGSEGV_FAULT_ADDRESS_ALIGNMENT.

2017-10-12  Bruno Haible  <bruno@clisp.org>

	Fix mistake in "highest bit number" test (regression from 2017-10-08).
	* m4/mmap.m4 (CL_MMAP): Update after value of cache variable changed.
	* aclocal.m4, src/configure: Regenerated.

2017-10-08  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.

2017-10-08  Bruno Haible  <bruno@clisp.org>

	Define mappable address range for many platforms.
	* lispbibl.d (UNIX_GNU_FREEBSD, UNIX_IRIX): New macros.
	(MAPPABLE_ADDRESS_RANGE_START, MAPPABLE_ADDRESS_RANGE_END): Define for
	many platforms.
	(ADDRESS_RANGE_RANDOMIZED): Do not define on OpenBSD.

2017-10-08  Bruno Haible  <bruno@clisp.org>

	New option "-marc" for mappable address range check.
	* spvw.d (mappable_address_range_check): New function.
	(parse_options): New option "-marc".
	* makemake.in: New target 'marc.out'.
	(all): Depend on it.
	(clean1): Remove it.

2017-10-08  Bruno Haible  <bruno@clisp.org>

	Emit the output of "lisp.run -mm" to stdout, not stderr.
	* win32.d (DumpProcessMemoryMap): Accept a FILE* argument.
	* win32aux.d (DumpProcessMemoryMap): Likewise.
	* spvw.d (dump_process_memory_map_callback): Likewise.
	(dump_process_memory_map): Likewise.
	(parse_options): Pass stdout.
	* spvw_mmap.d (warn_before_reserving_range, mmap_prepare): Pass stderr.

2017-10-08  Bruno Haible  <bruno@clisp.org>

	Fix misuse of Autoconf cache.
	* m4/mmap.m4 (CL_MMAP): Put the complete test result in a single *_cv_*
	variable.
	* aclocal.m4, src/configure: Regenerated.

2017-10-08  Bruno Haible  <bruno@clisp.org>

	Fix build failure with pre-C99 compilers (regression from 2017-03-14).
	* spvw_mmap.d: Use 'var' where appropriate.
	* pathname.d: Put (void)param statements first.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Properly recognize PowerPC64 CPU on AIX.
	* lispbibl.d (POWERPC64): Define also when _ARCH_PPC64 is defined.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Fix error when creating lispbibl.h on AIX.
	* makemake.in (lispbibl.h): Start the command with '( (', not '(('.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* gllib/*: Update from gnulib.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Fix false alarm about mmap on DragonFly BSD.
	* spvw_mmap.d (mincore_works): New variable.
	(mincore_init): Initialize it.
	(warn_before_mmap): Do nothing if mincore_works is false.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Relax the Autoconf test for mmap with MAP_FIXED.
	* m4/mmap.m4 (CL_MMAP): Test only whether mmap with MAP_FIXED works
	for some address.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Remove support for Sun-4 machines prior to Sun-4m.
	* m4/mmap.m4 (CL_MMAP): Do not define HAVE_MMAP_DEVZERO_SUN4_29.
	* configure.in: Update comment.
	* makemake.in (XCFLAGS): Do not define SUN4_29.
	* lispbibl.d: Remove tests of SUN4_29.
	* unix.d: Simplify accordingly.
	* spvw.d (init_memory): Remove SUN4_29 special case.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Update after the newest change in libsigsegv's API.
	* spvw_mmap.d (system_pagesize): New variable.
	(mmap_init_pagesize): Initialize it.
	* spvw_fault.d (handle_fault): Use system_pagesize instead of the
	(constant) value of SIGSEGV_FAULT_ADDRESS_ALIGNMENT.
	* spvw_fault_old.d (handle_fault): Likewise.

2017-10-07  Bruno Haible  <bruno@clisp.org>

	Fix compilation error on FreeBSD (regression from 2017-10-06).
	* m4/vadvise.m4: New file.
	* configure.in: Invoke CL_VADVISE.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-06  Bruno Haible  <bruno@clisp.org>

	Fix compilation error on NetBSD 8 beta.
	* unix.d (vadvise): Assume it is declared in <sys/vadvise.h>.
	* configure.in: Do not invoke CL_VADVISE. Just check for vadvise instead.
	* m4/vadvise.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Autoconf macros: Use AS_HELP_STRING systematically.
	AS_HELP_STRING ensures proper column alignment.
	Note that its first argument must be double quoted, otherwise brackets
	in the argument are discarded if they are not escaped as trigraphs.
	* m4/clisp.m4 (CL_CLISP): Fix indentation and quoting style.
	* m4/ffcall.m4 (CL_FFCALL): Talk about GNU libffcall. Use AS_HELP_STRING
	instead of AC_HELP_STRING.
	* m4/readline.m4 (CL_READLINE): Talk about GNU readline. Use
	AS_HELP_STRING instead of AC_HELP_STRING.
	* m4/termcap.m4 (CL_TERMCAP): Use AS_HELP_STRING.
	* m4/lightning.m4 (CL_LIGHTNING): Fix quoting style.
	* aclocal.m4, src/configure, modules/*/configure: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Fix signal blocking handling (regression from 2008-05-25).
	* m4/signal.m4 (CL_SIGNAL_UNBLOCK, CL_SIGNAL_BLOCK_OTHERS,
	CL_SIGACTION_UNBLOCK): Remove test of now nonexistent variable
	$signalblocks.
	* aclocal.m4, src/configure: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: <termio.h>, <sys/termio.h>, <sgtty.h> are not needed.
	All current platforms that have one of these also have <termios.h>.
	* unix.d: Assume that if HAVE_TERMIOS_H is not defined,
	HAVE_SYS_TERMIO_H, HAVE_TERMIO_H, HAVE_SGTTY_H are not defined either.
	* m4/ioctl.m4 (CL_IOCTL): Likewise.
	* stream.d: Remove code for UNIX_TERM_TERMIO and UNIX_TERM_SGTTY.
	* m4/termios.m4 (CL_TERM): Do not test for termio.h, sys/termio.h,
	sgtty.h.
	* configure.in: Update comment.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume that <termios.h> has tcgetattr() and TCSAFLUSH.
	* unix.d: Assume that HAVE_TERMIOS_H implies HAVE_TCGETATTR and
	HAVE_TCSAFLUSH.
	* m4/ioctl.m4 (CL_IOCTL): Likewise.
	* m4/termios.m4 (CL_TERM): Do not test for tcgetattr and TCSAFLUSH.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume that <sys/ptem.h> is not needed for 'struct winsize'.
	'struct winsize' is found in <sys/ioctl.h> on all current platforms.
	* unix.d: Assume WINSIZE_NEED_SYS_PTEM_H is not defined.
	* m4/termios.m4 (CL_TERM): Do not test for <sys/ptem.h>.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume that getpagesize() exists on all Unix platforms.
	* spvw_mmap.d (mmap_init_pagesize): Do not use SHMLBA nor Solaris
	2.4 fallbacks.
	* unix.d: Do not include <sys/ipc.h>, <sys/shm.h>,
	<sys/sysmacros.h>, <sys/vmmac.h>.
	* configure.in: Do not invoke CL_SHM_H, CL_SHM.
	* m4/shm.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Ensure compatibility of .mem file between NetBSD/sparc architectures.
	* spvw_mmap.d (mmap_init_pagesize): Choose 8192 on any SPARC platform.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume that getrusage() is properly declared.
	* unix.d (getrusage): Remove declaration.
	* m4/rusage.m4 (CL_RUSAGE): Do not define RUSAGE_WHO_T.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Remove unused code in Autoconf macros.
	* configure.in: Do not invoke CL_RLIMIT. Instead, check for getrlimit.
	* modules/syscalls/configure.in: Do not invoke CL_RLIMIT. Instead,
	check for getrlimit, setrlimit, and determine sizeof(rlim_t).
	* src/m4/rlimit.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Remove unused autoconf test.
	* configure.in: Do not invoke CL_MSYNC.
	* m4/msync.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Drop support for old Mac OS Rhapsody.
	* lispbibl.d (UNIX_RHAPSODY, UNIX_DARWIN): Remove macros.
	Test UNIX_MACOSX instead of UNIX_DARWIN everywhere.
	* unix.d: Remove special code for UNIX_RHAPSODY.
	* spvw.d, stream.d, socket.d: Test UNIX_MACOSX instead of UNIX_DARWIN.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume that caddr_t is a typedef equivalent to 'char *'.
	* m4/mmap.m4 (CL_MMAP): Use 'char*' instead of 'caddr_t'.
	* stream.d (clear_tty_input, finish_tty_output, clear_tty_output): Use
	'char*' instead of 'CADDR_T'.
	* configure.in: Do not invoke CL_CADDR_T.
	* m4/caddr_t.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Remove unused code in Autoconf macros.
	* m4/ioctl.m4 (CL_IOCTL): Do not define IOCTL_REQUEST_T, IOCTL_DOTS,
	IOCTL_ARGUMENT_T.
	* configure.in: Update comment.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume ANSI C or C++ in Autoconf macros.
	* m4/as-underscore.m4: Use ANSI C prototypes.
	* m4/signal.m4: Likewise.
	* aclocal.m4, src/configure: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Remove workaround against ancient systems with old waitpid declaration.
	* unix.d (waitpid, wait2): Use pid_t instead of PID_T.
	* unixaux.d (wait2): Likewise.
	* configure.in: Do not invoke CL_WAITPID.
	* m4/waitpid.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Remove workaround against ancient systems with hidden ELOOP macro.
	* pathname.d (realpath, get_path_info): Use ELOOP, not ELOOP_VALUE.
	* configure.in: Do not invoke CL_ELOOP.
	* m4/eloop.m4: Remove file.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-05  Bruno Haible  <bruno@clisp.org>

	Remove workaround against ancient Cygwin bug (not known to gnulib).
	* pathname.d (directory_search_scandir): Use closedir, not CLOSEDIR.
	* unix.d (CLOSEDIR): Remove macro.
	* configure.in: Do not invoke CL_CLOSEDIR.
	* m4/closedir.m4: Remove file.
	* m4/filecharset.m4: Update.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-04  Bruno Haible  <bruno@clisp.org>

	maint: Modernize code style of Autoconf macros.
	* m4/*.m4: Use modern indentation and quoting style.
	* m4/filecharset.m4: Fix compilation failure with pre-C99 compilers
	(regression from 2008-05-27).
	* aclocal.m4, src/configure, modules/*/configure: Regenerated.

2017-10-03  Bruno Haible  <bruno@clisp.org>

	Remove unused autoconf test.
	* src/configure.in: Do not invoke CL_SHM_RMID.
	* src/m4/shm-rmid.m4: Remove file.
	* src/m4/shm.m4 (CL_SHM): Update.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-10-03  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* build-aux/config.guess: Update from gnulib git.
	* build-aux/config.sub: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.

2017-10-01  Bruno Haible  <bruno@clisp.org>

	Fix build failure on glibc systems where iconv converters are missing.
	* constsym.d: Do not define many charset symbols if HAVE_GOOD_ICONV is
	not set.
	* encoding.d: Remove verification that HAVE_GOOD_ICONV is set.
	(init_encodings_2): Do not assume that HAVE_GOOD_ICONV is set.
	(encoding_from_name): Update accordingly.

2017-09-30  Bruno Haible  <bruno@clisp.org>

	Fix build failure with pre-C99 compilers (regression from 2008-07-12).
	* eval.d (JMP): Insert extra braces.
	* pathname.d (classify_namestring): Use 'var'.
	Likewise in some other places.
	* stream.d (wr_by_aux_ia_unbuffered, wr_by_array_iau8_unbuffered): Use
	'var'.
	Likewise in some other places.

2017-09-30  Bruno Haible  <bruno@clisp.org>

	configure: Fix build failure on IRIX when CC is set and not GCC
	(regression from 2011-05-17).
	* configure: Do not invoke $CC -dumpmachine when $CC does not
	contain 'gcc'.

2017-09-29  Bruno Haible  <bruno@clisp.org>

	Fix build failure on many platforms (regression from 2017-09-24).
	* lispbibl.d (Stream): Do not use INNARDS_OF_GCV_OBJECT if it is not
	defined.

2017-09-29  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported \
	&& make -f Makefile.devel build-prerequisites".
	* build-aux/config.guess: Update from gnulib git.
	* build-aux/config.sub: Likewise.
	* build-aux/ar-lib: Update from automake git.
	* build-aux/compile: Likewise.
	* build-aux/depcomp: Likewise.
	* build-aux/install-sh: Likewise.
	* build-aux/missing: Likewise.
	* build-aux/ylwrap: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Regenerated.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.

2017-09-24  Bruno Haible  <bruno@clisp.org>

	Define suitable address ranges in lispbibl.d, rather than in spvw.d.
	* lispbibl.d (MAPPABLE_ADDRESS_RANGE*): New macros, extracted from
	spvw.d.
	* spvw.d (init_memory): Use them.

2017-09-24  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/mipseb with WIDE_SOFT.
	This fixes a problem of the 2017-05-29 change.
	Based on work by Sébastien Villemot <sebastien@debian.org>,
	reported in bug#705.
	* lispbibl.d (Stream): Put strmflags and strmtype inside a union.
	(strmflags, strmtype): Define as macros.
	(allocate_stream, var_stream): Rename parameters.
	* spvw_typealloc.d (allocate_stream): Rename parameters.
	* stream.d (var_stream): Likewise.

2017-09-24  Bruno Haible  <bruno@clisp.org>

	Talk about Cygwin, not Cygwin32.
	* lispbibl.d (UNIX_CYGWIN): Renamed from UNIX_CYGWIN32.
	* constsym.d, error.d, genclisph.d, pathname.d, socket.d, spvw.d,
	spvw_sigsegv.d, stream.d, subr.d, unix.d, unixaux.d, execname.c: Update.
	* _distmakefile, _clisp.c: Likewise.
	* modules/syscalls/calls.c: Likewise.
	* modules/berkeley-db/bdb.c: Likewise.
	* modules/dirkey/dirkey.c: Likewise.
	* m4/closedir.m4: Update comment.

2017-09-24  Bruno Haible  <bruno@clisp.org>

	Extend porting documentation.
	* unix/PLATFORMS: Add section about address space layout.

2017-09-24  Bruno Haible  <bruno@clisp.org>

	Fix g++ -std=gnu++11 "invalid suffix on literal" warnings.
	* constobj.d (O(command_shell)): Put a space between literal string and
	token that expands to some strings.
	* built.d (built_flags): Likewise.

2017-09-24  Bruno Haible  <bruno@clisp.org>

	Fix build failure with "g++ -std=gnu++11" and libffcall 2.0.
	* foreign.d (cast_to_callback_t): New macro.
	(free_foreign_callin, convert_function_from_foreign): Use it.

2017-09-20  Bruno Haible  <bruno@clisp.org>

	Improve code structure.
	* clhs.lisp: Reorder functions.

2017-09-20  Bruno Haible  <bruno@clisp.org>

	Remove unused code.
	* clhs.lisp (read-from-file): Remove function.
	(start-message): Move from here...
	* modules/libsvm/libsvm.lisp (start-message): ... to here.

2017-09-20  Bruno Haible  <bruno@clisp.org>

	Retrieve the CLHS symbol map in one step, in most cases.
	* clhs.lisp (ensure-clhs-map): Use the domain name as a guidance which
	map file name to try.

2017-09-19  Bruno Haible  <bruno@clisp.org>

	Avoid build failure in clx/new-clx module in WIDE_SOFT model.
	Reported and fix proposed by Sébastien Villemot in
	<https://sourceforge.net/p/clisp/patches/51/>.
	The cause is that export_def is not 100% hygienic: It outputs a
	definition with all occurring macros pre-expanded. Therefore the macro
	argument names must be different from all identifiers that may be
	pulled in by macro expansion of the occurring macros.
	* lispbibl.d (cstombs_help_): Rename argument 'A' to 'asserter'.
	(with_string_0_help_, with_sstring_0_help_): Rename argument 'A' to
	'asserter', 'NR' to 'notreached'.
	(unpack_sstring_alloca_help_): Rename argument 'u' to 'notreached'.

2017-09-10  Bruno Haible  <bruno@clisp.org>

	Use newest libffcall.
	* m4/ffcall.m4 (CL_LIBFFCALL_DOWNLOAD_URL): Point to the libffcall-2.0
	release.
	(CL_FFCALL): Try to link first with -lffcall, before falling back to
	linking with -lavcall -lcallback. Correct indentation.
	* aclocal.m4, src/configure: Regenerated.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Remove the need to pass --with-libsigsegv-prefix when passing --prefix.
	Likewise for --with-libffcall-prefix.
	This helps at least on Linux/powerpc64 (CentOS 7).
	* configure (explicit_prefix): New variable.
	(note_prefix): New function. Invoke it when a --prefix option is seen.
	(have_explicit_libsigsegv_args, have_explicit_libffcall_args): New
	variables. Use them to know whether to augment subdir_configure_args.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Improve support for portability testing.
	The function mymalloc had code for checking the result of malloc(),
	but this check was a no-op in the interesting cases (e.g. with
	SINGLEMAP_MEMORY), and additionally it remained silent.
	* spvw_allocate.d (pointable_usable_test): Really test whether the
	malloc() result occupied some bits outside oint_addr_mask.
	(mymalloc): Print a warning before returning NULL.
	* spvw_allocate_old.d: Likewise.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Handle ILP32 ABIs properly.
	* lispbibl.d (intQsize, HAVE_DD): Omit redundancy. But list ARM64
	because of its ILP32 ABI.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Support for Linux/s390x.
	* lispbibl.d: On Linux/s390x, default the memory model to
	GENERIC64_HEAPCODES and avoid SINGLEMAP_MEMORY.
	(oint_type_*, oint_addr_*, oint_data_*) [UNIX_LINUX && S390_64]: Define
	a parameterization of TYPECODES configuration.
	* spvw.d (init_memory): Hardcode some good heap limits for the
	TRIVIALMAP_MEMORY model on Linux/s390x.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Support for Linux/powerpc64.
	* lispbibl.d (oint_type_*, oint_addr_*, oint_data_*)
	[UNIX_LINUX && POWERPC64]: Define parameterization of TYPECODES
	configuration.
	(mtypecode): Define also for oint_type_len==8 on 64-bit machines.
	* spvw.d (init_memory): Hardcode some good heap limits for the
	TRIVIALMAP_MEMORY model on Linux/powerpc64.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Support for Linux/arm64.
	* makemake.in (XCFLAGS): Add '-fPIC' on ARM64.
	* lispbibl.d (MALLOC_ADDRESS_RANGE) [UNIX_LINUX && ARM64]: Redefine,
	to work around deficiency of the configure test.
	(oint_type_*, oint_addr_*, oint_data_*) [UNIX_LINUX && ARM64]: Define
	parameterization of TYPECODES configuration.
	(varobject_alignment): Define to 8 on ARM64.
	* spvw.d (init_memory): Hardcode some good heap limits for the
	TRIVIALMAP_MEMORY model on Linux/arm64.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Support 64-bit platforms with MMAP_FIXED_ADDRESS_HIGHEST_BIT <= 38.
	On 64-bit platforms with an mmapable address range of at most 39 bits,
	aint and saint were defined to 32-bit integer types, which is
	catastrophic for SINGLEMAP_MEMORY support.
	* lispbibl.d (aint, saint): Define to 64-bit integer types in this case.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	Avoid unwarranted warnings from gcc's -Wformat-security.
	Reported by Jerry James in
	<https://sourceforge.net/p/clisp/mailman/message/36008037/>.
	* lispbibl.d (gettext, clgettext, clgettextl): Declare with GCC
	attribute format_arg.

2017-08-24  Bruno Haible  <bruno@clisp.org>

	For stdio to stdout/stderr, avoid use of fputs and puts.
	* lispbibl.d (fprint, print): New macros.
	* lispbibl.d, avl.d, encoding.d, error.d, errunix.d, errwin32.d:
	* eval.d, genclisph.d, io.d, lightning.c, spvw.d:
	* spvw_alloca.d, spvw_allocate.d, spvw_allocate_old.d, spvw_debug.d:
	* spvw_fault.d, spvw_fault_old.d, spvw_garcol.d, spvw_garcol_old.d:
	* spvw_global.d, spvw_memfile.d, spvw_mmap.d, spvw_sigint.d:
	* spvw_sigsegv.d, win32aux.d:
	Replace most uses of fputs, puts, fputc, putc by uses of macros 'print'
	and 'fprint'.
	* floatparam.c (print): New macro. Use it instead of puts.
	* intparam.c (print): New macro. Use it instead of puts.
	(print_underscored): Renamed from printf_underscored.

2017-08-23  Sam Steingold  <sds@gnu.org>

	* error.d, errunix.d, errwin32.d, eval.d, floatparam.c:
	* genclisph.d, intparam.c, io.d, lightning.c, lispbibl.d:
	* spvw_alloca.d, spvw_debug.d, spvw_fault.d, spvw_fault_old.d:
	* spvw_garcol.d, spvw_global.d, spvw_mmap.d, spvw_sigint.d:
	Use (f)puts instead of (f)printf when possible.

2017-08-04  Sam Steingold  <sds@gnu.org>

	* m4/ffcall.m4, configure, .hgignore: Recommend building libffcall
	and libsigsegv in the hg-ignored prerequisites directory and use
	$() instead of `` in instructions for the sake of tmux.

2017-08-03  Sam Steingold  <sds@gnu.org>

	Fix bug#701: deftype does not check package lock.
	* clos-genfun2b.lisp (top-level-declarations): Extract from...
	(check-gf-declspecs): Use it.
	* condition.lisp (check-not-type): Call check-package-lock.
	(check-not-declaration): Call check-not-declaration,
	use top-level-declarations.
	* init.lisp (check-redefinition): Call check-package-lock even if
	no files are associated with the symbol.

2017-08-03  Sam Steingold  <sds@gnu.org>

	Fix bug#702: CLISP handles declarations inconsistently.
	* clos-genfun2b.lisp (+gf-declarations+): Remove.
	(check-gf-declspecs): Pass ERROR or WARN to ERRFUNC as appropriate
	and return the list of validated declarations.
	(shared-initialize-<standard-generic-function>): Use the return
	value of check-gf-declspecs as the declspecs slot.
	* clos-genfun3.lisp (analyze-defgeneric): Ditto.
	* constobj.d (declaration_types): Add DYNAMICALLY-MODIFIABLE.

2017-08-02  Sam Steingold  <sds@gnu.org>

	* clos-genfun2b.lisp, clos-genfun3.lisp, clos-genfun4.lisp:
	* clos-methcomb2.lisp, clos-method1.lisp, clos-method2.lisp:
	* clos-method3.lisp, defstruct.lisp, places.lisp: Use ("~?" fmt args)
	instead of ("~A" (apply #'format nil fmt args))
	for brevity, clarity and uniformity.

2017-08-02  Sam Steingold  <sds@gnu.org>

	* makemake.in (gllib/libgnu.a): Depend on build-aux.

2017-07-31  Sam Steingold  <sds@gnu.org>

	Implement RFE#52: add (declare (dynamically-modifiable)).
	* clos-genfun1.lisp (generic-function): Add slot
	$DYNAMICALLY-MODIFIABLE.
	* clos-genfun2b.lisp (+gf-declarations+): New constant.
	(check-gf-declspecs): Use it.
	(std-add-method): Use GF-DYNAMICALLY-MODIFIABLE instead of
	*DYNAMICALLY-MODIFIABLE-GENERIC-FUNCTION-NAMES* to disable warnings.
	(gf-set-dynamically-modifiable): New function.
	(initialize-instance-<generic-function>)
	(reinitialize-instance-<generic-function>): Use it.
	(*dynamically-modifiable-generic-function-names*): Remove.
	(need-gf-already-called-warning-p): Use GF-DYNAMICALLY-MODIFIABLE
	instead of *DYNAMICALLY-MODIFIABLE-GENERIC-FUNCTION-NAMES*.
	* clos-package.lisp, init.lisp: Export DYNAMICALLY-MODIFIABLE.
	* compiler.lisp (*declaration-types*): Add DYNAMICALLY-MODIFIABLE.
	(process-declarations): Handle DYNAMICALLY-MODIFIABLE.
	* clos-genfun4.lisp (no-applicable-method, no-primary-method)
	(no-next-method, find-method, add-method, remove-method)
	(compute-discriminating-function, compute-applicable-methods)
	(compute-applicable-methods-using-classes)
	(compute-effective-method): Declare dynamically-modifiable.
	* clos-genfun5.lisp (ensure-generic-function-using-class): Ditto.
	* clos-method3.lisp (method-qualifiers, method-generic-function)
	((setf method-generic-function), function-keywords): Ditto.
	* clos-class5.lisp (shared-initialize, reinitialize-instance)
	(initialize-instance, allocate-instance, make-instance)
	(dynamically-modifiable, update-instance-for-different-class)
	(make-instances-obsolete, update-instance-for-redefined-class): Ditto.
	* clos-class6.lisp (class-name, (setf class-name))
	(class-direct-subclasses, class-direct-superclasses)
	(compute-direct-slot-definition-initargs)
	(compute-class-precedence-list)
	(compute-effective-slot-definition-initargs)
	(compute-effective-slot-definition, compute-slots)
	(compute-default-initargs, ensure-class-using-class)
	(validate-superclass, add-direct-subclass, remove-direct-subclass)
	(reader-method-class, writer-method-class): Ditto.
	* clos-dependent.lisp (add-dependent, remove-dependent)
	(map-dependents): Ditto.
	* clos-print.lisp (print-object): Ditto.
	* clos-slotdef3.lisp (direct-slot-definition-class)
	(effective-slot-definition-class): Ditto.
	* clos-slots2.lisp (slot-missing, slot-unbound)
	(slot-value-using-class, (setf slot-value-using-class))
	(slot-boundp-using-class, slot-makunbound-using-class): Ditto.
	* clos-specializer3.lisp (specializer-direct-generic-functions)
	(add-direct-method, remove-direct-method)
	(specializer-direct-methods): Ditto.
	* describe.lisp (describe-object): Ditto.
	* documentation.lisp (documentation, (setf documentation)): Ditto.
	* gray.lisp (close, open-stream-p, stream-element-type)
	((setf stream-element-type), stream-position)
	(stream-read-sequence, stream-write-sequence, stream-read-char)
	(stream-unread-char, stream-read-char-no-hang, stream-peek-char)
	(stream-listen, stream-read-char-will-hang-p)
	(stream-read-char-sequence, stream-read-line, stream-clear-input)
	(stream-write-char, stream-line-column, stream-start-line-p)
	(stream-write-char-sequence, stream-write-string, stream-terpri)
	(stream-fresh-line, stream-finish-output, stream-force-output)
	(stream-clear-output, stream-advance-to-column, stream-read-byte)
	(stream-read-byte-lookahead, stream-read-byte-will-hang-p)
	(stream-read-byte-no-hang, stream-read-byte-sequence)
	(stream-write-byte, stream-write-byte-sequence): Ditto.
	* loadform.lisp (make-load-form): Ditto.

2017-07-17  Sam Steingold  <sds@gnu.org>

	* gray.lisp (clos::*dynamically-modifiable-generic-function-names*):
	Add Gray generic functions to avoid the
	CLOS:GF-ALREADY-CALLED-WARNING as per the spec.
	Reported by Jean Louis <bugs@gnu.support>.

2017-06-25  Bruno Haible  <bruno@clisp.org>

	Bump version number after beta release.
	* version.sh: Bump version number to 2.49.60+.
	* version.h, src/configure: Regenerated.

2017-06-25  Bruno Haible  <bruno@clisp.org>

	Regenerate the POT file.
	* po/*.pot, po/*.po, po/*.gmo: Regenerated through
	"make -f Makefile.devel potfiles".

2017-06-25  Bruno Haible  <bruno@clisp.org>

	Prepare a beta release for translators.
	* version.sh: Bump version number to 2.49.60.
	* version.h, src/configure: Regenerated.

2017-06-25  Bruno Haible  <bruno@clisp.org>

	Update Swedish translation.
	* po/sv.po: Update from Sebastian Rasmussen <sebras@gmail.com>.
	* po/sv.gmo, po/clisplow_sv.*: Regenerated.

2017-06-24  Bruno Haible  <bruno@clisp.org>

	Use newest libffcall.
	* m4/ffcall.m4 (CL_LIBFFCALL_DOWNLOAD_URL): Point to the libffcall-1.13
	release.
	* aclocal.m4, src/configure: Regenerated.

2017-06-22  Bruno Haible  <bruno@clisp.org>

	Update French translation.
	* po/fr.po: Update from Stéphane Aulery <lkppo@free.fr>.
	* po/fr.gmo, po/clisplow_fr.*: Regenerated.

2017-06-22  Bruno Haible  <bruno@clisp.org>

	Update Swedish translation.
	* po/sv.po: Update from Sebastian Rasmussen <sebras@gmail.com>.
	* po/sv.gmo, po/clisplow_sv.*: Regenerated.

2017-06-19  Bruno Haible  <bruno@clisp.org>

	Remove some obsolete code.
	Reported by Compro Prasad <comproprasad@gmail.com>.
	* lispbibl.d (symbolp): Remove obsolete case that assumes a
	symbol_bit_o.

2017-06-17  Bruno Haible  <bruno@clisp.org>

	Update Swedish translation.
	* po/sv.po: Update from Sebastian Rasmussen <sebras@gmail.com>.
	* po/sv.gmo, po/clisplow_sv.*: Regenerated.

2017-06-15  Bruno Haible  <bruno@clisp.org>

	Avoid warning about restartf_t.
	* lispbibl.d: Include <noreturn.h>.
	(restartf_t): Use _GL_NORETURN_FUNCPTR instead of _Noreturn.
	(quit, reset, unwind_upto): Use _GL_NORETURN_FUNC.
	* spvw.d (quit): Use _GL_NORETURN_FUNC.
	* eval.d (reset, unwind_upto): Likewise.

2017-06-15  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib, and import module 'noreturn'.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* Makefile.devel (GNULIB_CORE): Add noreturn.
	* build-aux/config.guess: Update from gnulib git.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-06-14  Bruno Haible  <bruno@clisp.org>

	Do not declare the need for an executable stack on Linux and FreeBSD.
	For explanations, see
	<https://git.savannah.gnu.org/gitweb/?p=libffcall.git;a=blob_plain;f=porting-tools/execstack/README>.
	* ari80386.d, sp80386.d: Add GNU-stack note.
	* arisparc.d, arisparc64.d, spsparc.d, spsparc64.d: Likewise.
	* arihppa.d: Likewise.
	* arivaxunix.d: Likewise.
	* sp68000.d: Likewise.
	* ariarm.d: Likewise, but with slightly different syntax.

2017-06-11  Bruno Haible  <bruno@clisp.org>

	Update Swedish translation.
	* po/sv.po: Update from Sebastian Rasmussen <sebras@gmail.com>.
	* po/sv.gmo, po/clisplow_sv.*: Regenerated.

2017-06-02  Bruno Haible  <bruno@clisp.org>

	Rename frame type CHANDLER to C_HANDLER.
	Suggested by Sam Steingold.
	* lispbibl.d (C_HANDLER_frame_info): Renamed from CHANDLER_frame_info.
	(make_C_HANDLER_frame): Renamed from make_CHANDLER_frame.
	(make_C_HANDLER_entry_frame): Renamed from make_CHANDLER_entry_frame.
	(unwind_C_HANDLER_frame): Renamed from unwind_CHANDLER_frame.
	* eval.d (invoke_handlers): Update.
	* io.d (read_internal): Likewise.
	* pathname.d (LOGICAL-PATHNAME, direntry_to_string): Likewise.
	* stream.d (MAYBE_IGNORE_ERRORS,lisp_completion) : Likewise.
	* spvw_update.d (update_STACKs): Likewise.
	* spvw_garcol.d, spvw_garcol_old.d (gc_mark_stack): Likewise.

2017-05-30  Vladimir Tzankov  <vtzankov@gmail.com>

	* lispbibl.d (per_thread) [UNIX_MACOSX]: use __thread with clang

2017-05-30  Bruno Haible  <bruno@clisp.org>

	Do not publish impnotes.html for the moment.
	* doc/Makefile (DIST): Set to empty.

2017-05-29  Bruno Haible  <bruno@clisp.org>

	Fix GC bug that affects some stream types (regression from 2004-04-28).
	Analyzed by Vladimir Tzankov <vtzankov@gmail.com>.
	The problem is that since the macro SXrecord_nonweak_length was
	introduced, walking a page of Xrecord objects makes use of the
	Record_type(obj) without testing whether typecode(obj)==stream_type.
	Thus, the fact of storing strmtype in the same place as the rectype
	causes an strmtype to be interpreted as a rectype.
	* lispbibl.d (Rectype_Stream): Define always.
	(Stream): Do not try to save space when case_stream is defined.
	(allocate_stream): Define as a function always.
	* spvw_typealloc.d (allocate_stream): Likewise.

2017-05-29  Bruno Haible  <bruno@clisp.org>

	Update Swedish translation.
	* po/sv.po: Update from Sebastian Rasmussen <sebras@gmail.com>.
	* po/sv.gmo, po/clisplow_sv.*: Regenerated.

2017-05-28  Bruno Haible  <bruno@clisp.org>

	New command line option -nextgc-factor (undocumented).
	* spvw_global.d (mem): Add nextgc_trigger_factor field.
	* spvw_global_old.d: Likewise.
	* spvw_garcol.d (gar_col_normal): Multiply total_room with
	mem.nextgc_trigger_factor.
	* spvw_garcol_old.d: Likewise.
	* spvw.d: Include c-strtod.h.
	(argv_initparams): Add argv_nextgc_factor field.
	(parse_options): Accept option -nextgc-factor.
	(init_memory): Initialize mem.nextgc_trigger_factor.

2017-05-28  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib, and import module 'c-strtod'.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* Makefile.devel (GNULIB_CORE): Add c-strtod.
	* build-aux/config.guess: Update from gnulib git.
	* build-aux/config.sub: Likewise.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/oracle/configure: Likewise.

2017-05-27  Bruno Haible  <bruno@clisp.org>

	Add check of make_machine_code argument.
	* lispbibl.d (make_machine_code_unchecked): Renamed from
	make_machine_code.
	(make_machine_code): New macro.
	(error_pseudocode_alignment): New declaration.
	* spvw.d (error_pseudocode_alignment): Make global. Add a 'prefix'
	parameter.
	(verify_pseudocode_alignment): Pass "&" as prefix argument.

2017-05-27  Bruno Haible  <bruno@clisp.org>

	Do not put arbitrary C function pointers onto the STACK.
	* list.d (sublis_assoc): Add pcall_test argument. Use it instead of
	assuming to find this C function in the STACK.
	(sublis, nsublis): Add pcall_test argument.
	(SUBLIS, NSUBLIS): Do not invoke make_machine_code.
	Put a dummy onto the STACK instead.

2017-05-27  Bruno Haible  <bruno@clisp.org>

	Put only valid pointers into the FRAME_(frame_SP) of a CHANDLER frame.
	* pathname.d (signal_type_error): Fetch the thing from the STACK.
	(LOGICAL-PATHNAME): Pass NULL to make_CHANDLER_frame.
	* io.d (signal_reader_error): Fetch the stream from the STACK.
	(read_internal): Put the stream into the STACK, and pass NULL to
	make_CHANDLER_frame.

2017-05-27  Bruno Haible  <bruno@clisp.org>

	New frame type CHANDLER.
	Needed because GC has to skip 3 words when scanning STACK, not just 2.
	* lispbibl.d: Describe the CHANDLER frames.
	(CHANDLER_frame_info): New macro.
	(unwind_limit_t, entrypoint_limit_t, skip2_limit_t): Adjust to make room
	for this frame info.
	(*_frame_info, nested_bit_t, dynjump_mask_t, driver_bit_t,
	handler_bit_t, blockgo_max_t): Redefine so that the values fit together.
	(make_CHANDLER_frame): Renamed from make_HANDLER_frame. Use
	fake_gcv_object instead of make_machine_code.
	(make_CHANDLER_entry_frame): Renamed from make_HANDLER_entry_frame. Use
	fake_gcv_object instead of make_machine_code.
	(unwind_CHANDLER_frame): Renamed from unwind_HANDLER_frame.
	* spvw_garcol.d (gc_mark_stack): For CHANDLER frames, skip 3 words,
	not 2.
	* spvw_garcol_old.d: Likewise.
	* spvw_update.d (update_STACKs): Likewise.
	* eval.d (invoke_handlers): Distinguish CHANDLER frames and HANDLER
	frames through the frame info.
	(nest_env): Do not assume that NESTED_ITAGBODY_frame_info and
	ITAGBODY_frame_info differ by just bit(nested_bit_t).
	* io.d (signal_reader_error): Fix comment.
	(read_internal): Update.
	* pathname.d (LOGICAL_PATHNAME, direntry_to_string): Update.
	* stream.d (MAYBE_IGNORE_ERRORS, lisp_completion): Update.

2017-05-27  Bruno Haible  <bruno@clisp.org>

	Prepare for new frame info byte values.
	* lispbibl.d (blockgo_bit_t, cframe_bit_t, dynjump_bit_t,
	blockgo_bit_o, cframe_bit_o, dynjump_bit_o): Remove macros.
	(blockgo_max_t, dynjump_mask_t): New macros.
	(*_frame_info, driver_bit_t): Redefine so that blockgo_max_t works.
	* eval.d (unwind): Use blockgo_max_t instead of blockgo_bit_t. Use
	CBLOCK_CTAGBODY_frame_info instead of cframe_bit_t. Use dynjump_mask_t
	instead of dynjump_bit_t.
	* debug.d (blockgo_frame_p): New function.
	(lexical_frame_p): Use it.

2017-05-27  Bruno Haible  <bruno@clisp.org>

	Prepare for new frame info byte values.
	* lispbibl.d (skip2_limit_t): New macro.
	(skip2_bit_t, skip2_bit_o): Remove macros.
	* eval.d (unwind): Use skip2_limit_t instead of skip2_bit_t.
	* spvw_garcol.d (gc_mark_stack): Use skip2_limit_t instead of
	skip2_bit_o.
	* spvw_garcol_old.d: Likewise.
	* spvw_update.d (update_STACKs): Likewise.
	* debug.d (framep, lexical_frame_p, same_env_as): Likewise.

2017-05-26  Bruno Haible  <bruno@clisp.org>

	Allow regular testing of memory management with limited memory size.
	* Makefile.devel (build-porting32-gcc-limited_memory,
	build-porting32-cc-limited_memory, build-porting64-gcc-limited_memory,
	build-porting64-cc-limited_memory): New targets.
	* modules/asdf/Makefile (asdf.fas): Give it more memory.

2017-05-26  Bruno Haible  <bruno@clisp.org>

	Allow regular testing of SPVW_PURE_PAGES memory management.
	* lispbibl.d: In SPVW_PAGES case with TYPECODES, test PREFER_PURE_PAGES
	to decide between SPVW_PURE and SPVW_MIXED.
	* Makefile.devel (build-porting32-gcc-typecodes-spvw_pure_pages,
	build-porting32-cc-typecodes-spvw_pure_pages,
	build-porting64-gcc-typecodes-spvw_pure_pages,
	build-porting64-cc-typecodes-spvw_pure_pages): New targets.
	(build-porting32-gcc-typecodes-spvw_mixed_pages): Renamed from
	build-porting32-gcc-typecodes-spvw_pages.
	(build-porting32-cc-typecodes-spvw_mixed_pages): Renamed from
	build-porting32-cc-typecodes-spvw_pages.
	(build-porting64-gcc-typecodes-spvw_mixed_pages): Renamed from
	build-porting64-gcc-typecodes-spvw_pages.
	(build-porting64-cc-typecodes-spvw_mixed_pages): Renamed from
	build-porting64-cc-typecodes-spvw_pages.

2017-05-26  Bruno Haible  <bruno@clisp.org>

	Optimize unneeded code when SIGCLD is not defined.
	* spvw_sigcld.d (begin_want_sigcld, end_want_sigcld): Do nothing if
	SIGCLD is not defined.

2017-05-26  Bruno Haible  <bruno@clisp.org>

	Reinstall the old GC from clisp-2.47.
	This should provide a reference point when hunting down GC bugs.
	* lispbibl.d: Document OLD_GC instead of NO_MULTITHREAD_GC.
	Verify OLD_GC and MULTITHREAD are exclusive.
	* spvw_allocate_old.d: New file, from clisp-2.47 with non-algorithmic
	updates from spvw_allocate.d.
	* spvw_circ_old.d: New file, from clisp-2.47.
	* spvw_fault_old.d: New file, from clisp-2.47 with non-algorithmic
	updates from spvw_fault.d.
	* spvw_genera1_old.d: New file, from clisp-2.47 with non-algorithmic
	updates from spvw_genera1.d.
	* spvw_genera3_old.d: New file, from clisp-2.47.
	* spvw_global_old.d: New file, from clisp-2.47 with non-algorithmic
	updates from spvw_global.d.
	* spvw_heap_old.d: New file, from clisp-2.47.
	* spvw.d: Include these files instead of the non-_old variant when
	OLD_GC is defined.
	* spvw_garcol_old.d: Include the _old variant of spvw* files.
	(gc_sweep1_varobject_page): Include DEBUG_SPVW_ASSERT fix from
	2009-01-07.
	* spvw_memfile.d: Change condition from MULTITHREAD to
	!OLD_GC && MULTITHREAD, for clarity.
	* spvw_space.d: Likewise.
	* spvw_typealloc.d: Likewise.
	* makemake.in (SPVW_INCLUDES): Add the new files.
	* Makefile.devel (build-porting*old_gc): Define OLD_GC instead of
	NO_MULTITHREAD_GC.

2017-05-25  Bruno Haible  <bruno@clisp.org>

	Silence error messages from 'find' (regression from 2017-03-21).
	* makemake.in (make_modules): Add test whether $m/configure exists.

2017-05-25  Bruno Haible  <bruno@clisp.org>

	Fix build warning
	"unrecognized command line option ‘-Wno-shift-negative-value’".
	* makemake.in (XCFLAGS): Use -Wno-shift-negative-value only for
	GCC versions that really support it.

2017-05-25  Bruno Haible  <bruno@clisp.org>

	Fix race condition w.r.t. SIGWINCH signal (regression from 2009-10-21).
	* spvw.d (main): Invoke update_linelength after establishing the
	SIGWINCH handler, not before.

2017-05-25  Bruno Haible  <bruno@clisp.org>

	Add Swedish localization (work in progress).
	* constsym.d (swedish): Add.
	* spvw_language.d (language_swedish): New enum value.
	(current_language_o, init_language): Handle it.
	(init_language_from): Check for Swedish.

2017-05-25  Bruno Haible  <bruno@clisp.org>

	Silence error messages from 'find' (regression from 2017-03-21).
	* makemake.in (make_modules): Add test whether $m/Makefile exists.

2017-05-25  Bruno Haible  <bruno@clisp.org>

	Small fixes in socket.d.
	* lispbibl.d (addr_to_string): Change argument types.
	(nonintr_connect): Change name argument type.
	(socket_getlocalname, socket_getpeername, accept_connection): Fix
	comment.
	(create_client_socket): Change timeout argument type. Fix comment.
	* socket.d: Mention use of gnulib.
	(addr_to_string): Change argument types.
	(nonintr_connect): Change name argument type.
	(host_fn_t): Change addrlen argument type. Add comment.
	(string_to_addr1, resolve_host1): Change addrlen argument type.
	(resolve_host): Relax cast of gethostbyaddr's first argument.
	(socket_connect_fn_t): Change addr and addrlen argument types. Add
	comment.
	(with_host_port): Relax cast of connector's first argument.
	(connect_to_x_via_ip): Change addr and addrlen argument types.
	(socket_getlocalname_aux): Fix comment. Handle inet_ntop failure.
	(socket_getlocalname, socket_getpeername): Fix comment.
	(socket_getpeername): Handle inet_ntop failure.
	(bindlisten_via_ip): Change addr and addrlen argument types.
	(accept_connection): Add comment. Set errno, not WSAGetLastError.
	(connect_via_ip): Change addr and addrlen argument types. Use do/while
	loop instead of 'goto'.
	(create_client_socket): Change timeout argument type. Fix comment.
	* stream.d (accept_connection, create_client_socket): Remove redundant
	declarations.

2017-05-22  Bruno Haible  <bruno@clisp.org>

	Update some URLs.
	Reported by Don Cohen
	<https://sourceforge.net/p/clisp/mailman/message/35853807/>.
	* unix/INSTALL: Update outdated URLs. Prefer https over http or ftp
	URLs.

2017-05-21  Bruno Haible  <bruno@clisp.org>

	Add Swedish translation (work in progress).
	* po/sv.po: New file, from Sebastian Rasmussen <sebras@gmail.com>.
	* po/LINGUAS: Add sv.
	* po/Makefile.devel (OTHER_LINGUAS): Add sv.
	* po/Makefile.trans.sv: New file.

2017-05-20  Vladimir Tzankov  <vtzankov@gmail.com>

	* lispbibl.d: (MULTITHREAD): Do not use SINGLEMAP_MEMORY model.
	Fixed lisp stack address is the issue.

2017-05-20  Vladimir Tzankov  <vtzankov@gmail.com>

	Fix MT builds with MAP_MEMORY_TABLES model
	* spvw.d (create_thread, init_multithread_special_symbols): Initialize
	thread special variables bindings once the symbol_tab has been setup.

2017-04-17  Bruno Haible  <bruno@clisp.org>

	Fix regeneration of src/configure after version.sh has changed.
	* Makefile.devel ($(CONFIGURES)): Erase autom4te.cache directory (that
	contains a cached version number), to make sure the new version number
	from version.sh is taken into account.

2017-04-04  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Windows when the version number is "2.49.50".
	* makemake.in (clisp.rc): Support major.minor.micro version syntax in
	determination of PRODUCTVERSION and FILEFLAGS.

2017-04-04  Bruno Haible  <bruno@clisp.org>

	Fix build failure when compiling for mingw.
	* win32.d: Include <winternl.h> and <ntstatus.h>, not <ddk/ntifs.h>.
	Fix provided by Akira Kakuto <kakuto@fuk.kindai.ac.jp>.

2017-04-04  Bruno Haible  <bruno@clisp.org>

	Fix build failure when compiling for mingw on Cygwin.
	* makemake.in (UTILCOMPILE): Use $(CC), not just 'gcc'. This is needed
	because the utils/* programs include <config.h>, and config.h was
	generated for $(CC).

2017-03-27  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-exec-image): Add the `exit-on-error`
	workaround for Bug#695.

2017-03-26  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (MULTIBUILD_OPTIONS): Split into ...
	(MULTIBUILD_MODULES): Default to asdf (platform-independent) and
	rawsock (well-ported).
	(MULTIBUILD_EXTRAS): Empty by default.

2017-03-23  Sam Steingold  <sds@gnu.org>

	* stream.d (wr_by_array_iau8_buffered): Pass persev to
	write_byte_array_buffered() instead of persev_full.

2017-03-23  Reini Urban <reini.urban@gmail.com>
	    Sam Steingold  <sds@gnu.org>

	* stream.d (iconv): Condition "undef iconv" on whether it is
	defined, not on platform.

2017-03-23  Jerry James <loganjerry@gmail.com>
	    Sam Steingold  <sds@gnu.org>

	* modules/libsvm/libsvm.lisp (svm_destroy_model): Use C-style
	declaration - fix a compilation error (patch#34).

2017-03-22  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-script): Add a test for -x raising an error.
	(check-exec-image): Add tests for init-function raising an error.

2017-03-22  Sam Steingold  <sds@gnu.org>

	Fix bug#694: Cygwin+no-dynamic-modules fails with a shell syntax error
	* makemake.in (CLISP_DEF): Check CLISP_DEF instead of HSYSOS when
	deciding whether to modify CLISP_DEF or not.

2017-03-21  Bruno Haible  <bruno@clisp.org>

	Replace the 'newer' utility with a portable shell alternative.
	Jörg Höhle found that "newer $file1 $file2" is equivalent to
	test -f $file1 && \
	  { test ! -f $file2 || test -n "`find $file1 -prune -newer $file2`"; }
	* src/makemake.in (UTILS): Remove 'newer'.
	Use a 'find' based shell command instead of the 'newer' program.
	* utils/newer.c: Remove file.
	* Makefile.devel (GNULIB_CORE): Remove stat-time, timespec.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* gllib/Makefile.am, gllib/Makefile.in: Regenerated.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* build-aux/config.sub: Update from gnulib git.

2017-03-20  Bruno Haible  <bruno@clisp.org>

	Fix "End of comment outside comment" warnings from varbrace.
	* utils/varbrace.c (enum parsing_state): New type.
	(parsing_state_at_end_of_line): New function.
	(next_token): Continue reading more lines for a preprocessor
	line that ends within a C style comment.

2017-03-20  Sam Steingold  <sds@gnu.org>

	Fix non-blocking sockets on Mac OS X.
	* unix.d (NO_BLOCK_DECL): Do not accept handle.
	(START_NO_BLOCK): Accept on_fail, move function call from
	NO_BLOCK_DECL here.
	(END_NO_BLOCK): Accept on_fail.
	* win32.d (NO_BLOCK_DECL, START_NO_BLOCK, END_NO_BLOCK): Add.
	* socket.d (connect_via_ip): Use
	NO_BLOCK_DECL/START_NO_BLOCK/END_NO_BLOCK.
	* stream.d (listen_handle): Update the use of
	NO_BLOCK_DECL/START_NO_BLOCK/END_NO_BLOCK.
	* unixaux.d (fd_read, fd_write, sock_write): Ditto.
	Reported by Karsten Poeck <Karsten.Poeck@gmail.com>.

2017-03-20  Reini Urban  <reini.urban@gmail.com>
            Bruno Haible  <bruno@clisp.org>

	Fix text file processing Makefile rules for parallel make.
	* makemake.in (TXT_FILES): Use a different temporary file for each
	target file.

2017-03-20  Reini Urban  <reini.urban@gmail.com>
            Bruno Haible  <bruno@clisp.org>

	Fix intparam.h/floatparam.h Makefile rule for parallel make.
	* makemake.in (PARAMS): Use a different temporary file for each
	target file.

2017-03-20  Bruno Haible  <bruno@clisp.org>

	Bump version number after beta release.
	* version.sh: Bump version number to 2.49.50+.
	* version.h, aclocal.m4, src/configure: Regenerated.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Prepare beta release.
	* version.sh: Bump version number to 2.49.50.
	* version.h, aclocal.m4, src/configure: Regenerated.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Fix the recognition of Solaris.
	* lispbibl.d (UNIX_SUNOS5): Include also Solaris/x86_64.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Fix recognition of native Windows as target platform.
	* makemake.in (TOS): Set based on $host_os from autoconf.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Do not generate a broken Makefile when using the option --host/--build.
	Rationale:
	- clisp cannot be cross-built anyway (because of the memory image).
	  The earlier use-case of "makemake cross ..." of ca. 1993 was when
	  compiling for a slow machine. Nowadays machines are much faster.
	- The main use of --host is to indicate which toolchain to use
	  (${host}-gcc, ${host}-ld, ${host}-ar, etc.)
	- --host is frequently used in builds on Windows (e.g.
	  --build=i686-pc-cygwin --host=i686-w64-mingw32).
	* configure: Do not pass 'cross' to makemake.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Fix error message when configure fails due to a missing argument.
	* configure: Set prev to 'build', not 'host'. In the error message,
	add '--' before prev.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Fix build failure when compiling 'newer' on Cygwin.
	* makemake.in (CPPFLAGS): Add the ${GNULIB_INCLUDE} options here too.
	Link all programs that are compiled with $(CPPFLAGS) with ${GLLIB_A}.
	(MODULE_CPPFLAGS): No need to add ${GNULIB_INCLUDE} a second time.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Fix alignment issues on IA64 and with GENERIC64C_HEAPCODES.
	* lispbibl.d (C_CODE_ALIGNMENT, log2_C_CODE_ALIGNMENT): Do not redefine.
	(PSEUDODATA_ALIGNMENT, log2_PSEUDODATA_ALIGNMENT): New macros.
	(PSEUDOCODE_ALIGNMENT, log2_PSEUDOCODE_ALIGNMENT): New macros.
	(make_machine_code): Adjust for GENERIC64C_HEAPCODES.
	(TheMachineCode): Adjust accordingly.
	* spvw.d (verify_pseudodata_alignment): New macro.
	(error_pseudodata_alignment): New function.
	(verify_pseudocode_alignment): Renamed from verify_code_alignment.
	(error_pseudocode_alignment): Renamed from error_code_alignment. Change
	error message.
	(init_memory): Invoke verify_code_alignment, verify_pseudodata_alignment
	respectively.
	* encoding.d (nls_table_t): Align to PSEUDODATA_ALIGNMENT, not 4.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Fix an autoconf test crash on IA64.
	* m4/mmap.m4: On IA64, do not try to mmap at the address where the
	executable sits.

2017-03-19  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure: Regenerated.

2017-03-18  Bruno Haible  <bruno@clisp.org>

	Make --enable-portability enable support for any kind of address space.
	* lispbibl.d: Obey flag NO_ADDRESS_SPACE_ASSUMPTIONS. It has the effect
	to enable WIDE_SOFT on 32-bit platforms and disable SINGLEMAP_MEMORY,
	TYPECODES, TRIVIALMAP_MEMORY, CAN_ALLOCATE_8BIT_VECTORS_ON_C_STACK,
	CAN_ALLOCATE_STRINGS_ON_C_STACK.
	* makemake.in (XCFLAGS): Add -DNO_ADDRESS_SPACE_ASSUMPTIONS if
	--enable-portability is specified.

2017-03-18  Bruno Haible  <bruno@clisp.org>

	Avoid code duplication of a condition.
	* lispbibl.d (CAN_ALLOCATE_8BIT_VECTORS_ON_C_STACK,
	CAN_ALLOCATE_STRINGS_ON_C_STACK): New macros.
	(_SP_before_suspend, SET_SP_BEFORE_SUSPEND): Use them.
	* spvw_global.d (is_valid_stack_address): Likewise.
	* constobj_tl.d: Likewise.

2017-03-17  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* aclocal.m4, src/configure: Regenerated.

2017-03-17  Bruno Haible  <bruno@clisp.org>

	Fix build failures with --with-debug on NetBSD.
	* unix.d: Include <sys/ioctl.h> always. Needed to get ioctl() declared.
	* foreign.d (FOREIGN-POINTER-INFO): Cast dli.dli_saddr, possibly a
	'const void *', to 'void *'.
	* lispbibl.d (dotimes_called_with_count_of_wrong_size): Export to
	clisp.h.

2017-03-17  Bruno Haible  <bruno@clisp.org>

	Do not test unportable features in "make check".
	* makemake.in: Generate a new target 'extracheck'. Let 'extracheck', not
	'check', depend on 'check-exec-image'.

2017-03-17  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/arm.
	* arilev0.d (mulu32_, divu_3216_1616_, divu_3216_3216_, divu_3232_3232_,
	divu_6432_3232_, divu_6432_6432_, divu_6464_6464_): When defined in
	lisparit.o, add a suffix to the symbol. This avoids a link-time
	collision with ari*.o.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure on 64-bit HP-UX without -DNO_ARI_ASM.
	* lispbibl.d (HPPA64): New macro.
	* arilev0.d: Exclude HPPA64 when testing for HPPA.
	* intlog.d: Likewise.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure on 64-bit HP-UX with -DNO_ARI_ASM.
	* intlog.d (integerlength32) [HPPA]: Test NO_ARI_ASM, not NO_ASM.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Enable the '-mm' option also on HP-UX.
	* spvw_mmap.d (dump_process_memory_map_callback,
	dump_process_memory_map): Move from here...
	* spvw.d (dump_process_memory_map_callback, dump_process_memory_map):
	... to here.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure on HP-UX.
	* makemake.in (with_dynamic_modules): Default to 'no' on HP-UX.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure with HP-UX cc and Sun cc.
	* makemake.in: Compile the CPARTS and clisp-test.c with option "-I.".

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure on HP-UX/hppa.
	* arilev0.d (divu_6432_3232_): Test HPPA_DIV_WORKS, not HPPA.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Fix build failure with HP-UX make.
	Apparently HP-UX make expects an absolute filename for SHELL.
	* makemake.in: For HP-UX, set SHELL to the absolute filename of bash,
	not just "bash".

2017-03-16  Bruno Haible  <bruno@clisp.org>

	Do not rely on unportable 'test file1 -nt file2' primitive.
	Fixes a build failure on OpenBSD.
	* Makefile.devel (GNULIB_CORE): Add stat-time, timespec.
	* utils/newer.c: New file.
	* makemake.in: Do not emit a '.SHELL' line.
	(UTILS): Add 'newer'.
	Use the 'newer' program instead of a 'newer()' shell function.
	* configure.in: Do not invoke CL_TEST_NT.
	* m4/test.m4: Remove file.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* gllib/Makefile.am, gllib/Makefile.in: Regenerated.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-03-16  Bruno Haible  <bruno@clisp.org>

	maint: Add a convenience target for checking the documentation.
	* Makefile.devel (check-doc): New target.

2017-03-15  Bruno Haible  <bruno@clisp.org>

	Fix build failure on HP-UX (regression from 2005-07-29).
	* makemake.in (gen.lispbibl.c): Fix the sed expression to also work
	with HP-UX sed.

2017-03-15  Bruno Haible  <bruno@clisp.org>

	Do not treat all non-GCC compilers like SUNWspro cc.
	* makemake.in: Fix the test of the CC_SUNPRO variable.

2017-03-15  Bruno Haible  <bruno@clisp.org>

	Update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* build-aux/config.guess: Update from gnulib git.
	* build-aux/snippet/*: Update from gnulib.
	* gllib/*: Likewise.
	* glm4/*: Likewise.
	* gllib/Makefile.am, gllib/Makefile.in: Regenerated.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-03-14  Sam Steingold  <sds@gnu.org>

	Fix TRUENAME on /proc symlinks to very long paths.
	* pathname.d (get_path_info): When result==linklen, retry
	readlink() because this means that linkbuf was too small.

2017-03-14  Bruno Haible  <bruno@clisp.org>

	Fix build failure on AIX in 64-bit mode with gcc.
	* makemake.in: Compile genclisph.c with option -O1, not -O0.

2017-03-14  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-EVAL-WHEN): Remove the set-but-not-used
	variable `eval-p'.

2017-03-14  Sam Steingold  <sds@gnu.org>

	avoid many -Wunused-parameter warnings
	* spvw.d, spvw_garcol.d, spvw_mmap.d, spvw_sigint.d, spvw_sigpipe.d,
	spvw_sigsegv.d, spvw_sigwinch.d: Cast unused parameters to 'void'.

2017-03-14  Sam Steingold  <sds@gnu.org>

	Fix bug#687: executable images are broken when configured --with-debug.
	* spvw_memfile.d (find_memdump): Reduce header_size: exclude
	_subr_tab_addr and _symbol_tab_addr from header comparison.

2017-03-13  Bruno Haible  <bruno@clisp.org>

	Implement the undocumented option -mm on many more platforms.
	* spvw.d (parse_options): Accept option '-mm' on all platforms.
	Implement it also on all other platforms where gnulib's vma-iter module
	works, namely on Linux, FreeBSD, NetBSD, OpenBSD, IRIX, OSF/1, Mac OS X,
	Cygwin, BeOS, Haiku.

2017-03-13  Bruno Haible  <bruno@clisp.org>

	Fix result of two autoconf tests in C++ mode.
	The test programs need to either use exit() and include <stdlib.h>, or
	use 'return'.
	* m4/poll.m4 (CL_POLL): Use 'return' instead of 'exit'.
	* m4/shm.m4 (CL_SHM): Likewise.
	* aclocal.m4, src/configure: Regenerated.

2017-03-12  Bruno Haible  <bruno@clisp.org>

	Add support for generational GC on NetBSD/x86 and NetBSD/x86_64.
	* lispbibl.d: On NetBSD/x86, choose the same ONE_FREE_BIT_HEAPCODES
	representation as on BeOS/x86. Enable TRIVIALMAP_MEMORY on NetBSD.
	* spvw.d (init_memory): Specify usable address range for NetBSD/x86
	and NetBSD/x86_64.

2017-03-12  Bruno Haible  <bruno@clisp.org>

	Terminate endless loop of mmap_zeromap failures after 10 failures.
	This is useful for NetBSD.
	* spvw_mmap.d (spvw_mmap.d): Abort if it fails 10 times in a row with
	identical arguments and error code.

2017-03-12  Bruno Haible  <bruno@clisp.org>

	Fix wrong uses of errno.
	* spvw_garcol.d (gar_col_normal): Save OS_errno around fputs call.
	* spvw_garcol_old.d (gar_col_normal): Likewise.
	* spvw_memfile.d (loadmem_from_handle): Save errno around fprintf call.
	* spvw_mmap.d (mmap_init, mmap_zeromap): Likewise.
	* pathname.d (stat_obj): Save errno before exiting with_sstring_0.

2017-03-12  Bruno Haible  <bruno@clisp.org>

	Simplify GC_SAFE_CALL, GC_SAFE_SYSTEM_CALL.
	* lispbibl.d (GC_SAFE_CALL, GC_SAFE_SYSTEM_CALL): Take only 1 argument.
	* pathname.d, stream.d: All callers updated.

2017-03-12  Bruno Haible  <bruno@clisp.org>

	Add support for TRIVIALMAP_MEMORY configuration on FreeBSD/x86_64.
	* spvw.d (init_memory): Specify usable address range for FreeBSD/x86_64.

2017-03-12  Bruno Haible  <bruno@clisp.org>

	Fix build failure on x86 platforms with clang, e.g. FreeBSD/x86.
	* makemake.in (SP_ASMD, SP_ASMS): Set to non-empty also when using
	GCC or a GCC compatible compiler.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	Do not attempt to use SINGLEMAP_MEMORY on OpenBSD/x86_64.
	* lispbibl.d (SINGLEMAP_MEMORY): Do not define if
	ADDRESS_RANGE_RANDOMIZED is defined.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	Add support for generational GC on OpenBSD/x86.
	* lispbibl.d (ADDRESS_RANGE_RANDOMIZED): Do not define for 32-bit
	OpenBSD.
	* spvw.d (init_memory): For 32-bit OpenBSD, use the address range
	0x90000000..0xC8000000.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	When warning about the address range, dump the process memory map.
	* spvw_mmap.d (dump_process_memory_map_callback,
	dump_process_memory_map): New functions.
	(warn_before_reserving_range): Invoke dump_process_memory_map.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	Avoid unwanted optimizations on signed integer types by gcc.
	* makemake.in (XCFLAGS): Add '-fwrapv' option.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	Fix build failure on OpenBSD 6 (regression from 2017-03-10).
	* makemake.in (XCFLAGS): Test gcc version before adding -Wno-* options.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	New heapcodes scheme KERNELVOID32B_HEAPCODES.
	Needed to get generational GC working on OpenBSD/x86.
	* lispbibl.d: Define/expect KERNELVOID32B_HEAPCODES as an alternative
	to KERNELVOID32A_HEAPCODES.
	* spvw.d (init_memory): Update accordingly.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	Rename LINUX_NOEXEC_HEAPCODES to KERNELVOID32_HEAPCODES.
	* lispbibl.d: Define/expect KERNELVOID32_HEAPCODES and
	KERNELVOID32A_HEAPCODES instead of LINUX_NOEXEC_HEAPCODES.
	* constsym.d (LISPSYM_B): Update.
	* spvw.d (init_memory): Update.
	* spvw_gcmark.d (gc_mark): Update.
	* spvw_memfile.d (loadmem_update): Update.
	* lightning.c: Update.
	* io.d (pr_orecord): Update.
	* built.d (built_flags): Update.
	* Makefile.devel (build-porting*, build-darwin-*): Rename and update
	accordingly.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	Rename STANDARD_HEAPCODES to ONE_FREE_BIT_HEAPCODES.
	* lispbibl.d: Define/expect ONE_FREE_BIT_HEAPCODES instead of
	STANDARD_HEAPCODES.
	* spvw.d (init_memory): Update.
	* spvw_garcol.d (alive): Update.
	* spvw_garcol_old.d (alive): Update.
	* spvw_gcmark.d (gc_mark): Update.
	* lightning.c: Update.
	* built.d (built_flags): Update.
	* makemake.in: Update.
	* Makefile.devel (build-porting*, build-darwin-*): Rename and update
	accordingly.

2017-03-11  Bruno Haible  <bruno@clisp.org>

	maint: Modernize multibuild-linux-x86 target.
	* Makefile.devel (build-linux-x86-*): Remove targets.
	(multibuild-linux-x86): Use the build-porting32-gcc-* targets.
	(multibuild-linux-x86_64): New target.

2017-03-10  Bruno Haible  <bruno@clisp.org>

	Disable address range warning on Mac OS X.
	* spvw_mmap.d: Treat Mac OS X like a platform without 'mincore'.
	Reported by Sam Steingold.

2017-03-10  Sam Steingold  <sds@gnu.org>

	* makemake.in (XCFLAGS) [GCC & !CROSS]: Add -Wno-shift-negative-value.
	Note that gcc accepts -Wno-<whatever>, so no version check is needed.

2017-03-10  Bruno Haible  <bruno@clisp.org>

	Warn before reserving an address range that might crash CLISP.
	* Makefile.devel (GNULIB_CORE): Add vma-iter.
	* spvw_mmap.d: Include vma-iter.h.
	(is_large_range_unmapped_locals): New type.
	(is_large_range_unmapped_callback, is_large_range_unmapped,
	warn_before_reserving_range): New functions.
	(mmap_prepare): Invoke warn_before_reserving_range.
	* gllib/*: Update from gnulib.
	* glm4/*: Likewise.
	* gllib/Makefile.am, gllib/Makefile.in: Regenerated.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-03-10  Bruno Haible  <bruno@clisp.org>

	Warn before doing mmap calls that might crash clisp.
	* configure.in: Test for mincore.
	* spvw_mmap.d (mincore_pageinfo_t): New type.
	(mincore_init, is_small_range_unmapped, warn_before_mmap): New
	functions.
	(mmap_init): Invoke mincore_init.
	(mmap_zeromap, mmap_filemap): Invoke warn_before_mmap.
	* src/configure, src/config.h.in: Regenerated.

2017-03-09  Sam Steingold  <sds@gnu.org>

	Fix module build failure with inttypes defined in base modules.
	* foreign.d, subr.d (PARSE-FOREIGN-INTTYPE): Accept second ERRORP
	argument; return 0 when the type is not found and ERRORP is NIL.
	* foreign1.lisp (parse-c-type): Pass ERRORP=T to PARSE-FOREIGN-INTTYPE.
	(finalize-coutput-file): Do not write register_foreign_inttype()
	for types already accepted by PARSE-FOREIGN-INTTYPE.

2017-03-09  Sam Steingold  <sds@gnu.org>

	Add asciz_startswith - a replacement for strncmp not requiring
	begin_system_call/end_system_call.
	* spvw.d (asciz_startswith): Implement.
	* lispbibl.d (asciz_startswith): Declare.
	* pathname.d (get_path_info): Use it instead of strncmp().

2017-03-09  Sam Steingold  <sds@gnu.org>

	* misc.d (LISP-IMPLEMENTATION-VERSION): Wrap atol() and strncmp()
	in begin_system_call/end_system_call.

2017-03-09  Bruno Haible  <bruno@clisp.org>

	Fix build failure with DEBUG_GCSAFETY.
	* lispbibl.d (INIT_SUBR_TAB, INIT_SYMBOL_TAB, INIT_OBJECT_TAB): Do
	not define if DEBUG_GCSAFETY && SINGLEMAP_MEMORY.

2017-03-09  Bruno Haible  <bruno@clisp.org>

	Fix some gcc warnings about use of fprintf.
	* spvw.d (init_memory): Cast specific fprintf arguments to
	'unsigned long'.
	* spvw_debug.d (nobject_out1): Cast specific fprintf arguments to 'int'
	or 'unsigned long'.
	(back_trace_depth): Cast specific fprintf arguments to 'unsigned long'.
	* spvw_memfile.d (loadmem_from_handle): Cast specific sprintf arguments
	to 'unsigned long'.
	* spvw_sigsegv.d (print_mem_stats): Cast specific fprintf arguments to
	'unsigned long long'.
	* eval.d (check_funtab, CHECK_STACK): Cast specific fprintf arguments to
	'unsigned long'.
	* predtype.d (with_gc_statistics): Likewise.
	* errunix.d (OS_error_arg): Likewise.

2017-03-09  Bruno Haible  <bruno@clisp.org>

	configure: Fail right away if configure could not create intparam.h.
	* configure: Fail immediately if configure could not create intparam.h
	or floatparam.h.

2017-03-08  Bruno Haible  <bruno@clisp.org>

	maint: Add facility for testing builds with DEBUG_GCSAFETY.
	* Makefile.devel (build-porting32-gcc-debug_gcsafety,
	build-porting64-gcc-debug_gcsafety): New targets.

2017-03-08  Sam Steingold  <sds@gnu.org>

	Modify the bug#679 fix: defer getting the TRUENAME of stdio and
	avoid resolving /proc symlinks to non-existing local files
	* lispbibl.d (file_stream_truename): Resolve the deferred TRUENAME.
	* makemake.in (check-script): Add 2 tests.
	* pathname.d (test_file_stream_named): Check name, not truename.
	(file_stream_truename): Move here from stream.d
	(get_path_info): Do not use local symlinks from "/proc".
	(TRUENAME, probe_path_from_stream, DELETE-FILE, RENAME-FILE, OPEN)
	(FILE-WRITE-DATE, FILE-AUTHOR): Use file_stream_truename.
	* stream.d (handle_pathname): Call PATHNAME instead of TRUENAME.
	(handle_to_stream): Do not set strm_file_truename.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	New heuristic for choosing between TYPECODES and HEAPCODES.
	* lispbibl.d (TYPECODES): Do not define on 64-bit platforms for which
	the address ranges do not fit. Do not defined on 32-bit platforms at all.
	Specific platforms might need specific adjustment.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	Fix build failure on AIX in 64-bit mode.
	* makemake.in (AR): Use value determined by autoconf.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	Fix build failure on AIX in 64-bit mode.
	* glm4/lib-ld.m4: Update from gnulib.
	* aclocal.m4, src/configure, modules/*/configure: Regenerated.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	Fix build failures with AIX make.
	* makemake.in (gllib): Do not use a directory name as a target name.
	(clean-subdirs, disclean-subdirs): Do not use $(MAKE) with option -C.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	Fix autoconf test failure on Solaris.
	* m4/address.m4 (CL_ADDRESS_RANGE): Do not redeclare printf.
	Assume ANSI C when redeclaring tmpnam.
	* aclocal.m4, src/configure: Regenerated.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	Avoid miscompiled code by gcc-5.2 on Solaris/SPARC.
	* eval.d (interpret_bytecode_): Disable U_operand assembler code for
	SPARC with gcc 5.

2017-03-05  Bruno Haible  <bruno@clisp.org>

	Do not choose SINGLEMAP_MEMORY with wrong oint_type_len, oint_addr_len.
	(Regression from 2017-02-28.)
	* lispbibl.d: Move definitions of HEAPCODES, TYPECODES, WIDE_STRUCT,
	WIDE_ENDIANNESS, OBJECT_STRUCT, CHART_STRUCT down. Move definition of
	SINGLEMAP_MEMORY up, so that it occurs before the definition of
	oint_type_len, oint_addr_len.
	(SINGLEMAP_MEMORY): Remove special-casing of UNIX_AIX and UNIX_NETBSD,
	because redundant: On AIX, MMAP_FIXED_ADDRESS_HIGHEST_BIT comes out as
	-1. On NetBSD/x86_64, MALLOC_ADDRESS_RANGE has some bits >=
	MMAP_FIXED_ADDRESS_HIGHEST_BIT-6 set.

2017-03-04  Bruno Haible  <bruno@clisp.org>

	Make "make check" more robust.
	The shell command 'test `command` = ...' provokes a syntax error when
	the command produces not exactly one word. To avoid this, use an
	intermediate shell variable and double-quote its access.
	* makemake.in (check-script): Use intermediate variables for output to
	be tested.

2017-03-04  Bruno Haible  <bruno@clisp.org>

	Fix "make check" error on Solaris 10.
	Solaris 10 'tail' does not understand the '-n' option.
	* makemake.in (check-script): Use "sed -n -e '$p'" instead of
	'tail -n 1'.
	* clisp-link.in (clisp_eval): Likewise.

2017-03-04  Bruno Haible  <bruno@clisp.org>

	New configure option --enable-portability.
	It favours portability over optimizations.
	* makemake.in (info_help): Document option --enable-portability.
	(enable_portability): New variable. When set, keep ARI_ASMD and SP_ASMD
	empty and add the following options to the CFLAGS:
	-DNO_ASM -DNO_ARI_ASM -DNO_SP_ASM -DNO_FAST_DISPATCH
	-DNO_FAST_FLOAT -DNO_FAST_DOUBLE -DNO_ALLOCA -DNO_GENERATIONAL_GC.
	* configure (info_help): Document option --enable-portability.
	* Makefile.devel (build-porting*-portability): New targets.
	* unix/PLATFORMS: Recommend --enable-portability instead of -DSAFETY=3.

2017-03-03  Bruno Haible  <bruno@clisp.org>

	Fix build failure with NO_ALLOCA (regression from 2005 or earlier).
	* spvw.d (find_name): Use a DYNAMIC_ARRAY instead of alloca.
	(get_module_symbol): Likewise.
	(dynload_modules): Remove a misplaced FREE_DYNAMIC_ARRAY.
	* spvw_garcol.d (gar_col_normal): Invoke FREE_DYNAMIC_ARRAY in the
	right order.
	* spvw_memfile.d (open_native_filename): New function, extracted from
	open_filename.
	(open_filename): Use a DYNAMIC_ARRAY instead of alloca.
	(loadmem): Likewise.
	* spvw_sigsegv.d (install_stackoverflow_handler): If NO_ALLOCA,
	allocate the fallback stack through malloc instead of alloca.
	* pathname.d (get_path_info): Remove FREE_DYNAMIC_ARRAY of a variable
	allocated in the caller.
	(init_pathnames): Use a DYNAMIC_ARRAY instead of alloca.
	(LAUNCH): Invoke FREE_DYNAMIC_ARRAY in the right order.
	* stream.d (listen_char_keyboard): Use a DYNAMIC_ARRAY instead of
	alloca.
	(rd_ch_terminal3): Likewise.
	(READ-INTEGER, READ-FLOAT, WRITE-INTEGER, WRITE-FLOAT): Fix misuse of
	FREE_DYNAMIC_8BIT_VECTOR.
	* misc.d (REGISTRY): Use a DYNAMIC_ARRAY instead of alloca.
	* lisparit.d (print_integer): Fix misuse of FREE_DYNAMIC_STRING.

2017-03-03  Bruno Haible  <bruno@clisp.org>

	Make it possible to avoid any hand-maintained assembler code.
	* spsparc.d, spsparc64.d (_get_g1): Move from here ...
	* arisparc.d, arisparc64.d: ... to here.
	* arilev0.d: If NO_ARI_ASM is defined, do not reference symbols in the
	assembly-language ari*.d.
	* lispbibl.d: If NO_SP_ASM is defined, do not reference symbols in the
	assembly-language sp*.d.

2017-03-02  Bruno Haible  <bruno@clisp.org>

	Fix build failure on 64-bit platforms with CC="gcc -m32".
	* configure.in: Invoke AC_LIB_PROG_LD.
	* makemake.in (LD): New variable. Use it to produce lisp.o.
	* aclocal.m4, src/configure: Regenerated.

2017-03-02  Bruno Haible  <bruno@clisp.org>

	Check the right set of C symbols against C_CODE_ALIGNMENT, part 2.
	* makemake.in (FALIGNFLAGS): Use it also when compiling socket.d.

2017-03-01  Bruno Haible  <bruno@clisp.org>

	Check the right set of C symbols against C_CODE_ALIGNMENT.
	* pseudofun.d (*PSEUDO_F, *PSEUDO_G): New macros.
	* spvw.d (verify_code_alignment, error_code_alignment): Take a C string
	as second argument instead of a symbol.
	(init_symbol_functions): Do not invoke verify_code_alignment here.
	(init_memory): Invoke verify_code_alignment here.
	* makemake.in (FALIGNFLAGS): New variable. Use it in the compilation of
	specific files.
	* Makefile.devel (build-*): Remove -falign-functions options, now
	handled through makemake.in.

2017-03-01  Bruno Haible  <bruno@clisp.org>

	Fix build failure with GENERIC64_HEAPCODES and -falign-functions=8.
	* makemake.in (WIDE_HARD): New variable.
	(XCFLAGS): If WIDE_HARD is true, add -falign-functions=8, not
	-falign-functions=4.

2017-02-28  Bruno Haible  <bruno@clisp.org>

	Simplify macrology: Remove MAP_MEMORY macro.
	Earlier MAP_MEMORY was SINGLEMAP_MEMORY || MULTIMAP_MEMORY, but since
	2008-07-06 we do not have MULTIMAP_MEMORY any more. It is confusing that
	MAP_MEMORY is not implied by TRIVIALMAP_MEMORY.
	* lispbibl.d (MAP_MEMORY): Remove macro. Use SINGLEMAP_MEMORY instead.
	* spvw_fault.d, spvw_garcol.d, spvw_garcol_old.d: Use SINGLEMAP_MEMORY
	instead.

2017-02-28  Bruno Haible  <bruno@clisp.org>

	Make SINGLEMAP_MEMORY / SPVW_PURE_BLOCKS work on 64-bit platforms.
	* m4/mmap.m4 (CL_MMAP): Add a test that determines
	MMAP_FIXED_ADDRESS_HIGHEST_BIT.
	* lispbibl.d (oint_type_len, oint_addr_len, etc.): If SINGLEMAP_MEMORY
	is defined, define them according to MMAP_FIXED_ADDRESS_HIGHEST_BIT.
	(tint, aint, saint): Do not require oint_type_len, oint_addr_len to be
	literal constants.
	(SINGLEMAP_MEMORY): Define according to MMAP_FIXED_ADDRESS_HIGHEST_BIT
	and some address ranges.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.

2017-02-28  Bruno Haible  <bruno@clisp.org>

	Fix build failure with NO_MULTITHREAD_GC and GENERATIONAL_GC.
	* spvw.d (varobj_mem_region): Moved here ...
	* spvw_garcol.d (varobj_mem_region): ... from here.
	* spvw_garcol_old.d (gar_col_normal): Pass NULL to
	build_old_generation_cache.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Fix build failure with NO_MULTITHREAD_GC (leftover from 2008-10-29).
	* spvw_garcol_old.d (gar_col): Add 'level' argument.

2017-02-26  Sam Steingold  <sds@gnu.org>

	Fix bug#679: when a stream returned by MAKE-STREAM has a path,
	the stream should be an acceptable argument to TRUENAME.
	* stream.d (handle_pathname): Call TRUENAME instead of PATHNAME.
	(handle_to_stream): Set both pathname and truename.

2017-02-26  Sam Steingold  <sds@gnu.org>

	* modules/asdf/asdf.lisp: Upgrade to upstream 3.2.0.
	* Makefile.devel (ASDF_URL): Use https.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Fix error when running the ansi-tests (regression from 2016-08-26).
	* makemake.in: Use clispload.lisp instead of clispload.lsp.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Make it possible to use Makefile.devel from a source distribution.
	* Makefile.devel (SOURCES7): Add version.sh.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	maint: Add facility for testing builds in different configurations.
	* lispbibl.d: Reorganize comments about flags that can be set in CFLAGS.
	* configure: Write log files cbcstep1.log, cbcstep2.log, cbcstep3.log.
	* Makefile.devel (multibuild-porting32-gcc, build-porting32-gcc-*): New
	targets.
	(multibuild-porting32-cc, build-porting32-cc-*): New targets.
	(multibuild-porting64-gcc, build-porting64-gcc-*): New targets.
	(multibuild-porting64-cc, build-porting64-cc-*): New targets.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Use CFLAGS that avoid strict type-based aliasing.
	Without it, at least some version of gcc miscompiles 'update_instance'
	in record.d.
	* makemake.in (XCFLAGS): Add -fno-strict-aliasing or the equivalent
	option for other compilers.
	Reported by Jerry James <loganjerry@gmail.com> in
	<https://sourceforge.net/p/clisp/mailman/message/35687181/>.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Recognize the Sun compiler also on Solaris/x86.
	* makemake.in (XCC_SUNPRO): Use without testing whether TSYS is 'sun4'.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Fix build failures on Solaris 10 with gcc.
	* configure: On Solaris, force CONFIG_SHELL to bash.
	* intparam.c: Do not define _POSIX_SOURCE.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	configure: Fix build failure when CC is set and not GCC
	(regression from 2011-05-17).
	* configure: Ignore exit code of CC_machine assigment statement.

2017-02-26  Bruno Haible  <bruno@clisp.org>

	Fix bug#680: build failure when using --elispdir option.
	* configure: Pass --elispdir option and argument only to makemake.
	Reported by Alex D.

2017-02-25  Bruno Haible  <bruno@clisp.org>

	Fix build failure when using --with-libreadline-prefix option.
	The cause was that the modules/readline/configure script was ignoring
	the --with-libreadline-prefix option during autoconfiguration but not
	during compilation, because acl_libname_spec and acl_shlibext came out
	as empty.
	* m4/readline.m4 (CL_READLINE): AC_REQUIRE the prerequisites of
	AC_LIB_LINKFLAGS_BODY.

2017-02-25  Bruno Haible  <bruno@clisp.org>

	configure: Give some advice when readline or libncurses is not found.
	* m4/readline.m4 (CL_READLINE): If not found, set ac_cv_have_readline
	to 'no, per user request'
	or 'no, consider installing GNU ncurses'
	or 'no, consider installing GNU readline and its header files'
	or 'no, consider installing GNU readline 4.1 or newer'.

2017-02-25  Bruno Haible  <bruno@clisp.org>

	configure: Improve failure message when --with-ffcall cannot be honored.
	* m4/ffcall.m4 (CL_LIBFFCALL_DOWNLOAD_URL): New macro.
	(CL_FFCALL): Upon failure, suggest to build a downloaded tarball. Fix
	the final configure invocation line.

2017-02-25  Bruno Haible  <bruno@clisp.org>

	configure: Give some advice when libffcall is not found.
	* m4/ffcall.m4 (CL_FFCALL): If not found, set cl_cv_have_ffcall to
	'no, consider installing GNU libffcall'.
	* configure: Adjust accordingly.

2017-02-24  Bruno Haible  <bruno@clisp.org>

	Fix build failure on non-glibc platforms.
	* utils/*.c: Include <config.h>.
	* src/makemake.in (UTILS, hardcode): Compile with option "-I.".
	Reported by Sam Steingold.

2017-02-24  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove leftover of obsolete Atari ST charset conversion.
	* makemake.in (CHSCONVERT, CHSCONVERT_FILTER): Remove variables.

2017-02-24  Bruno Haible  <bruno@clisp.org>

	Fix clang warning "'-falign-functions=4' is not supported" on Mac OS X.
	* makemake.in (XCC_BRAND): Set to 'clang' also for the system compiler
	on Mac OS X 10.11.
	Reported by Sam Steingold.

2017-02-24  Bruno Haible  <bruno@clisp.org>

	maint: Update download of ansi-tests.
	* Makefile.devel (ANSITESTS_REPO): New variable.
	(ANSITESTS_SVN): Remove variable.
	(update-ansi-tests): Use git instead of svn.

2017-02-22  Bruno Haible  <bruno@clisp.org>

	maint: Structure Makefile.devel.
	* Makefile.devel: Reorganize in sections and subsections.

2017-02-21  Bruno Haible  <bruno@clisp.org>

	Update libsigsegv download location.
	* configure (libsigsegv_url): Use the official download location.

2017-02-20  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux/arm.
	* makemake.in (ARI_ASMD): Treat cpu 'armhf' like 'arm'.

2017-02-20  Bruno Haible  <bruno@clisp.org>

	Fix syntax errors in makemake.in (regression from 2010-07-13).
	* makemake.in: Add ';;' before 'esac'.

2017-02-20  Bruno Haible  <bruno@clisp.org>

	Remove obsolete file.
	* unix/sigsegv.c: Remove file. Obsoleted by the libsigsegv package.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Remove the assembly-language optimizations for m68k.
	They are bitrotten, since Linux/m68k is dead. Modern m68k variants
	probably have different performance characteristics than the 68020.
	* ari68020.d: Remove file.
	* makemake.in (ARI_ASMD, ARI_ASMS, ARI_ASMC): Simplify accordingly.
	* arilev1.d: Likewise.
	* arilev0.d (sign_of_sint32, sign_of_sint16, high16, highlow32,
	highlow32_0, mulu32, divu_3216_1616, divu_6432_3232): Remove __asm__
	code for m68k.
	* intlog.d (integerlength16, integerlength32: Likewise.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Fix collision between ASCII character names and Unicode character names.
	* charstrg.d (char_name): Special case for #\U0001F514 and #\U0001F5CF.
	(name_char): Special case for "UNICODE_BELL" and "UNICODE_PAGE".

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Fix clang warning "flag '-falign-functions=4' is not supported".
	* makemake.in (XCC_BRAND): New variable.
	(XCFLAGS): Do not use -falign-functions=4 with clang.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Fix build failure with clang.
	* lispbibl.d (STACK_register, mv_count_register, value1_register,
	SP_register): Do not define for clang.
	(restartf_t): Do not use _Noreturn on a function type, except with GCC.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Make --with-lib{sigsegv,ffcall}-prefix work with clang on 64-bit Ubuntu.
	* glm4/lib-prefix.m4: Update from gnulib.
	* aclocal.m4, src/configure, modules/*/configure: Regenerated.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Modernize: Really update to the newest gnulib.
	Ran "make -f Makefile.devel build-aux-update gnulib-imported
	build-prerequisites".
	* Makefile.devel (GNULIB_AUX, build-aux-update): Fetch depcomp and
	install-sh from Automake, not gnulib. Fetch also ar-lib from Automake.
	* build-aux/config.guess: Update from gnulib git.
	* build-aux/config.rpath: Likewise.
	* build-aux/config.sub: Likewise.
	* build-aux/ar-lib: New file, from automake git.
	* build-aux/compile: Update from automake git.
	* build-aux/depcomp: Likewise.
	* build-aux/missing: Likewise.
	* build-aux/ylwrap: Likewise.
	* build-aux/snippet/*: Update from gnulib.
	* gllib/*: Likewise.
	* glm4/*: Likewise.
	* gllib/Makefile.am, gllib/Makefile.in: Regenerated.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated.
	* modules/*/configure, modules/*/config.h.in: Likewise.
	* modules/*/*/config.h.in, modules/*/*/configure: Likewise.
	* utils/txt2c.c (process_file): Handle multiline #if directives.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	maint: Fix conflict between fix-perms.sh and gnulib import.
	* utils/fix-perms.sh: Do not clobber the permissions of
	gllib/uniname/gen-uninames.lisp.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Fix build failure on Linux with musl libc.
	* unix.d: Do not include <asm/page.h>. Instead, assume SHMLBA is
	defined in <sys/shm.h>.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Disable the 'ulimit -s 16384' recommendation, except on PowerPC.
	* configure (STACK_LIMIT): Set to 8192 on all CPUs except PowerPC.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Recommend libsigsegv 2.11.
	* configure (libsigsegv_url): Update to 2.11.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Define a single place to set the libsigsegv download URL.
	* configure (libsigsegv_url): New variable.
	(SIGSEGV): Remove variable.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Fix build failure when --with-libsigsegv-prefix option is used.
	* makemake.in (LIBSIGSEGV): Use @LIBSIGSEGV@, not @LTLIBSIGSEGV@.
	Rationale: While @LIBSIGSEGV@ contains -Wl,-rpath options,
	@LTLIBSIGSEGV@ contains -R options, which are meant for the libtool
	script. But we do not invoke the libtool script for linking.

2017-02-19  Bruno Haible  <bruno@clisp.org>

	Support the standard way of building GNU packages.
	* Makefile.in: New file.
	* Makefile.devel (SOURCES1): Add it.
	* configure.in: Invoke AC_PROG_MAKE_SET. Create Makefile from
	Makefile.in if building in the source directory.

2017-02-08  Sam Steingold  <sds@gnu.org>

	* spvw.d (init_symbol_values) [UNIX_MACOSX]: Set
	SYS::*DISASSEMBLE-USE-LIVE-PROCESS* to NIL because
	otherwise DISASSEMBLE hangs CLISP.

2017-01-29  Bruno Haible  <bruno@clisp.org>

	Fix build problem on 32-bit platforms, introduced on 2016-11-13.
	* dfloat.d (DF_DF_mult_DF): Do not use bitQ() to test a bit of an uintD.
	Reported by Jerry James <loganjerry@gmail.com> in
	<https://sourceforge.net/p/clisp/mailman/message/35632512/>.

2016-11-13  Bruno Haible  <bruno@clisp.org>

	Define known facts for more CPUs.
	* lispbibl.d (ARM64, POWERPC64, S390_64): New macros.
	(MIPS64): Define more reliably.
	(C_CODE_ALIGNMENT, log2_C_CODE_ALIGNMENT): Define for many CPUs, based
	on GCC. For DECALPHA, set C_CODE_ALIGNMENT to 4 instead of 8.

2016-11-13  Bruno Haible  <bruno@clisp.org>

	Reduce portability effort for yet unknown 64-bit platforms.
	* lispbibl.d (intQsize, HAVE_DD): Define also when long_bitsize==64 but
	the CPU is unknown.
	(intBWsize, intWLsize, intBWLsize): Define always.
	(intDsize, intDDsize, log2_intDsize): Likewise.

2016-11-13  Bruno Haible  <bruno@clisp.org>

	Add support for Linux/x32 ABI on x86_64.
	* lispbibl.d (WIDE_HARD): Define depending on long_bitsize and
	pointer_bitsize, not on preprocessor defines like __x86_64__.
	(LINUX_NOEXEC_HEAPCODES): Pick as default memory model on Linux/x32.
	Do not forbid SINGLEMAP_MEMORY on Linux/x32.

2016-11-13  Bruno Haible  <bruno@clisp.org>

	Prepare for ILP32 ABIs on 64-bit CPUs (x32 on x86_64, n32 on MIPS64).
	* lispbibl.d (bitQ, bitQm, bitQ_test, minus_bitQ, minus_bitQm): New
	macros, available when intQsize is defined.
	* intsqrt.d (UDS_sqrt_) [ifdef intQsize]: Use bitQ(..) instead of
	bit(..).
	* dfloat.d (dfloat_decode, encode_DF, double_to_DF, DF_ftruncate_DF,
	DF_futruncate_DF, DF_fround_DF, DF_minus_DF, DF_DF_plus_DF,
	DF_DF_minus_DF, DF_DF_mult_DF, DF_DF_div_DF, DF_sqrt_DF, I_to_DF,
	RA_to_DF) [ifdef intQsize]: Likewise.
	* flo_konv.d (DF_to_SF, DF_to_FF, LF_to_DF) [ifdef intQsize]: Likewise.
	* flo_rest.d (F_decode_float_F_I_F, F_float_sign_F) [ifdef intQsize]:
	Likewise.
	* lisparit.d (init_arith): Likewise.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove old Linux workaround.
	* makemake.in (XCFLAGS): Remove workaround for Linux < 1.1.52.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove old GCC bug workaround.
	* lispbibl.d (DYNAMIC_ARRAY): Remove old GCC 2.5.5 workaround.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Update to automake-1.15, libtool-2.4.6, the newest gnulib.
	* Makefile.devel (LIBTOOL_VERSION): Bump to 2.4.6.
	(AUTOMAKE_VERSION): Bump to 1.15.
	(GTK_GIT_ROOT): New variable, replaces GTK2_SVN_ROOT.
	(GNULIB_AUX, build-aux-update): Fetch 'missing' from Automake, not from
	gnulib.
	Update relative paths of files from libtool tarball.
	Fetch both gtk-2.0.m4 and gtk-3.0.m4.

	* m4/libtool.m4: Update from libtool-2.4.6.
	* m4/ltoptions.m4: Likewise.
	* m4/ltsugar.m4: Likewise.
	* m4/ltversion.m4: Likewise.
	* m4/lt~obsolete.m4: Likewise.
	* build-aux/ltmain.sh: Likewise.

	* build-aux/compile: Update from Automake git.
	* build-aux/missing: Likewise.
	* build-aux/ylwrap: Likewise.

	* build-aux/config.guess: Update from gnulib git.
	* build-aux/config.rpath: Likewise.
	* build-aux/config.sub: Likewise.
	* build-aux/depcomp: Likewise.
	* build-aux/install-sh: Likewise.

	* m4/gtk-2.0.m4: Update from GNOME git.
	* m4/gtk-3.0.m4: New file, from GNOME git.

	* gllib/Makefile.in: Regenerated with Automake 1.15.
	* aclocal.m4, src/configure, src/config.h.in: Regenerated with
	Autoconf 2.69.
	* modules/*/configure, modules/*/config.h.in: Likewise.
	* modules/*/*/config.h.in, modules/*/*/configure: Likewise.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Fix Makefile.devel syntax error introduced on 2011-04-21.
	* Makefile.devel (build-aux-update): Correct shell syntax.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Assume intDsize >= 16.
	* arilev1.d (sign_of_sintD, muluD, muluD_unchecked, divuD, floorD, D):
	Simplify accordingly.
	* intelem.d (get_32_Dptr, set_32_Dptr, get_max32_Dptr, set_max32_Dptr,
	I_to_UQ, I_to_Q, L_to_I, UL_to_I, L2_to_I, UL2_to_I, UQ_to_I): Simplify
	accordingly.
	* intlog.d (logcount_8, integerlength8): Remove macros.
	(I_logcount_I, integerlengthD): Simplify accordingly.
	* intprint.d (table): Likewise.
	* dfloat.d (DF_DF_mult_DF, DF_DF_div_DF, DF_sqrt_DF): Likewise.
	* hashtabl.d (hashcode_bignum): Likewise.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for mc680x0 CPUs on HP-UX.
	* lispbibl.d: Assume HPUX_ASSEMBLER is not defined.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for mc680x0 CPUs before mc68020.
	* lispbibl.d (M68K): Define instead of MC680X0 or MC680Y0.
	Adjust all code accordingly. Remove code conditional for MC68000 only.
	* eval.d, arilev0.d, arilev1.d, intelem.d, intlog.d, foreign.d: Adjust
	accordingly.
	* ari68000.d: Remove file.
	* makemake.in, utils/d2c/Makefile.in: Remove handling of ari68000.d.

2016-11-12  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for long dead platforms.
	* makemake.in: Remove most special values of TARGET argument.
	Drop support for GCC versions older than 2.95.
	Make GCC version handling future-proof.
	Drop support for Ultrix, IRIX 4, old SVR4, HP300.
	For debugging, use -ggdb instead of -g.
	* utils/txt2c.c: Remove support for QUOTE_QUOTES.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for IRIX.
	* lispbibl.d (UNIX_IRIX, UNIX_IRIX5): Remove macros.
	(GENERATIONAL_GC): Update.
	* spvw_mmap.d (mmap_init_pagesize): Remove IRIX workaround.
	* spvw_sigsegv.d (stackoverflow_handler_continuation): Likewise.
	* pathname.d (realpath): Likewise.
	* stream.d (IS_EINVAL_EXTRA): Likewise.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for Data General DG/UX.
	* lispbibl.d (UNIX_DGUX): Remove macro.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for Amiga UNIX.
	* lispbibl.d (UNIX_AMIX): Remove macro.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for Apple A/UX.
	* lispbibl.d (UNIX_AUX): Remove macro.
	* unix.d: Remove Apple A/UX workaround.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for Unix SYSV from around 1995.
	* lispbibl.d (UNIX_SYSV_USL, UNIX_SYSV_UHC_1, UNIX_SYSV_PTX): Remove
	macros.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for SINIX.
	* lispbibl.d (UNIX_SINIX): Remove macro.
	(SINGLEMAP_MEMORY): Remove SINIX workaround.
	* src/spvw_mmap.d (mmap_init_pagesize): Likewise.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize: Remove support for Ultrix.
	* lispbibl.d (UNIX_DEC_ULTRIX, UNIX_DEC_ULTRIX_GCCBUG): Remove macros.
	* control.d: Remove Ultrix GCC workarounds.
	* array.d: Likewise.
	* flo_rest.d: Likewise.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Modernize blurbs and comments.
	* COPYRIGHT: Update year.
	* SUMMARY: Remove outdated infos. Use https URLs where available.
	* unix/PLATFORMS: Trim list of platforms and hints. Mention
	GENERIC64_HEAPCODES.
	* lispbibl.d: Remove comment about old (now all museum) platforms.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Make GENERIC64{A,B}_HEAPCODES work with -falign-functions=4.
	* lispbibl.d (machinep) [GENERIC64A_HEAPCODES, GENERIC64B_HEAPCODES]:
	Define in such a way that machine pointers only need to be aligned
	mod 4.
	(C_CODE_ALIGNMENT) [GENERIC64A_HEAPCODES, GENERIC64B_HEAPCODES]:
	Do not redefine to 8.
	(LINUX_NOEXEC_HEAPCODES, GENERIC64A_HEAPCODES, GENERIC64B_HEAPCODES):
	Update comments.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Fix weird errors when rebuilding 'base' after having changed CFLAGS.
	* makemake.in (clean1): Remove also the .o files in the BASE_MODULES.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Fix a "No more room for LISP objects" error when building syscalls.
	The clisp modprep call now needs at least -m 1180KW.
	* modules/syscalls/Makefile.in (calls.m.c): Add option -m 2MW.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Make GENERIC64A_HEAPCODES work again after the type predicates change
	from 2016-11-10.
	* lispbibl.d (immediate_bias_mask) [HEAPCODES]: Define.
	(immediate_object_p) [HEAPCODES]: Define using immediate_bias_mask.
	(immediate_number_p, charp, small_read_label_p, systemp, if_realp,
	if_rationalp, integerp, fixnump, posfixnump, floatp, short_float_p)
	[HEAPCODES]: Use immediate_bias_mask instead of
	immediate_bias | nonimmediate_bias_mask.

2016-11-11  Bruno Haible  <bruno@clisp.org>

	Fix compilation error of DEBUG_BACKTRACE feature with C++ compiler.
	Fixes a regression introduced on 2008-01-09.
	* debug.d (print_bt_to_frame): Change type of bt_ parameter.

2016-11-10  Bruno Haible  <bruno@clisp.org>

	Remind user to use -falign-functions=8 with GENERIC64_HEAPCODES.
	* lispbibl.d (C_CODE_ALIGNMENT, log2_C_CODE_ALIGNMENT):
	For GENERIC64_HEAPCODES, require that the alignment is at least 8.

2016-11-10  Bruno Haible  <bruno@clisp.org>

	New memory model GENERIC64_HEAPCODES, for 64-bit machines.
	* lispbibl.d (GENERIC64_HEAPCODES): Define if GENERIC64A_HEAPCODES or
	GENERIC64B_HEAPCODES or GENERIC64C_HEAPCODES is defined.
	(oint_type_shift, oint_type_len, oint_type_mask, oint_data_shift,
	oint_data_len, oint_data_mask, garcol_bit_o, machine_bias,
	varobject_bias, cons_bias, immediate_bias, subr_bias, imm_type_shift,
	immediate_object_p, machinep): Define for each of GENERIC64A_HEAPCODES,
	GENERIC64B_HEAPCODES, GENERIC64C_HEAPCODES.
	(fixnum_type, sfloat_type, char_type, small_read_label_type,
	system_type, sign_bit_t, sign_bit_o, bignum_bit_o, number_immediatep,
	nonimmediate_bias_mask, nonimmediate_heapcode_mask, type_data_object,
	type_zero_oint, gcinvariant_object_p, gcinvariant_oint_p,
	gcinvariant_bias_p, nonimmediate_heapnr) [GENERIC64_HEAPCODES]: Define.
	(varobject_alignment) [GENERIC64_HEAPCODES]: Require to be at least 8.
	(subr_t) [GENERIC64_HEAPCODES]: Force alignment of 8.
	Otherwise treat GENERIC64_HEAPCODES like LINUX_NOEXEC_HEAPCODES.
	* spvw.d (init_memory) [GENERIC64A_HEAPCODES, GENERIC64B_HEAPCODES]:
	mmap a hole.
	(init_memory) [GENERIC64_HEAPCODES]: Guess where the heap may end.
	* spvw_gcmark.d (gc_mark) [GENERIC64_HEAPCODES]: Recognize immediate
	values.
	* spvw_memfile.d (loadmem_update): Treat GENERIC64_HEAPCODES like
	LINUX_NOEXEC_HEAPCODES.
	* io.d (pr_orecord): Likewise.
	* lightning.c (jitc_getsize_framer, jitc_get_framecoder): Likewise.
	* built.d (built_flags): Consider GENERIC64_HEAPCODES.
	Suggested by Florian Weimer.

2016-11-10  Bruno Haible  <bruno@clisp.org>

	Prepare for GENERIC64_HEAPCODES object model.
	* lispbibl.d (immediate_number_p, charp, small_read_label_p, systemp,
	if_realp, if_rationalp, integerp, fixnump, posfixnump, floatp,
	short_float_p) [!TYPECODES]: Include nonimmediate_bias_mask in the
	bit mask.

2016-11-10  Bruno Haible  <bruno@clisp.org>

	Support for memory models with oint_data_len >= 55.
	* dfloat.d (RA_to_DF): Add code for oint_data_len >= 55.

2016-11-09  Bruno Haible  <bruno@clisp.org>

	Fix compilation error of OBJECT_STRUCT mode with g++ versions < 4.7.
	Fixes a regression introduced on 2016-08-28.
	* lispbibl.d (designated_init): New macro.
	(as_object, INIT_ALLOCSTAMP, gcv_object_t::operator object(), as_chart):
	Use it.

2016-11-09  Bruno Haible  <bruno@clisp.org>

	Fix g++ warnings of type -Wc++0x-compat.
	* eval.d (augment_decl_env): Rename local variable 'decltype'.
	* control.d (PROCLAIM): Likewise.

2016-11-09  Bruno Haible  <bruno@clisp.org>

	Fix gcc warning of type -Wformat.
	* spvw.d (init_subr_tab_1): Cast fprintf argument to 'int'.

2016-11-09  Bruno Haible  <bruno@clisp.org>

	Fix gcc warnings of type -Wparentheses.
	* spvw_language.d (init_language): Put braces.
	* charstrg.d (nstring_invertcase, nstring_upcase, nstring_downcase):
	Likewise.
	* pathname.d (directory_search_scandir): Likewise.
	(init_launch_streamarg): Simplify boolean expression.
	* intelem.d, flo_rest.d: Use #pragma GCC diagnostic.

2016-11-09  Bruno Haible  <bruno@clisp.org>

	Fix a relevant gcc warning of type -Wclobbered.
	* pathname.d (direntry_to_string): Use 'volatile' to disallow a
	dangerous compiler optimization.

2016-11-09  Bruno Haible  <bruno@clisp.org>

	Fix compilation error introduced on 2007-11-26.
	* spvw_allocate.d (error_speicher_voll): Rename to
	error_memory_exhausted and handle_memory_exhausted, respectively.

2016-09-04  Sam Steingold  <sds@gnu.org>

	* utils/fix-perms.sh: replace obsolete "-perm +111" with
	"-perm /111" and .cvsignore with .hgignore

2016-08-29  Sam Steingold  <sds@gnu.org>

	* lispbibl.d, built.d, spvw.d, spvw_garcol.d, spvw_garcol_old.d:
	* spvw_mark.d: remove the obsolete object representation WIDE_AUXI

2016-08-29  Sam Steingold  <sds@gnu.org>

	* utils/modprep.lisp (modprep): bind *module-name*, *module-line*,
	*module-package*, *package-properties* here ...
	(parse): ... not here
	(lexical-analysis): ignore //-comments inside /*-comments

2016-08-29  Sam Steingold  <sds@gnu.org>

	* makemake.in (check-script) [darwin]: disable nohup
	http://stackoverflow.com/questions/29112446/nohup-doesnt-work-with-os-x-yosmite-get-error-cant-detach-from-console-no-s
	http://stackoverflow.com/questions/23898623/nohup-cant-detach-from-console

2016-08-29  Sam Steingold  <sds@gnu.org>

	Fix bug#677: logical pathnames and letter case gone wrong
	* compiler.lisp (compile-file-pathname-helper): when output is
	supplied and is physical, translate input from logical before merge

2016-08-29  Sam Steingold  <sds@gnu.org>

	Fix bug#684: modprep handling of quotation mark in single line comment
	* utils/modprep.lisp (lexical-analysis): handle // comments

2016-08-28  Sam Steingold  <sds@gnu.org>

	* utils/modprep.lisp (output-all): bind all global variables in
	appropriate functions to allow loading into the same lisp session
	(output-all): make sure that the file name is printed on #line 1
	without #P
	(custom:*suppress-similar-constant-redefinition-warning*)
	[:compile-toplevel]: set to T to avoid the warnings on reload

2016-08-28  Sam Steingold  <sds@gnu.org>

	* genclisph.d (emit_export_declaration, struct typecode_entry):
	use `const' to avoid the warning:
	deprecated conversion from string constant to ‘char*’ [-Wwrite-strings]

2016-08-28  Sam Steingold  <sds@gnu.org>

	avoid the clang -Wgnu-designator warning
	* lispbibl.d (as_object, as_chart): use the new {.one_o=???}
	syntax instead of GNU old-style field designator extension {one_o:???}
	https://gcc.gnu.org/onlinedocs/gcc-6.2.0/gcc/Designated-Inits.html

2016-08-26  Sam Steingold  <sds@gnu.org>

	Fix bug#686: missing CFLAG -falign-functions=4 in Makefile
	* makemake.in (XCFLAGS) [XCC_GCC]: treat gcc 5 & 6 like 3 & 4

2016-08-14  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (hardlink_file_o): add
	(copy_one_file): fix GC-safety bugs

2016-08-12  Sam Steingold  <sds@gnu.org>

	* modules/pcre/cpcre.c (PCRE:PCRE-EXEC): fix a GC-safety bug

2016-08-12  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (copy_one_file): fix STACK depth handling

2016-08-11  Sam Steingold  <sds@gnu.org>

	* pathname.d (delete_directory): fix rmdir() failure handling

2016-08-11  Sam Steingold  <sds@gnu.org>

	* package.d (intern): cerror_package_locked can trigger GC

2016-08-11  Sam Steingold  <sds@gnu.org>

	* makemake.in (make_modules): create separate targets for base and
	full modules because the former are compiled using the boot
	linking set, while the latter (e.g., asdf) require the base linking set

2016-08-11  Sam Steingold  <sds@gnu.org>

	* modules/bindings/glibc/linux.lisp: avoid
	error: "Never use <bits/ipctypes.h> directly; include <sys/ipc.h> instead."
	by including <sys/ipc.h> instead of <bits/ipctypes.h>

2016-06-09  Daniel Jour  <daniel.oertwig@gmail.com>

	Disable TRIVIALMAP_MEMORY and SINGLEMAP_MEMORY on NetBSD due to
	mmap and MAP_FIXED issues
	* lispbibl.d (TRIVIALMAP_MEMORY, SINGLEMAP_MEMORY) [UNIX_NETBSD]:
	disable

2016-05-16  Daniel Jour  <daniel.oertwig@gmail.com>

	Update asdf to version 3.1.7
	* modules/asdf/asdf.lisp: Update to asdf 3.1.7
	* modules/asdf/asdf.xml: Update asdf module description

2016-05-01  Daniel Jour  <daniel.oertwig@gmail.com>

	* lispbibl.d (VALUE1_EXTRA) [!value1_register]: do not define
	This fixes patch 93dee6a014b2 (2008-01-13) as discussed in
	https://sourceforge.net/p/clisp/mailman/message/35061096/

2015-03-18  Ken Brown  <kbrown@cornell.edu>

	Fix dynamic loading on Cygwin (patch#44)
	* src/genclisph.d [UNIX_CYGWIN32]: Fix syntax error in lisp.def
	* src/makemake.in (archive_cmds): Fix definition on Cygwin
	(lisp.def): Add "hostent_to_lisp" to lisp.def on Cygwin
	(clisp-link): Use absolute path to lisp.def

2015-03-05  Ken Brown  <kbrown@cornell.edu>

	* src/lispbibl.d (ULONGLONG): Avoid conflict with w32 typedef on
	64-bit Cygwin (patch#43)

2015-03-05  Ken Brown  <kbrown@cornell.edu>

	* lispbibl.d, ari80386.d, ari80386.msvc.c, asmi386.h, asmi386.hh:
	* sp80386.d, sp80386.msvc.c: Use __CYGWIN__ instead of __CYGWIN32__
	to detect Cygwin: __CYGWIN32__ is deprecated and, more
	importantly, is not defined on 64-bit Cygwin (patch#42)

2015-03-05  Ken Brown  <kbrown@cornell.edu>

	* src/m4/signal.m4: Remove obsolete Cygwin-specific code (patch#41)

2015-03-04  Ken Brown  <kbrown@cornell.edu>

	The Cygwin heap is now in high memory, so STANDARD_HEAPCODES
	no longer work (patch#38).
	* src/lispbibl.d (LINUX_NOEXEC_HEAPCODES) [UNIX_CYGWIN32]: Define

2015-03-04  Ken Brown  <kbrown@cornell.edu>

	"Handle" is used in a w32 prototype, interfering with our
	definition of it as a macro (patch#36).
	* src/unix.d [UNIX_CYGWIN32]: Work around namespace pollution in
	w32 headers

2014-10-22  Sam Steingold  <sds@gnu.org>

	Fix bug#668 posix:file-state always return NIL for :rdev
	* modules/syscalls/configure.in: check for struct stat members

2014-05-11  Sam Steingold  <sds@gnu.org>

	* m4/termcap.m4 (CL_TERMCAP): also look for tgetent in tinfo;
	fixes bug#665 as suggested by Jason Miller <jasontkd@users.sf.net>

2013-04-14  Sam Steingold  <sds@gnu.org>

	* modules/asdf/asdf.lisp: upgrade to 2.33

2013-01-06  Sam Steingold  <sds@gnu.org>

	Avoid startup errors when the user has weird ~/.clisp
	* pathname.d, subr.d (PROBE-PATHNAME): accept &key (:error t)
	* spvw.d (main_actions): pass :ERROR NIL to PROBE-PATHNAME

2013-02-08  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/demos/clx-demos.lisp: require CLX

2013-02-05  Sam Steingold  <sds@gnu.org>

	* modules/bindings/glibc/linux.lisp (__swblk_t): remove the unused
	`def-c-type' (removed from glibc too); fixes bug#656;
	see also <http://article.gmane.org/gmane.comp.lib.glibc.alpha/25618>
	aka <https://sourceware.org/ml/libc-alpha/2012-10/msg00035.html>

2013-01-06  Bruno Haible  <bruno@clisp.org>

	* pathname.d (unix_user_pwd): Do not use getlogin().
	Reported by Alberto Riva <alb@chip.org> in
	<http://article.gmane.org/gmane.lisp.clisp.general:13995>
	<https://sourceforge.net/p/clisp/mailman/message/30303970/>

2012-11-23  Sam Steingold  <sds@gnu.org>

	* modules/oracle/Makefile.in (ALL_CFLAGS): new variable,
	accumulate all C flags here, move -I$(srcdir) here from CPPFLAGS
	which is overridden by clisp-link invocation from Makefile

2012-11-20  Sam Steingold  <sds@gnu.org>

	PCRE-EXEC returns character positions instead of byte positions
	* lispbibl.d (Encoding_mblen): export to clisp.h
	* modules/pcre/cpcre.c (PCRE-EXEC): use it convert ovector (byte
	positions) to MATCH (character positions)
	Reported by Mike Palmer <michaeljohnpalmer@gmail.com> in
	<http://article.gmane.org/gmane.lisp.clisp.general:13972>
	<https://sourceforge.net/p/clisp/mailman/message/30115294/>

2012-11-29  Sam Steingold  <sds@gnu.org>

	* modules/oracle/oracle.lisp: code clean-up for better performance
	and error reporting
	(db-error, nl, out, out-nl): remove
	(check-seq-type): add
	(fetch-all): use it
	(update-row, comma-list-of-keys, join): use WITH-OUTPUT-TO-STRING
	instead of CAT so that the algorithm is linear instead of quadratic
	(check-pairs): use ETYPECASE
	(to-string): use PRINC-TO-STRING instead of FORMAT

2012-09-14  Vladimir Tzankov  <vtzankov@gmail.com>

	implement RFE#49
	* threads.lisp (*DEFAULT-SPECIAL-BINDINGS*): add abort restart that
	kills current thread - exits with two values: :ABORT and current
	internal real time

2012-08-20  Vladimir Tzankov  <vtzankov@gmail.com>

	* lispbibl.d (per_thread): TLS (i.e. __thread qualifier) is supported
	by gcc 4.5+ on MacOSX and results in significant performance gain

2012-08-03  Vladimir Tzankov  <vtzankov@gmail.com>

	* stream.d (wr_by_array_iau8_buffered): pin the source buffer before
	performing actual write

2012-05-03  Sam Steingold  <sds@gnu.org>

	update berkeley-db to 5.1
	* modules/berkeley-db/bdb.c (add_message): fix
	(DB-VERSION): use db_full_version when available
	(DBE-CREATE): remote is no longer supported by upstream
	(dbt_to_object): also return nil when p_dbt->size==0
	(DB-COMPACT): add
	(DB-VERIFY): mark the db handle invalid because it "may not be accessed
	again after DB->verify() is called, regardless of its return"

2012-04-27  Sam Steingold  <sds@gnu.org>

	Fix bug#625: symlink to directory handling
	* modules/syscalls/calls.c (symlink_file): strip trailing "/" from
	new_pathstring
	(copy_one_file): use PROBE-PATHNAME instead of PROBE-FILE to
	accommodate directories
	* pathname.d (delete_directory): when rmdir() fails with ENOTDIR,
	call unlink() because we are dealing with a symbolic link

2012-04-23  Sam Steingold  <sds@gnu.org>

	* format.lisp (format-apply): do not bind *FORMAT-CS* here ...
	(formatter): ... do it here instead for run-time error reporting
	in compiled FORMAT calls [bug#631]

2012-04-23  Sam Steingold  <sds@gnu.org>

	Do not signal errors inside begin/end_blocking_system_call blocks
	Reported by Don Cohen <http://article.gmane.org/gmane.lisp.clisp.devel:22914>
	<https://sourceforge.net/p/clisp/mailman/message/29165154/>
	* modules/syscalls/calls.c (POSIX:OPENLOG): use clisp_realloc
	instead of clisp_malloc/free
	(my_chmod, my_chown, my_utime): return status instead of signaling
	(SET-FILE-STAT): signal errors after end_blocking_system_call
	(FILE-INFO): do not jump out of a begin/end_blocking_system_call block

2012-04-23  Sam Steingold  <sds@gnu.org>

	* modules/gdbm/gdbm.c (error_bad_type): fix declaration (for g++)
	* modules/rawsock/rawsock.c (RAWSOCK:CONVERT-ADDRESS): add a cast

2012-04-23  Sam Steingold  <sds@gnu.org>

	* makemake.in (XCFLAGS): do not add -Wimplicit when compiling with C++:
	"warning: command line option `-Wimplicit' is valid for C/ObjC but not for C++"

2012-04-20  Sam Steingold  <sds@gnu.org>

	Fix bug#636: APPLY reacts differently to dotted list when compiled
	* eval.d (error_apply_dotted): remove; use error_subr_toofew() instead
	(apply_subr, apply_closure): more checks for dotted argument list

2012-04-23  Sam Steingold  <sds@gnu.org>

	* defs1.lisp (logical-pathname-translations): signal TYPE-ERROR on
	non-existent logical host as per ANSI [bug#638]

2012-04-19  Sam Steingold  <sds@gnu.org>

	The official binary IP address representation is now a byte
	vector, not an integer.
	* socket.d (string_to_addr1): use data_to_sb8vector instead of
	LEbytes_to_UI
	* modules/rawsock/rawsock.c (CONVERT-ADDRESS): ipv6 is 128 bits,
	not 64; accept byte vectors too
	* modules/rawsock/test.tst: use CONVERT-ADDRESS instead of ip->ve

2012-04-19  Sam Steingold  <sds@gnu.org>

	* array.d (data_to_sbvector): add a modexp function
	(copy_sbvector): use it
	* lispbibl.d (data_to_sbvector): add the prototype
	(data_to_sb8vector): add a #define and export both to clisp.h
	* modules/berkeley-db/bdb.c, modules/clx/new-clx/clx.f:
	* modules/dirkey/dirkey.c, modules/gdbm/gdbm.c:
	* modules/pcre/cpcre.c, modules/rawsock/rawsock.c:
	* modules/syscalls/calls.c: use them

2012-04-18  Sam Steingold  <sds@gnu.org>

	* error.d (error_pos_integer): add, based on charstrg.d:error_posint
	* lispbibl.d (error_pos_integer): add the prototype
	* charstrg.d (error_posint): remove
	(test_index): use error_pos_integer instead
	* sequence.d (error_posint): remove
	(test_start_end, test_start_end_1, test_count_arg):
	use error_pos_integer instead

2012-03-27  Sam Steingold  <sds@gnu.org>

	* modules/pcre/cpcre.c (pcre_config_option): check the return
	value of pcre_config() and use a long for value storage

2012-03-27  Sam Steingold  <sds@gnu.org>

	* modules/i18n/gettext.c (bool_char_lconv, int_char_lconv): treat
	-1 like CHAR_MAX and use sfixnum instead of fixnum

2012-03-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* hashtabl.d (prepare_resize): check kvtable size against
	ARRAY-DIMENSION-LIMIT

2012-03-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* lispbibl.d (arraysize_limit_1) [MACOSX, WIDE_HARD]: set to
	2^24-2 since HEAPCODES memory model is used

2012-03-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* spvw.d (signal_handler_thread) [MULTITHREAD, MACOSX]: ignore
	SIGHUP & SIGCONT until I know how to handle them (vfork()
	causes SIGHUP - e.g. (DISASSEMBLE 'CAR))

2012-03-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* foreign.d (FOREIGN-CALL-OUT): foreign call may block. use
	begin/end_block_system_call()

2012-02-13  Bruno Haible  <bruno@clisp.org>

	* clos-genfun2b.lisp (compute-dispatch): Do not blindly assume that
	(bc-and-not class test-class) is non-nil; test it explicitly.
	[bug#628]

2012-02-02  Sam Steingold  <sds@gnu.org>

	* socket.d (get_hostname): turn into a function and allocate the
	array in the caller to support gcc 4.7 [patch#31]

2012-02-02  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (file_stat_to_STACK): use off_to_I
	instead of L_to_I for st_size [bug#626]
	[S_IFMT]: split st_mode into mknod_type_check and check_chmod_mode

2012-01-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* spvw.d (mt_main_actions): main thread should be the same as any
	other - initialize time, reader and set normal exit flag

2012-01-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* zthread.d (xlock_lock_helper): fix possible deadlock when acquiring
	a lock released by xcondition_wait()
	(THREAD-INTERRUPT): release thread's _signal_reenter_ok spinlock on
	error

2012-01-10  Vladimir Tzankov  <vtzankov@gmail.com>

	* xthread.d (testandset) [ARM]: implement spinlocks for ARM

2011-10-17  Vladimir Tzankov  <vtzankov@gmail.com>

	* zthread.d (xlock_lock_helper): remove wrong "shortcut" on
	acquiring a lock held by thread that exemption-wait-ed on it
	[bug#615]

2011-09-16  Sam Steingold  <sds@gnu.org>

	* pathname.d (assure_dir_exists): call merge-pathnames on the
	truename to ensure that all truenames have non-NIL version because
	a NIL component means "unfilled" (19.2.2.2.1) [bug#606]

2011-09-16  Sam Steingold  <sds@gnu.org>

	* m4/clisp.m4 (CL_DECOLONIZE): fix the 2011-07-25 15472 patch
	which broke the native msys/mingw build
	Reported by Dan Stanger <dan.stanger@ieee.org>
	<http://article.gmane.org/gmane.lisp.clisp.devel:22759>
	<https://sourceforge.net/p/clisp/mailman/message/28097114/>

2011-09-14  Sam Steingold  <sds@gnu.org>

	* modules/readline/readline.lisp: include rlconf.h for
	DEFAULT_INPUTRC and SYS_INPUTRC and tilde.h for tilde_expand

2011-09-14  Sam Steingold  <sds@gnu.org>

	* makemake.in (clean5): do not remove modules.h twice

2011-08-29  Sam Steingold  <sds@gnu.org>

	add interface to VerQueryValue, GetFileVersionInfo et al
	http://msdn.microsoft.com/en-us/library/ms647464(v=vs.85).aspx
	* modules/syscalls/calls.c (OS:FILE-VERSION): add function
	* modules/syscalls/posix.lisp (OS:FILE-VERSION): add structure
	* modules/syscalls/configure.in (LIBS): add -lversion

2011-08-29  Sam Steingold  <sds@gnu.org>

	* clisp.rc.in: extract from makemake.in
	* makemake.in (clisp.rc): use it

2011-08-29  Sam Steingold  <sds@gnu.org>

	* makemake.in (MODULE_CPPFLAGS_VAR): remove
	(MODULE_CPPFLAGS): always define and use to avoid adding
	${GNULIB_INCLUDE} to CPPFLAGS twice

2011-08-26  Sam Steingold  <sds@gnu.org>

	* makemake.in (clisp.rc) [win32]: add version information for filever
	http://msdn.microsoft.com/en-us/library/aa381058(v=VS.85).aspx

2011-08-25  Sam Steingold  <sds@gnu.org>

	Report failures in init_language
	* spvw_language.d (init_language): accept lisp_error_p and report
	all failures using either fprintf() or error();
	use classify_namestring on all platforms to check argv_localedir
	(language_deutsch): rename to language_german for consistency
	(language_francais): rename to language_french for consistency
	* i18n.d (SET-CURRENT-LANGUAGE): pass lisp_error_p=true to init_language
	* lispbibl.d (init_language): update the prototype
	(file_kind_t): move here from pathname.d and rename from
	namestring_kind_t
	(classify_namestring): add the prototype
	* pathname.d (classify_namestring): make global
	* spvw.d (main): pass lisp_error_p=false to init_language

2011-08-24  Sam Steingold  <sds@gnu.org>

	* configure (makemake_args) [win32gcc]: add --with-dynamic-modules=no
	<http://article.gmane.org/gmane.comp.lib.gnulib.bugs:27739>
	<https://lists.gnu.org/archive/html/bug-gnulib/2011-07/msg00425.html>
	(host_arg): add both --host and --build argument
	Suggested by Eric Blake <eblake@redhat.com>
	https://lists.gnu.org/archive/html/bug-libsigsegv/2011-08/msg00006.html

2011-08-24  Sam Steingold  <sds@gnu.org>

	* error.d (format_message, FORMAT-MESSAGE): move here from ...
	* errwin32.d: here for the sake of cygwin

2011-08-24  Sam Steingold  <sds@gnu.org>

	* makemake.in: save & restore CC around setting it for XCC_CREATESHARED
	Suggested by Eric Blake <eblake@redhat.com>
	<http://article.gmane.org/gmane.comp.shells.bash.bugs:17158>
	<http://lists.gnu.org/archive/html/bug-bash/2011-08/msg00280.html>

2011-08-24  Sam Steingold  <sds@gnu.org>

	* misc.d (LISP-IMPLEMENTATION-VERSION): add missing GETTEXT calls
	(MACHINE-TYPE, MACHINE-VERSION): make return value immutable
	* spvw.d (main): localize the name of the main thread

2011-08-24  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (init_language): danish locale is "da_DK"
	Reported by Bruno Haible

2011-08-23  Sam Steingold  <sds@gnu.org>

	* win32.d (WSAEAGAIN, WSAENOENT): remove unused defines
	(ioctl): do not define to ioctlsocket because gnulib defines it to
	rpl_ioctl which calls ioctlsocket

2011-08-23  Sam Steingold  <sds@gnu.org>

	revert most of the 2011-08-17 patch
	* win32.d: include <ddk/ntifs.h> for NtQueryInformationFile
	because that's what works with i686-pc-mingw32-gcc and is
	recommended by http://msdn.microsoft.com/en-us/library/ff567052.aspx;
	do not include ntstatus.h because it is included by winddk/ntddk
	which is included by ntifs
	* configure.in: do not test for windows headers

2011-08-19  Sam Steingold  <sds@gnu.org>

	Implement RFE#46: use OS facilities to print os-error
	* condition.lisp (try-coerce-to-condition): special handling of
	NIL datum for the sake of OS-ERROR & its subclasses
	(os-error): add $CODE slot and :REPORT option
	(os-error-win32, os-stream-error, os-file-error): new conditions,
	subclasses of OS-ERROR
	(simple-os-error): remove
	(%defclcs): remove OS-ERROR -> SIMPLE-OS-ERROR map
	* lispbibl.d (cint_white_p): do not export
	(condition_t): remove os_error
	(OS_file_error): signal OS-FILE-ERROR, not SIMPLE-FILE-ERROR
	* constsym.d (simple_os_error): remove
	(os_error, os_file_error, os_stream_error, strerror): add
	(os_error_win32, format_message) [WIN32|CYGWIN]: add
	* subr.d (strerror): add
	(format_message) [WIN32|CYGWIN]: add
	* error.d (end_error): for os_stream_error, os_file_error,
	os_error, os_error_win32: reset errstring (known as datum to
	COERCE-TO-CONDITION, see above) to NIL; complete :CODE
	(error_code_converter_t, convert_error_code): add
	(OS_filestream_error): signal OS-ERRORs, not SIMPLE-ERRORs
	* errunix.d (os_error_t, get_errormsg): remove
	(STRERROR): preliminary implementation: required numeric argument
	(OS_error, OS_error_arg): push errcode on STACK for the :CODE argument
	(errno_out_low): use ANSIC_error_code_converter & strerror_r
	* errwin32.d (get_OS_error_info): remove
	(OS_error_internal_body): remove
	(format_message): add
	(OS_error_internal): use it
	(FORMAT-MESSAGE): preliminary implementation: required numeric argument
	(OS_error, OS_error_arg): push errcode on STACK for the :CODE argument
	* spvw.d (libopen, find_name): define when WIN32_NATIVE|HAVE_DLOPEN
	for the sake of finding converters in error.d:convert_error_code
	* modules/syscalls/calls.c (RESOLVE-HOST-IPADDR): signal
	error_condition, not os_error because there is no errno
	(errno_to_symbol_w, errno_to_symbol_a): add error_code_converter_t
	objects for error.d:convert_error_code
	(ERRNO, LAST-ERROR): convert from symbolic to numeric too
	(STRERROR, FORMAT-MESSAGE): use and override the preliminary
	definitions in errunix.d and errwin32.d
	* modules/syscalls/preload.lisp: unlock the SYSTEM package and
	remove it from *SYSTEM-PACKAGE-LIST* to enable overriding STRERROR
	& FORMAT-MESSAGE in calls.c
	* modules/syscalls/posix.lisp: import and export SYS::STRERROR &
	SYS::FORMAT-MESSAGE; re-add SYSTEM to *SYSTEM-PACKAGE-LIST*

2011-08-18  Sam Steingold  <sds@gnu.org>

	* makemake.in (LIBS): prepend ${GLLIB_A} before -lws2_32 & -lintl
	<http://article.gmane.org/gmane.lisp.clisp.devel:22701>
	<https://sourceforge.net/p/clisp/mailman/message/27966160/>

2011-08-18  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (check_last_error) [WIN32|CYGWIN]:
	renamed from check_errno
	(OS::LAST-ERROR) [WIN32|CYGWIN]: extracted from OS:ERRNO
	(OS::FORMAT-MESSAGE) [WIN32|CYGWIN]: extracted from OS::STRERROR
	(POSIX:ERRNO, POSIX:STRERROR): always define
	* modules/syscalls/posix.lisp (last-error, format-message): export
	* lispbibl.d (cint_white_p): export to clisp.h for FORMAT-MESSAGE
	to strip terminating whitespace and periods to conform to strerror

2011-08-17  Sam Steingold  <sds@gnu.org>

	* configure.in: check for many more windows headers which might
	declare NtQueryInformationFile
	* win32.d: try to include all those header one by one
	Suggested by Michael Kappert & Yaroslav Kavenchuk
	<http://article.gmane.org/gmane.lisp.clisp.devel:22684> &c
	<https://sourceforge.net/p/clisp/mailman/message/27960367/>

2011-08-08  Sam Steingold  <sds@gnu.org>

	* spvw_mmap.d (munmap, mprotect) [HAVE_MACH_VM|HAVE_WIN32_VM]:
	declare when defined to avoid a "warning: no previous declaration"

2011-08-08  Sam Steingold  <sds@gnu.org>

	Rename errno_t to os_error_code_t to avoid a conflict with mingw
	* unix.d (os_error_code_t): typedef to int; replaces errno_t
	* win32.d (os_error_code_t): typedef to DWORD; replaces errno_t
	* unixaux.d, win32aux.d (namestring_file_id, handle_file_id):
	return os_error_code_t instead of errno_t
	* pathname.d (check_file_reopen): update for the new type name

2011-08-08  Sam Steingold  <sds@gnu.org>

	* configure.in: check for <winternl.h>, <ntstatus.h> and <ddk/winddk.h>
	* win32.d: include them only when detected (the first two on
	cygwin/mingw, the last one on msys/mingw)

2011-08-05  Sam Steingold  <sds@gnu.org>

	fix the 2011-03-31 fix for bug#414
	* loop.lisp (*nullvar*): new unbound global
	(destructure): use it instead of (helpvar 0) for null patters
	(expand-loop): bind it; repeat count var does not depend on preceding
	(expand-loop@note-initialization): do not barf on *nullvar* reuse

2011-08-03  Sam Steingold  <sds@gnu.org>

	fix bug#604: loop does not warn on REPEAT before FOR
	* loop.lisp (expand-loop): REPEAT is a TERMINATION-TEST
	which is a MAIN-CLAUSE, not a VARIABLE-CLAUSE

2011-08-03  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (check_errno): add ERFKILL & EHWPOISON

2011-08-02  Sam Steingold  <sds@gnu.org>

	fix bug#603: no warning when lambda is incompatible with arglist
	* compiler.lisp (inline-callable-function-lambda-p): call c-warn
	when the lambdalist is incompatible with the argument count

2011-08-02  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (src/aclocal.m4): run aclocal in src
	<http://article.gmane.org/gmane.comp.lib.gnulib.bugs:27763>
	<https://lists.gnu.org/archive/html/bug-gnulib/2011-07/msg00449.html>

2011-08-02  Sam Steingold  <sds@gnu.org>

	fix bug#605: simple condition printing ignores user-supplied methods
	* condition.lisp (simple-condition): use :REPORT option instead of
	a PRINT-OBJECT :AROUND method

2011-08-01  Sam Steingold  <sds@gnu.org>

	fix recent breakage
	* socket.d (CLOSE) [win32]: define
	* win32.d (ioctl): define to ioctlsocket

2011-08-01  Sam Steingold  <sds@gnu.org>

	fix "clean" targets
	* makemake.in (anymodule): do not remove gllib; there is no such dir
	(clean1): do not remove build-aux, but do remove dynmod
	(clean5): remove modules.h and build-aux unless building in src
	(clean6): do not remove Makefile
	(clean7): depend on distclean-subdirs
	(clean-subdirs, distclean-subdirs): new targets
	(clean): depend on clean-subdirs
	* po/Makefile.in.in (distclean): remove Makefile.in

2011-08-01  Sam Steingold  <sds@gnu.org>

	* utils/txt2c.c (process_file): avoid a segfault by checking that
	standard_include_path is not NULL before accessing it

2011-08-01  Sam Steingold  <sds@gnu.org>

	revert the parts of the 2011-07-29 15496:d628d9ac3fce patch
	which broke the in-place build (in the src directory)
	* _clisp.c: include w32shell & execname with "", not <>
	* encoding.d: include nls_* with "", not <>
	* eval.d: include lightning with "", not <>
	* lispbibl.d: include version.h with "", not <>
	* modules.c: include lispbibl & clisp with "", not <>
	* spvw.d: include spvw_calendar.c with "", not <>

2011-08-01  Sam Steingold  <sds@gnu.org>

	* modules/berkeley-db/configure.in, modules/clx/new-clx/configure.in:
	* modules/syscalls/configure.in: call AC_SYS_LARGEFILE before the
	first AC_CHECK_SIZEOF to ensure 64-bit size_t
	Reported by Vladimir Tzankov <vtzankov@gmail.com> in
	<http://article.gmane.org/gmane.lisp.clisp.devel:22642>
	<https://sourceforge.net/p/clisp/mailman/message/27868080/>

2011-07-29  Sam Steingold  <sds@gnu.org>

	link over fewer files into the build directory
	* makemake.in (CLISP_LIBDIR): do not set
	(EVERY_INCLUDES_H): remove gllib files
	(UNICODE_INCLUDES, NLS_INCLUDES, SPVW_VERSION, w32shell.c)
	(execname.c, spvw_calendar.c, with_jitc): do not link over
	(TXT2CINCL): use SRCDIR, not SRCTOPDIR
	(gllib): pass top_srcdir, not CLISP_LIBDIR to make
	(modules.h): create with touch
	(LINKKIT): link files directly into linkkit/
	* modules.h: remove
	* Makefile.devel (src/gllib/Makefile.in): replace
	$(top_srcdir)/src/build-aux with $(top_srcdir)/build-aux instead
	of CLISP_LIBDIR
	* _clisp.c: include w32shell & execname with <>, not ""
	* encoding.d: include nls_* with <>, not ""
	* eval.d: include lightning with <>, not ""
	* lispbibl.d: include version.h with <>, not ""
	* modules.c: include lispbibl & clisp with <>, not ""
	* spvw.d: include spvw_calendar.c with <>, not ""

2011-07-29  Sam Steingold  <sds@gnu.org>

	* makemake.in (GNULIB_INCLUDE): -I$(builddir)/gllib -I$(srcdir)/gllib
	(XCPPFLAGS): add GNULIB_INCLUDE
	(UNICODE_EXTRA, GLLIB_MODULE_HEADERS): remove
	(anymodule): add GNULIB_INCLUDE to CPPFLAGS
	* encoding.d: include localcharset as <>, not as ""

2011-07-28  Sam Steingold  <sds@gnu.org>

	* socket.d (CLOSE): do not redefine the unix.d definition

2011-07-28  Sam Steingold  <sds@gnu.org>

	* configure: do not link over anything
	* makemake.in (po): new target
	(makemake.in, config.h.in, configure): remove link_dep targets
	(makemake, config.h, config.status): depend on files in SRCDIR
	* po/Makefile.in.in (VPATH): add

2011-07-28  Sam Steingold  <sds@gnu.org>

	* makemake.in (GLLIB_MODULE_HEADERS): set to regex.h for regexp

2011-07-27  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (ANSIC_error): export to clisp.h

2011-07-27  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): fix a typo: setsockopt was
	requested twice while getsockopt was not requested at all
	(GNULIB_IMPORTS): add recvfrom & sendto for rawsock
	* modules/rawsock/rawsock.c: use ANSIC_error instead of OS_error

2011-07-27  Sam Steingold  <sds@gnu.org>

	fix mingw compilation
	* lispbibl.d (setjmp) [__MINGW32__]: do not define
	Include <winsock2.h> before <windows.h> to avoid a warning
	* stream.d (QueryInformationFile) [WIN32_NATIVE]: do not include
	<ddk/ntifs.h> here, instead ...
	* win32.d: include <winternl.h> & <ntstatus.h>
	(_exit): remove prototype (get it from gnulib)
	(lseek): undef before redefining
	(CoGetCurrentProcess): remove prototype, rely on above headers

2011-07-27  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c: when the portability is ensured by
	gnulib, use ANSIC_error; when we use WIN32_NATIVE functions
	directly, use OS_error
	(POSIX:MKSTEMP) [WIN32_NATIVE]: use _get_osfhandle to convert the
	return value of gnulib mkstemp() to a windows file handle
	Include <shldisp.h> & <shlguid.h> for CLSID_ShellLink &
	IID_IShellLink
	* modules/regexp/Makefile.in (NO_CXX): removed unused variable

2011-07-27  Sam Steingold  <sds@gnu.org>

	* spvw_ctype.d (init_ctype): add "#ifdef LC_MESSAGES" for mingw

2011-07-26  Sam Steingold  <sds@gnu.org>

	* m4/clisp.m4 (CL_CLISP): use AC_MSG_ERROR instead of setting
	variables to bad values

2011-07-26  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): add select

2011-07-26  Sam Steingold  <sds@gnu.org>

	revert last patch; fix the gnulib defines in a more robust way:
	change C names for Lisp symbols to avoid clashes with the C world
	Suggested by Bruno
	* undef-gnulib.h: remove
	* Makefile.devel, makemake.in: remove undef-gnulib.h
	* spvwtabf.d, spvwtabo.d, spvwtabs.d: do not include undef-gnulib.h
	* constsym.d, eval.d, io.d, package.d, pathname.d, stream.d,
	* subr.d, time.d (read): rename to readL
	(listen): ... listenL
	(write): ... writeL
	(sleep): ... psleep
	(time): ... pptime
	(close): ... closeL
	Thanks to Yaroslav Kavenchuk for extensive testing

2011-07-25  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (src/undef-gnulib.h): new target
	(gnulib-imported): call it at the end
	* spvwtabf.d, spvwtabo.d, spvwtabs.d: include undef-gnulib.h after
	lispbibl to undefine the lisp symbols redefined by gnulib
	* makemake.in: link undef-gnulib.h into the build directory
	(spvwtab*.o): depend on undef-gnulib.h
	* undef-gnulib.h: new file, regenerated on each gnulib-imported

2011-07-25  Sam Steingold  <sds@gnu.org>

	* m4/clisp.m4 (CL_DECOLONIZE): even when $ac_cv_build is mingw, use
	cygpath when available because cross-compiling on cygwin is not detected

2011-07-20  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): add close, ioctl, and make stdlib
	inclusion explicit (it has always been present as a dependency)
	* modules/rawsock/rawsock.c, socket.d, stream.d, unix.d, win32.d:
	use close() instead of closesocket() and ioctl() instead of
	ioctlsocket() on all platforms

2011-07-20  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (RMRF, HG): new variables
	(gnulib-imported): remove gnulib directories before import to see
	added and deleted files right away

2011-07-20  Sam Steingold  <sds@gnu.org>

	* makemake.in: pass "--execute netrc=off" to wget to avoid
	"unknown token" errors

2011-07-20  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): add sys_select

2011-07-19  Sam Steingold  <sds@gnu.org>

	* configure.in: do not call gt_LC_MESSAGES
	* spvw_ctype.d, spvw_language.d: assume LC_MESSAGES is present
	* win32.d: do not define HAVE_LC_MESSAGES

2011-07-19  Sam Steingold  <sds@gnu.org>

	* bdb.c, clx.f, dirkey.c, gdbm.c, cpcre.c, rawsock.c, calls.c:
	* aridecl.d, array.d, charstrg.d, control.d, debug.d, encoding.d:
	* error.d, errunix.d, errwin32.d, eval.d, flo_konv.d, foreign.d:
	* funarg.d, genclisph.d, intbyte.d, intdiv.d, intelem.d, intmal.d:
	* io.d, lfloat.d, lisparit.d, lispbibl.d, makemake.in, pathname.d:
	* record.d, sequence.d, spvw.d, spvw_allocate.d, stream.d, symbol.d:
	* unix.d, win32.d, win32aux.d: gnulib module stdlib prodvides
	macro _Noreturn; use it instead of nonreturning_function()

2011-07-19  Sam Steingold  <sds@gnu.org>

	use gnulib modules to convert windows WSAGetLastError to errno
	* Makefile.devel (GNULIB_CORE): add bind accept listen recv send
	setsockopt shutdown connect socket setsockopt getsockname getpeername
	replace strerror with strerror_r-posix
	* errwin32.d (SOCK_error): remove
	* lispbibl.d: include <sys/select.h>
	* socket.d, stream.d, win32aux.d: use ANSIC_error instead of SOCK_error;
	use errno instead of sock_errno_is/sock_set_errno
	* unix.d, win32.d (SHUT_RD, SHUT_WR, SHUT_RDWR): do not defined
	here, ensured by gnulib (in sys/socket)
	(sock_errno, sock_errno_is, sock_set_errno, SOCK_error): remove

2011-07-15  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (language): make it static to avoid
	warning: non-local variable '<anonymous enum> language' uses anonymous type

2011-07-15  Sam Steingold  <sds@gnu.org>

	* socket.d (ipv4_ntop, ipv6_ntop): remove
	(addr_to_string): simplify
	(MACHINE-INSTANCE): use it
	(socket_getlocalname_aux, socket_getpeername): use inet_ntop
	instead of ipv[46]_ntop

2011-07-15  Sam Steingold  <sds@gnu.org>

	* encoding.d, lispbibl.d, pathname.d, socket.d, spvw.d, stream.d:
	* unix.d: always include <string.h> & <sys/socket.h> in lispbibl.d
	(socket, setsockopt): drop explicit prototypes, they are declared
	in <sys/socket.h> (from gnulib, if necessary)

2011-07-14  Sam Steingold  <sds@gnu.org>

	* configure.in: restore the readline check (accidentally removed)

2011-07-14  Sam Steingold  <sds@gnu.org>

	* makemake.in (UTILS): fix the last patch by making utils depend
	on ${EXTRAOBJ}

2011-07-13  Sam Steingold  <sds@gnu.org>

	* win32.d (HAVE_IPV4, HAVE_IPV6): define to 1 to avoid
	warning: "HAVE_IPV4" redefined
	Reported by Yaroslav Kavenchuk <kavenchuk@gmail.com>

2011-07-11  Sam Steingold  <sds@gnu.org>

	* lispbibl.d (listen): undef after including unistd because gnulib
	defines it to listen_used_without_including_sys_socket_h

2011-07-11  Sam Steingold  <sds@gnu.org>

	* makemake.in (EXTRAOBJ): set to ${GLLIB_A} to avoid
	"undefined reference to `rpl_malloc'" on mingw;
	but put it after the C file in the compilation command
	<http://article.gmane.org/gmane.lisp.clisp.devel:22573>
	<https://sourceforge.net/p/clisp/mailman/message/27774032/>

2011-07-08  Sam Steingold  <sds@gnu.org>

	* modules/regexp/regexi.c (REGEXP-EXEC):
	accept :return-type 'boolean instead of :boolean t
	* modules/regexp/regexp.lisp (regexp-matcher):
	pass :return-type 'boolean to regexp-exec

2011-07-08  Sam Steingold  <sds@gnu.org>

	* win32.d, unix.d, lispbibl.d (stdlib, sys/types, unistd, locale)
	(errno): include files which are included in both unix.d and
	win32.d from lispbibl.d instead
	* socket.d: do not include these files here

2011-07-08  Sam Steingold  <sds@gnu.org>

	* makemake.in: avoid $@ in single-target rules

2011-07-07  Sam Steingold  <sds@gnu.org>

	* configure: pass --with-debug to makemake
	* makemake.in: accept --with-debug instead of positional

2011-07-06  Sam Steingold  <sds@gnu.org>

	* m4/clisp.m4 (CL_CLISP): quote variable in test to avoid error
	"test: too many arguments"

2011-06-24  Sam Steingold  <sds@gnu.org>

	* modules/libsvm/configure.in: check for svm_free_and_destroy_model
	* modules/libsvm/libsvm.lisp: in libsvm 3.1 svm_destroy_model is
	replaced with svm_free_and_destroy_model with a different
	signature, so we have to work around that

2011-06-24  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (PRIORITY, %SET-PRIORITY) [WIN32_NATIVE]:
	compare handles with INVALID_HANDLE_VALUE, not NULL
	(PRIORITY) [WIN32_NATIVE]: make sure failed_p is always set
	* modules/bindings/win32/win32.lisp (GetPriorityClass): add

2011-06-01  Sam Steingold  <sds@gnu.org>

	* pathname.d, subr.d (PROBE-PATHNAME): mark as seclass_rd_sig
	because it may signal permission errors

2011-06-01  Sam Steingold  <sds@gnu.org>

	finish the 2011-05-13 possible_symlink patch
	* pathname.d (my_readlink) [UNIX_LINUX]: do not handle /proc specially
	(stat_for_search) [UNIX_LINUX]: ditto

2011-06-01  Sam Steingold  <sds@gnu.org>

	avoid errors on weird pathnames like ~/.gvfs under gnome
	* pathname.d (get_path_info): accept tolerantp
	(assure_dir_exists): pass tolerantp to get_path_info
	(namestring_kind_t): add NAMESTRING_BAD for existing objects
        for which no information could be obtained
	(classify_namestring): return NAMESTRING_BAD instead of signaling
	(PROBE-PATHNAME): signal the error here
	(directory_search_direntry_ok): never signal any errors,
	just return false
	(directory_search_scandir): call OS_file_error instead of
	error_file_not_exists after a failed directory_search_direntry_ok
	when if_none=DIR_IF_NONE_ERROR
	Reported by Don Cohen <http://article.gmane.org/gmane.lisp.clisp.general:13778>
	<https://sourceforge.net/p/clisp/mailman/message/27584189/>

2011-05-24  Sam Steingold  <sds@gnu.org>

	* _clisp.c (main) [WIN32_NATIVE]: use FormatMessage()
	instead of strerror() for GetLastError()
	Reported by Bruno Haible

2011-05-24  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): import mkfifo mknod mkstemp
	mkdtemp getloadavg
	* modules/syscalls/calls.c (MKSTEMP, MKDTEMP, LOADAVG, MKNOD):
	define uniformly on all platforms
	* modules/syscalls/posix.lisp (mknod): export on all platforms

2011-05-20  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (clgettext) [!GNU_GETTEXT]: define for CLSTEXT

2011-05-19  Sam Steingold  <sds@gnu.org>

	* subrkw.d: remove
	* spvw.d (init_subr_tab_2): use subr with LISPFUN_H instead of subrkw
	* subr.d (LISPFUN_H): fix
	* makemake.in (OTHER_INCLUDES): remove subrkw
	* po/Makefile.devel (DSOURCES): ditto
	* check-lispfun.lisp (check-lisp-defs): do not look at subrkw.d

2011-05-19  Sam Steingold  <sds@gnu.org>

	* zthread.d (EXEMPTION-WAIT): fix the key count in the definition
	to match the (correct) declaration in subr.d

2011-05-19  Sam Steingold  <sds@gnu.org>

	* constobj.d, constsym.d, hashtabl.d, io.d, lispbibl.d,
	* pathname.d, predtype.d, spvw.d, spvw_debug.d, subr.d, subrkw.d:
	remove the LOGICAL_PATHNAMES CPP macro;
	logical pathnames are unconditionally present in CLISP

2011-05-19  Sam Steingold  <sds@gnu.org>

	* constobj.d, constsym.d, lispbibl.d, pathname.d, subr.d: remove
	HAVE_SHELL which is always defined on all platforms supported by CLISP

2011-05-19  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (processor_architecture): add DEFCHECKER
	(SYSTEM-INFO): use it; also push dwProcessorType on STACK
	* modules/syscalls/posix.lisp (system-info): add PROCESSOR-TYPE slot

2011-05-19  Sam Steingold  <sds@gnu.org>

	* constobj.d, constsym.d, lispbibl.d, misc.d, socket.d:
	* spvw_memfile.d, subr.d: remove MACHINE_KNOWN
	which is always defined on all platforms supported by CLISP

2011-05-19  Sam Steingold  <sds@gnu.org>

	* constsym.d, lispbibl.d, misc.d, subr.d: remove HAVE_ENVIRONMENT
	which is always defined on all platforms supported by CLISP

2011-05-18  Vladimir Tzankov  <vtzankov@gmail.com>

	* time.d (thread_from_arg) [MULTITHREAD]: fix g++ gcsafety build

2011-05-18  Vladimir Tzankov  <vtzankov@gmail.com>

        * xthread.d: use "raw" mutexes for emulating spinlocks on
        architectures with no inline asm versions

2011-05-18  Vladimir Tzankov  <vtzankov@gmail.com>

        * spvw_sigcld.d (sigcld_enabled_INCF/DECF): fix counting

2011-05-19  Sam Steingold  <sds@gnu.org>

	* makemake.in (UTILCOMPILE): turn into a make variable and use it
	on win32 and when cross-compiling

2011-05-18  Sam Steingold  <sds@gnu.org>

	simplify UI language code
	* lispbibl.d (ENGLISH, LANGUAGE_STATIC): remove
	(language_english): move to ...
	* spvw_language.d (language_english): ... here
	(language): static enum
	(init_language): simplify, remove gotos
	* spvw_memfile.d (loadmem_from_handle): LANGUAGE_STATIC => !GNU_GETTEXT
	* i18n.d (TEXT) [!GNU_GETTEXT]: return the argument as string

2011-05-18  Sam Steingold  <sds@gnu.org>

	* makemake.in: finish the 2008-05-31 CL_CC_NEED_CCPAUX patch
	by removing the special case of comment5 in UTIL building
	(full): fix the grep REPLACE_ regexp (gnulib replacements)

2011-05-18  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c: do not include <ws2tcpip.h> twice
	* modules/rawsock/configure.in: <winsock2.h> is checked by gl_SOCKETLIB;
	add LIBSOCKET to LIBS while checking for functions

2011-05-18  Sam Steingold  <sds@gnu.org>

	* modules/i18n/configure.in: gl_FUNC_NL_LANGINFO is already called
	by gl_INIT in the top-level config file

2011-05-18  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f, modules/clx/new-clx/configure.in:
	* modules/fastcgi/configure.in, modules/regexp/configure.in:
	* modules/rawsock/configure.in, modules/rawsock/rawsock.c:
	* modules/syscalls/configure.in, configure.in, m4/general.m4:
	* m4/rusage.m4: do not check for gnulib files
	* Makefile.devel (GNULIB_CORE): add sys_uio & socketlib (already
	present as dependencies)
	* m4/putenv.m4: remove (should have been removed on 2010-09-27)
	* modules/syscalls/calls.c, modules/syscalls/configure.in:
	<sys/wait.h> and <wchar.h> are provided by gnulib

2011-05-18  Sam Steingold  <sds@gnu.org>

	* makemake.in (SUBDIR_CFLAGS): add @NO_CXX@ because
	gnulib regexp and fnmatch cannot be compiled with C++

2011-05-17  Sam Steingold  <sds@gnu.org>

	* modules/rawsock/rawsock.c, modules/berkeley-db/bdb.c:
	* modules/berkeley-db/configure.in, modules/syscalls/configure.in:
	* modules/fastcgi/fastcgi_wrappers.c, modules/gdbm/gdbm.c:
	* rawsock/rawsock.c, modules/rawsock/configure.in:
	no need to check and guard gnulib #include files and functions

2011-05-17  Sam Steingold  <sds@gnu.org>

	merge the wildcard module into syscalls; import gnulib into src only
	before: clisp:52,284k modules:14,136k src:25,876k
	after:  clisp:44,200k modules: 8,684k src:24,836k
	* Makefile.devel (MODULES): remove wildcard
	(GNULIB_USERS, MAKEFILE_IN): remove
	(gnulib-imported): import files into src/ only
	(GNULIB_CORE): import explicitly "unistd alloca-opt environ"
	which have been already included because of dependencies;
	also import lstat, stat, readlink
	* gnulib-tool.patch: remove
	* configure.in: rely on lstat, stat, readlink
	* makemake.in (GLLIB_A): no need for "_cl" suffix
	* pathname.d: lstat() is always present (from gnulib)
	* unix.d: readlink, lstat, gethostname come from gnulib
	* win32.d: gethostname comes from gnulib
	* m4/stat.m4: remove
	* modules/wildcard, modules/regexp/gl*, modules/syscalls/gl*: remove
	* modules/regexp/Makefile.in, modules/syscalls/Makefile.in:
	remove gnulib targets
	(GENERATED): remove libgnu_*.a
	(config.h): add target
	* modules/regexp/configure.in, modules/syscalls/configure.in:
	remove gnulib calls
	* modules/regexp/link.sh.in, modules/syscalls/link.sh.in
	(NEW_FILES): remove libgnu_*.a
	* modules/syscalls/calls.c (FNMATCH): add
	* modules/syscalls/posix.lisp: export FNMATCH & FNMATCH-MATCHER
	(fnmatch-matcher): implement
	(wildcard:match, wildcard:wildcard-matcher): add for
	backward-compatibility

2011-05-17  Sam Steingold  <sds@gnu.org>

	* misc.d (environ) [HAVE_ENVIRONMENT]: included for dependencies
	gnulib module environ already provides the declaration
	* socket.d: no need to guard including <unistd.h> - it is always
	provided by the gnulib module unistd
	* unix.d: no need to guard including <unistd.h>, <sys/time.h>,
	<time.h>, <sys/utsname.h> - they are always provided by gnulib
	* aridecl.d, arilev0.d, arilev1.d, lispbibl.d, win32.d:
	remove the last vestiges of Borland support
	* _clisp.c: add '#include "config.h"' (necessary for gnulib)
	* lispbibl.d: rely on alloca.h provided by gnulib/alloca-opt

2011-05-17  Sam Steingold  <sds@gnu.org>

	* configure: detect building for mingw from $CC -dumpmachine

2011-05-17  Sam Steingold  <sds@gnu.org>

	* utils/modprep.lisp (print-tables-1): DEFFLAGSET(..., !CONST)
	means that to add CONST to flags one passes NIL to the lisp function

2011-05-16  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (language): static, not global
	(current_language_o): global, not static
	(init_language): do not call bindtextdomain() with a nonexistent
	localedir because that it is usually called by SET-CURRENT-LANGUAGE
	with a NULL second argument
	* lispbibl.d (current_language_o) [!LANGUAGE_STATIC]: declare extern
	* spvw.d (init_memory): update initialization of O(current_language)
	* i18n.d (SET-CURRENT-LANGUAGE): use current_language_o() to set
	O(current_language)

2011-05-13  Sam Steingold  <sds@gnu.org>

	* pathname.d (possible_symlink): remove (linux 2.0.35 is long gone)

2011-05-10  Sam Steingold  <sds@gnu.org>

	* pathname.d (starp): remove
	(multiwild_char_p, singlewild_char_p, wild_char_p): use
	consistently throughout the file
	(DEF_WILD_CHECKER): new macro
	(word_wild_p, wild_p): define using it

2011-05-04  Sam Steingold  <sds@gnu.org>

	* stream.d (IS_EINVAL_EXTRA) [UNIX_SUNOS5]: add ENXIO

2011-05-04  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): replace close-hook with
	fd-hook (renamed in gnulib 2011-04-19)
	(gnulib-imported): pipe stderr to $(GNULIB_IMPORTED_LOG) too

2011-05-04  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (init_language): fix the 2011-04-10 patch (use
	strcpy instead of strcat)

2011-05-04  Sam Steingold  <sds@gnu.org>

	* symbol.d (GENTEMP): add a cast to fix g++ compilation

2011-05-04  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (GNULIB_CORE): add
	arpa_inet, netinet_in, inet_ntop, inet_pton
	* lispbibl.d: assume that <netinet/in.h> is always present
	* win32.d (CONNECT_NAME_T, CONNECT_CONST, CONNECT_ADDRLEN_T)
	(HAVE_NETINET_IN_H, HAVE_ARPA_INET_H, RET_INET_ADDR_TYPE)
	(INET_ADDR_SUFFIX, INET_ADDR_CONST): remove
	* socket.d: assume HAVE_ARPA_INET_H, HAVE_INET_NTOP, HAVE_INET_PTON,
	thus inet_addr() is never used
	(connect, inet_addr): remove the prototypes
	(all_digits_dots): remove the function
	* configure.in: do not call CL_CONNECT
	(LIBS): add -lnsl & -lsocket if required for connect() & gethostbyname()
	* m4/connect.m4, m4/socket.m4: remove
	* m4/tcpconn.m4: do not check for inet_pton & inet_ntop (get them
	from gnulib) and inet_addr (never used)
	* modules/rawsock/rawsock.c, modules/syscalls/calls.c: include
	<netinet/in.h> & <arpa/inet.h> unconditionally
	* modules/syscalls/configure.in: do not check for <netinet/in.h> &
	<arpa/inet.h>; do not call CL_SOCKET

2011-05-03  Sam Steingold  <sds@gnu.org>

	* genclisph.d (include_file): renamed from print_file; when fname
	does not exist, emit "#include <fname>"
	* lispbibl.d (stdbool.h): do not check for HAVE_STDBOOL_H because
	it is no longer defined by gnulib
	<http://lists.gnu.org/archive/html/bug-gnulib/2011-01/msg00571.html>

2011-05-02  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c, modules/syscalls/posix.lisp (stdio):
	enable even without FFI because it is useful for bypassing the
	normal CL filename processing

2011-05-01  Bruno Haible  <bruno@clisp.org>

	Disallow &WHOLE if it comes too late.
	* defmacro.lisp (analyze1): Report an error if &WHOLE appears
	after the first required variable or after &OPTIONAL.
	Refer to CLHS 3.4.4 and 3.4.5
	<http://www.ai.mit.edu/projects/iiip/doc/CommonLISP/HyperSpec/Body/sec_3-4-4.html>
	<http://www.ai.mit.edu/projects/iiip/doc/CommonLISP/HyperSpec/Body/sec_3-4-5.html>
	Reported at bug#599.

2011-04-28  Sam Steingold  <sds@gnu.org>

	* modules/clx/new-clx/clx.f (check_family): add
	(XLIB:ACCESS-HOSTS): handle all host families from my X.h and Xauth.h

2011-04-28  Sam Steingold  <sds@gnu.org>

	fix bug#598: GET-PROPERTY unpacks properties incorrectly on 64bit
	http://www.x.org/releases/X11R7.6/doc/man/man3/XChangeProperty.3.xhtml
	format = 8/16/32 means char/short/long, __NOT__ int8/int16/int32
	* modules/clx/new-clx/clx.f (get_client_message_format1): add,
	return the format_bytesize in addition to the actual format
	(get_client_message_format): call it
	(XLIB:CHANGE-PROPERTY): use it instead of format/8
	(make_client_message_data, XLIB:GET-PROPERTY):
	use fixnum & L_to_I for conversion instead of make_int*
	(get_client_message_data, coerce_into_map):
	use get_fixnum & I_to_L for conversion instead of get_int*
	* modules/clx/new-clx/clx.lisp (decode-wm-size-hints): revert the
	ZEROP check accidentally committed on 2009-09-18

2011-04-27  Elliott Slaughter  <elliottslaughter@gmail.com>

	* win32msvc/nsis/install.nsi: Fix PATH bug by insisting that packager
	uses long strings version of NSIS. Also upgrade EnvVarUpdate library.
	* win32msvc/nsis/add_to_path.nsh: Obsoleted by env_var_update.nsh.
	* win32msvc/nsis/env_var_update.nsh: Added to supercede add_to_path.nsh.
	* makemake.in: Use env_var_update.nsh rather than add_to_path.nsh.

2011-04-22  Sam Steingold  <sds@gnu.org>

	* places.lisp (setf-VALUES-aux): even if subform sets no values,
	it should consume one assigned value (bug#597)

2011-04-21  Sam Steingold  <sds@gnu.org>

	* Makefile.devel (CP): new variable; do _not_ pass "-u" so that
	fresh checkouts will not override updating in build-aux-update et al
	(LIBTOOL_VERSION): bump to 2.4
	(build-aux-update): get compile & ylwrap from a specific automake
	version instead of whatever happens to be currently installed

2011-04-18  Sam Steingold  <sds@gnu.org>

	* configure (makemake_args): when configure detects mingw/msys,
	pass --win32gcc to makemake
	Reported by Elliott Slaughter <elliottslaughter@gmail.com>.

2011-04-15  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-GLOBAL-FUNCTION-CALL): issue a style-warning
	when PARSE-NAMESTRING, MERGE-PATHNAMES, or READ-FROM-STRING, i.e.,
	a function which accept both &KEY arguments and an even number of
	&OPTIONAL arguments, is, apparently, invoked with &KEY but without
	&OPTIONAL arguments

2011-04-15  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (c-LAMBDABODY): issue a style-warning when lambda
	list contains both &optional and &key

2011-04-12  Sam Steingold  <sds@gnu.org>

	On Max OS X the value of *PATHNAME-ENCODING* is set to UTF-8 and cannot
	be changed because MacOSX pathnames are UTF-8 strings, not byte
	sequences (<http://thread.gmane.org/gmane.lisp.clisp.general/13725>
	<https://sourceforge.net/p/clisp/mailman/message/27345286/>
	and <http://developer.apple.com/library/mac/#qa/qa2001/qa1173.html>)
	* lispbibl.d (CONSTANT_PATHNAME_ENCODING) [UNIX_MACOSX]: define to UTF-8
	* encoding.d (init_dependent_encodings) [CONSTANT_PATHNAME_ENCODING]:
	set O(pathname_encoding) to CONSTANT_PATHNAME_ENCODING
	(SYSTEM::SET-PATHNAME-ENCODING): signal an error when the encoding
	argument is not CONSTANT_PATHNAME_ENCODING
	* spvw.d (argv_encoding_pathname): do not define when
	CONSTANT_PATHNAME_ENCODING is defined
	(parse_options): do not accept -Epathname
	* makemake.in (encflags) [TSYSOS=darwin]: do not add -Epathname
	Thanks to Carlos Ungil <carlos.ungil@gmail.com> for testing.

2011-04-10  Sam Steingold  <sds@gnu.org>

	* spvw_language.d (init_language): use strcat and strncat instead
	of while and dotimespL

2011-04-10  Sam Steingold  <sds@gnu.org>

	* modules/bindings/glibc/linux.lisp (wait, waitpid): restore (revert
	the 2011-03-23 patch); recommend POSIX:WITH-SUBPROCESSES in comments

2011-04-09  Sam Steingold  <sds@gnu.org>

	* modules/syscalls/calls.c (POSIX:SERVICE): fix non-missing
	protocol handling (bug#596)

2011-04-08  Vladimir Tzankov  <vtzankov@gmail.com>

	* spvw_sigpipe.d [MULTITHREAD, UNIX_MACOSX, GENERATIONAL_GC]:
	patch for strange SIGPIPE delivered to libsigsegv thread

2011-04-06  Sam Steingold  <sds@gnu.org>

	fix bug#586: WRITE-BYTE-SEQUENCE :no-hang t is only for byte vectors
	* sequence.d (WRITE-BYTE-SEQUENCE): implement "persev !=
	persev_full" for sequences other than (VECTOR (UNSIGNED-BYTE 8))

2011-04-06  Sam Steingold  <sds@gnu.org>

	* sequence.d (interactive_no_hang): new function
	(READ-BYTE-SEQUENCE, WRITE-BYTE-SEQUENCE): use it

2011-04-06  Sam Steingold  <sds@gnu.org>

	* unixaux.d (fd_read): revert the 2008-12-30 patch which closed
	the fd on ECONNRESET without marking the lisp stream as closed,
	thus leading to EBADF when the stream was closed

2011-04-05  Bruno Haible  <bruno@clisp.org>

	Tweak last two changes.
	* lispbibl.d (GENERATIONAL_GC): Add more comments.
	* spvw.d (SIGSEGV_FAULT_ADDRESS_ALIGNMENT): Define fallback.
	* spvw_fault.d (handle_fault): Simplify use of
	SIGSEGV_FAULT_ADDRESS_ALIGNMENT.

2011-04-04  Sam Steingold  <sds@gnu.org>

	* spvw_fault.d (handle_fault): fix last patch to restore support
	to libsigsegv-2.9 and earlier
	* lispbibl.d (GENERATIONAL_GC): ditto

2011-04-03  Bruno Haible  <bruno@clisp.org>

	Support for generational GC on Linux/S390.
	* configure (SIGSEGV): Recommend libsigsegv-2.10.
	* lispbibl.d (GENERATIONAL_GC): Consider also
	SIGSEGV_FAULT_ADDRESS_ALIGNMENT.
	* spvw_fault.d (handle_fault): Likewise.
	Reported by Christoph Egger <christoph@debian.org>.

2011-03-31  Sam Steingold  <sds@gnu.org>

	fix bug#414: loop expansion: spurious LET twice
	* loop.lisp (destructure): warn on destructuring empty patterns
	(expand-loop): do not destructure empty patterns and bind useless
	variables; this makes macroexpansion smaller but does not affect
	compiled code

2011-03-29  Sam Steingold  <sds@gnu.org>

	fix bug#594: HANDLER-BIND: no CONSTANTLY as a handler
	* compiler.lisp (insert-combined-LAPs): we have HANDLER-BEGIN&PUSH
	but not HANDLER-BEGIN, so insert a (PUSH)+(POP) after
	HANDLER-BEGIN which is not followed by a (PUSH)

2011-03-29  Sam Steingold  <sds@gnu.org>

	* compiler.lisp (insert-combined-LAPs): remove noop GOs

2011-03-29  Sam Steingold  <sds@gnu.org>

	fix bug#582: too much consing in IGNORE-ERRORS,
	partially reverting the 2005-01-21 patch
	* compiler.lisp (c-form-table): map HANDLER-BIND to c-HANDLER-BIND
	and SYS::%HANDLER-BIND to c-%HANDLER-BIND
	(c-handler-bind-handler-anode, c-handler-bind-anode):
	extract from c-HANDLER-BIND
	(c-HANDLER-BIND, c-%HANDLER-BIND): use them
	* init.lisp (%expand-handlers): remove unused code
	* modules/asdf/asdf.lisp (module-provide-asdf): work around the
	upcoming bug#594 which was fixed by the 2005-01-21 patch and
	is now being reintroduced

2011-03-29  Sam Steingold  <sds@gnu.org>

	* trace.lisp (subclosure-pos, trace1): use SYMBOL-SUFFIX instead
	of CONCAT-PNAMES to keep the named of the traced definition in the
	same package as the original name

2011-03-28  Sam Steingold  <sds@gnu.org>

	fix bug#587: socket-connect with timeout non-zero ->ETIMEDOUT
	* socket.d (connect_via_ip): do not reuse "ret" when checking for
	socket errors (fixes patch 2008-06-30)

2011-03-28  Sam Steingold  <sds@gnu.org>

	fix bug#585: LOOP mixing WITH & Hash Table FOR
	* loop.lisp (expand-loop): reverse the order of INITFORMS and
	ENDTEST-FORMS in preamble (tweak the 2006-07-20 patch)

2011-03-27  Sam Steingold  <sds@gnu.org>

	fix bug#593: (posix:wait) race condition
	* spvw_sigcld.d (sigcld_enabled): static var which counts how many
	times we have enabled SIGCLD
	(sigcld_enabled_lock) [MULTITHREAD]: spinlock for sigcld_enabled
	(install_sigcld_handler) [MULTITHREAD]: init sigcld_enabled_lock
	(begin_want_sigcld, end_want_sigcld): only act if sigcld_enabled==0
	* modules/syscalls/calls.c (BEGIN-SUBPROCESSES, END-SUBPROCESSES): add
	* modules/syscalls/posix.lisp (with-subprocesses): add

2011-03-24  Sam Steingold  <sds@gnu.org>

	Fix bug#588: arg warnings despite :ALLOW-OTHER-KEYS T
	* compiler.lisp (test-argument-syntax): report all wrong keys but
	only if :ALLOW-OTHER-KEYS T is not supplied
	(c-DIRECT-FUNCTION-CALL): duplicate and ignored keys are STYLE warnings

2011-03-24  Sam Steingold  <sds@gnu.org>

	* configure.in (AC_REVISION): explicitly call hg instead of using $Id$
	* m4/general.m4, modules/rawsock/configure.in:
	quote AC_LANG_PROGRAM to avoid an autoconf 2.68 warning
	* m4/address.m4, m4/filecharset.m4:
